<!-- ***************************************** -->
<!-- XSLT transformation for converting from   -->
<!-- U2 XML storage format 3.0 (4) to 3.1 (4)  -->
<!-- ***************************************** -->

<xsl:transform version="1.1"
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:u2="http://www.telelogic.com/tau"
   exclude-result-prefixes='u2'>

<!-- Change file format version number to 3.2 -->
<xsl:template match="u2:u2">
  <xsl:copy>
    <xsl:for-each select="@*">
      <xsl:choose>
        <xsl:when test="local-name()='OMVersion'">
          <xsl:attribute name="OMVersion">3.2</xsl:attribute>
        </xsl:when>
        <xsl:when test="local-name()='StorageVersion'">
          <xsl:attribute name="StorageVersion">4</xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
          <xsl:copy/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>


<!-- Default rule -->
<xsl:template match="*">
  <xsl:copy>
    <xsl:call-template name="copy-all-attributes"/>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template name="copy-all-attributes">
  <xsl:for-each select="@*">
    <xsl:copy/>
  </xsl:for-each>
</xsl:template>

<!-- ObjectNode transformation -->
<xsl:template match="u2:ObjectNode">
  <xsl:copy>
    <xsl:call-template name="copy-all-attributes"/>
    <u2:rType>
      <xsl:for-each select="u2:cInstance/u2:NamedInstance/u2:rInstanceOf">
        <xsl:call-template name="copy-all-attributes"/>
        <xsl:apply-templates/>
      </xsl:for-each>
    </u2:rType>
  </xsl:copy>
</xsl:template>

<!-- TargetKind -> Target transformation -->
<xsl:template match="u2:DataType">
  <xsl:copy>
    <xsl:if test="attribute::Guid = 'bbZihIuDF0ILDzvh0L05vl0E' and attribute::Name = 'TargetKind'">
      <xsl:attribute name="Name">Target</xsl:attribute>
    </xsl:if>
    <xsl:call-template name="copy-all-attributes"/>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>
<xsl:template match="u2:Attribute">
  <xsl:copy>
    <xsl:if test="attribute::Guid = 'LgeAPIRv9ABLhHohYENL5ftE' and attribute::Name = 'Target Kind'">
      <xsl:attribute name="Name">Target</xsl:attribute>
    </xsl:if>
    <xsl:call-template name="copy-all-attributes"/>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template match="u2:Ident">
  <xsl:copy>
    <xsl:call-template name="copy-all-attributes"/>
    <xsl:if test="(attribute::R = 'uid:bbZihIuDF0ILDzvh0L05vl0E' or child::u2:rDefinition/attribute::R = 'uid:bbZihIuDF0ILDzvh0L05vl0E')
                  and attribute::Name = 'TargetKind'">
      <xsl:attribute name="Name">Target</xsl:attribute>
    </xsl:if>
    <xsl:if test="(attribute::R = 'uid:LgeAPIRv9ABLhHohYENL5ftE' or child::u2:rDefinition/attribute::R = 'uid:LgeAPIRv9ABLhHohYENL5ftE')
                  and attribute::Name = 'Target Kind'">
      <xsl:attribute name="Name">Target</xsl:attribute>
    </xsl:if>
    <!-- ORef -> Oref transformation -->
    <xsl:if test="(child::u2:rDefinition/attribute::R = 'uid:Q9RYZEuBqLlLBMv79VoZeveV' or attribute::R = 'uid:Q9RYZEuBqLlLBMv79VoZeveV' or
                   child::u2:rDefinition/attribute::R = 'uid:1TrsdVRSq7vLuP4WMEbTByTL' or attribute::R = 'uid:1TrsdVRSq7vLuP4WMEbTByTL')
                  and attribute::Name = 'ORef'">
      <xsl:attribute name="Name">Oref</xsl:attribute>
    </xsl:if>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>


</xsl:transform>
  