#include "t3tri.h"

/**************************************************************************
 *
 * TE -> SA
 *
 * Function to be implemented by the System Adaptor
 *
 */

TriStatus 
triSAReset() 
{ 
  return TRI_OK; 
}

TriStatus 
triExecuteTestcase (const TriTestCaseId *testCaseId,  
                    const TriPortIdList *tsiPortList) 
{ 
  return TRI_OK; 
}

TriStatus 
triEndTestcase () 
{ 
  return TRI_OK; 
}

TriStatus 
triMap  (const TriPortId *compPortId,  
         const TriPortId *tsiPortId) 
{ 
  return TRI_OK; 
}


TriStatus 
triUnmap (const TriPortId *compPortId, 
          const TriPortId *tsiPortId) 
{ 
  return TRI_OK; 

}


TriStatus 
triSend (const TriComponentId *componentId, 
         const TriPortId      *tsiPortId, 
         const TriAddress     *sutAddress, 
         const TriMessage     *sendMessage) 
{
  /* Enqueue message back into port queue */
  triEnqueueMsg(tsiPortId, sutAddress, componentId, sendMessage);

  return TRI_OK;
}

TriStatus 
triSendMC (const TriComponentId *componentId, 
           const TriPortId      *tsiPortId, 
           const TriAddressList *sutAddressList, 
           const TriMessage     *sendMessage) 
{
  return TRI_Error;
}

TriStatus 
triSendBC (const TriComponentId *componentId, 
           const TriPortId      *tsiPortId, 
           const TriMessage     *sendMessage) 
{
  return TRI_Error;
}


TriStatus 
triCall (const TriComponentId   *componentId, 
         const TriPortId        *tsiPortId,  
         const TriAddress       *sutAddress,  
         const TriSignatureId   *signatureId,  
         const TriParameterList *parameterList) 
{
  return TRI_Error;
}

TriStatus 
triCallMC (const TriComponentId   *componentId, 
           const TriPortId        *tsiPortId,  
           const TriAddressList   *sutAddressList,  
           const TriSignatureId   *signatureId,  
           const TriParameterList *parameterList) 
{
  return TRI_Error;
}

TriStatus 
triCallBC (const TriComponentId   *componentId, 
           const TriPortId        *tsiPortId,  
           const TriSignatureId   *signatureId,  
           const TriParameterList *parameterList) 
{
  return TRI_Error;
}


TriStatus 
triReply (const TriComponentId    *componentId, 
          const TriPortId         *tsiPortId,  
          const TriAddress        *sutAddress,  
          const TriSignatureId    *signatureId,  
          const TriParameterList  *parameterList,  
          const TriParameter      *returnValue) 
{ 
  return TRI_Error;
}

TriStatus 
triReplyMC (const TriComponentId    *componentId, 
            const TriPortId         *tsiPortId,  
            const TriAddressList    *sutAddressList,  
            const TriSignatureId    *signatureId,  
            const TriParameterList  *parameterList,  
            const TriParameter      *returnValue) 
{ 
  return TRI_Error;
}

TriStatus 
triReplyBC (const TriComponentId    *componentId, 
            const TriPortId         *tsiPortId,  
            const TriSignatureId    *signatureId,  
            const TriParameterList  *parameterList,  
            const TriParameter      *returnValue) 
{ 
  return TRI_Error;
}


TriStatus
triRaise (const TriComponentId  *componentId,
          const TriPortId       *tsiPortId,
          const TriAddress      *sutAddress,
          const TriSignatureId  *signatureId,
          const TriException    *exception) 
{ 
  return TRI_Error;
}


TriStatus
triRaiseMC (const TriComponentId  *componentId,
            const TriPortId       *tsiPortId,
            const TriAddressList  *sutAddressList,
            const TriSignatureId  *signatureId,
            const TriException    *exception) 
{ 
  return TRI_Error;
}

TriStatus
triRaiseBC (const TriComponentId  *componentId,
            const TriPortId       *tsiPortId,
            const TriSignatureId  *signatureId,
            const TriException    *exception) 
{ 
  return TRI_Error;
}

TriStatus 
triSUTActionInformal (char* description) 
{ 
  return TRI_Error; 
}


TriStatus 
triSUTActionTemplate (const TriActionTemplate* templateValue) 
{ 
  return TRI_Error; 
}

