using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace TestExecutor
{
    public partial class ConnectForm : Form
    {
        private string _hostAddress;

        private const string StorageName = "TestExecutor.hosts";

        public string HostAddress
        {
            get { return _hostAddress; }
            set { _hostAddress = value; }
        }

        public ConnectForm()
        {
            InitializeComponent();
        }

        private void ConnectForm_Load(object sender, EventArgs e)
        {
            XmlDocument doc = new XmlDocument();
            try
            {
                doc.Load(StorageName);
                XmlNodeList nodeList = doc.GetElementsByTagName("host");
                foreach (XmlNode node in nodeList)
                    AddressComboBox.Items.Add(node.InnerText);
            }
            catch
            {
                // probably file was not found, ignore
            }

            if (AddressComboBox.Items.Count > 0)
                AddressComboBox.Text = (string)AddressComboBox.Items[0];
        }

        private void OnConnect(object sender, EventArgs e)
        {
            HostAddress = AddressComboBox.Text;

            // write entries fo combo box to a file 
            XmlDocument doc = new XmlDocument();

            XmlElement root = doc.CreateElement("hosts");
            doc.AppendChild(root);

            // write last entered host as first entry
            XmlElement host = doc.CreateElement("host");
            host.InnerText = HostAddress;
            root.AppendChild(host);

            // write all other elements from combo box
            foreach (string address in AddressComboBox.Items)
                if (address != HostAddress)
                {
                    host = doc.CreateElement("host");
                    host.InnerText = address;
                    root.AppendChild(host);
                }

            // write document
            XmlTextWriter writer = new XmlTextWriter(StorageName, null);
            writer.Formatting = Formatting.Indented;
            doc.WriteContentTo(writer);
            writer.Close();
        }

        private void AddressComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }
}