/*---------------------------------------------------------------------------
 * File Name: t3tri_template.c
 *
 * 2010 IBM Corporation
 * 
 * Description:
 *     This is a template with functions that have to be implemented for
 * TRI adaptation.
 */


#include "t3tri.h"



/**************************************************************************
 *
 * TE -> SA
 *
 * Function to be implemented by the System Adaptor
 *
 */

TriStatus 
triSAReset() 
{ 
  return TRI_OK; 
}

TriStatus 
triExecuteTestcase (const TriTestCaseId *testCaseId,  
                    const TriPortIdList *tsiPortList) 
{
  return TRI_OK; 
}

TriStatus 
triEndTestcase () 
{
  return TRI_OK; 
}

TriStatus 
triMap  (const TriPortId *compPortId,  
         const TriPortId *tsiPortId) 
{ 
  return TRI_Error; 
}


TriStatus 
triUnmap (const TriPortId *compPortId, 
          const TriPortId *tsiPortId) 
{ 
  return TRI_Error; 
}


TriStatus 
triSend (const TriComponentId *componentId, 
         const TriPortId      *tsiPortId, 
         const TriAddress     *sutAddress, 
         const TriMessage     *sendMessage) 
{
  return TRI_Error;
}


TriStatus 
triSendMC (const TriComponentId *componentId,
           const TriPortId      *tsiPortId,
           const TriAddressList *sutAddresses,
           const TriMessage     *sendMessage)
{
  return TRI_Error;
}           


TriStatus
triSendBC (const TriComponentId *componentId,
           const TriPortId      *tsiPortId,
           const TriMessage     *sendMessage)
{
  return TRI_Error;
}           


TriStatus 
triCall (const TriComponentId   *componentId, 
         const TriPortId        *tsiPortId,  
         const TriAddress       *sutAddress,  
         const TriSignatureId   *signatureId,  
         const TriParameterList *parameterList) 
{
  return TRI_Error; 
}


TriStatus
triCallMC (const TriComponentId   *componentId,
           const TriPortId        *tsiPortId, 
           const TriAddressList   *sutAddresses, 
           const TriSignatureId   *signatureId, 
           const TriParameterList *parameterList)
{
  return TRI_Error; 
}           


TriStatus
triCallBC (const TriComponentId   *componentId,
           const TriPortId        *tsiPortId,
           const TriSignatureId   *signatureId,
           const TriParameterList *parameterList)
{
  return TRI_Error; 
}           


TriStatus 
triReply (const TriComponentId    *componentId, 
          const TriPortId         *tsiPortId,  
          const TriAddress        *sutAddress,  
          const TriSignatureId    *signatureId,  
          const TriParameterList  *parameterList,  
          const TriParameter      *returnValue) 
{ 
  return TRI_Error; 
}


TriStatus 
triReplyMC (const TriComponentId   *componentId,
            const TriPortId        *tsiPortId,
            const TriAddressList   *sutAddresses,
            const TriSignatureId   *signatureId,
            const TriParameterList *parameterList,
            const TriParameter     *returnValue)
{
  return TRI_Error; 
}
            

TriStatus
triReplyBC (const TriComponentId   *componentId,
            const TriPortId        *tsiPortId,
            const TriSignatureId   *signatureId,
            const TriParameterList *parameterList,
            const TriParameter     *returnValue)
{
  return TRI_Error; 
}
            

TriStatus
triRaise (const TriComponentId  *componentId,
          const TriPortId       *tsiPortId,
          const TriAddress      *sutAddress,
          const TriSignatureId  *signatureId,
          const TriException    *exception) 
{ 
  return TRI_Error; 
}


TriStatus
triRaiseMC (const TriComponentId *componentId,
            const TriPortId      *tsiPortId,
            const TriAddressList *sutAddresses,
            const TriSignatureId *signatureId,
            const TriException   *exception)
{
  return TRI_Error; 
}
            

TriStatus
triRaiseBC (const TriComponentId *componentId,
            const TriPortId      *tsiPortId,
            const TriSignatureId *signatureId,
            const TriException   *exception)
{
  return TRI_Error; 
}            

            
TriStatus 
triSUTActionInformal (char* description) 
{ 
  return TRI_Error; 
}


TriStatus 
triSUTActionTemplate (const TriActionTemplate* templateValue) 
{ 
  return TRI_Error; 
}


/**************************************************************************
 *
 * TE -> PA
 *
 * Function to be implemented by the Platform Adaptor
 *
 */

TriStatus
triPAReset() 
{ 
  return TRI_OK; 
}


TriStatus
triStartTimer (const TriTimerId *timerId,
               TriTimerDuration  timerDuration) 
{ 
  return TRI_Error; 
}


TriStatus
triStopTimer (const TriTimerId *timerId) 
{ 
  return TRI_Error; 
}


TriStatus 
triReadTimer (const TriTimerId *timerId,
              TriTimerDuration *elapsedTime) 
{ 
  return TRI_Error; 
}


TriStatus
triTimerRunning (const TriTimerId *timerId,
                 unsigned char    *running) 
{ 
  return TRI_Error; 
}


TriStatus 
triExternalFunction (const TriFunctionId *functionId,		     
                     TriParameterList    *parameterList,
                     TriParameter        *returnValue) 
{ 
  return TRI_Error; 
}

/* End of File */

