/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/**
*******************************************************************************

File: asn2t3rts.h
Created on 18.07.2001 by Antti Kuosmanen
Description:

Asn2T3 Run Time Declarations. These are included by the generated code from
the Asn2T3 tool.

Copyright (c) Nokia Research Center 2001 -

Last change: $Id: asn2t3rts.h,v 2.10 2006/05/04 15:27:19 x-rupaya Exp $
*******************************************************************************
*/

#ifndef ASN2T3RTS_H
#define ASN2T3RTS_H

/* Configuration *************************************************************/

#define ASN2T3_RTS_USE_FRAMES   1

#define ASN2T3_RTS_BUFFER_LENGTH 1024

/* Select proprietary implementations for 64 bit signed integers from CASN. */
#ifndef ASN_HAS_INT64
#define ASN_HAS_INT64 1
#endif

#ifdef _WIN32
#ifndef I64_IS_INT64
#define I64_IS_INT64 1
#endif
#else
#ifndef I64_IS_LONG_LONG
#define I64_IS_LONG_LONG 1
#endif
#endif

/**
*******************************************************************************
*/

#include "asnutils.ext"
#include "asncodec.ext"
#include "asnper.ext"

#include "t3rts.h"
/* bool undefined because of name clash with BET & asn2c generated code and rts */
#ifdef bool
#undef bool
#endif

#if ASN2T3_RTS_USE_FRAMES == 1
#include "frame.vop"
#endif

/* T3 RTS additional implementation */

/* ASN.1 Types */
extern const t3rt_type_t t3asn_asn_1_null_type;
#define t3asn_STATIC_asn_1_null_type \
(t3rt_type_t)&t3asn_asn_1_null_type_struct

extern t3rt_type_struct_t t3asn_asn_1_null_type_struct; /* NULL type */

int
t3asn_t3rt_value_is_external_value (t3rt_value_t value, 
				    t3rt_context_t context);

int
t3asn_t3rt_value_is_special_value (t3rt_value_t value, 
					t3rt_context_t context);

/* 
 * Sets type of value
 */

void
t3asn_t3rt_value_set_type (t3rt_value_t value, 
			   const t3rt_type_t type, 
			   t3rt_context_t context);

/* Following are Asn2T3 needed RTS declarations */

void 
asn2t3_delete_ext_function (void * external_value,
			    t3rt_context_t ctx);

int 
asn2t3_check_int (sint32 value, 
		  sint32 low,
		  sint32 high);

int 
asn2t3_check_real (double value, 
		   double low,
		   double high);

int
asn2t3_check_string (sint32 value, 
		     sint32 low,
		     sint32 high);


/* codecs utilities */

#if ASN2T3_RTS_USE_FRAMES == 1

typedef void (*asn2t3_ber_decoder)(ASNCODG *, void *);
typedef void (*asn2t3_per_decoder)(ASNPERG *, void *);

void asn2t3_encode_set_frame(ASNCODG *codg, FRAME_PTR *);
void asn2t3_encode_set_frame_per(ASNPERG *codg, FRAME_PTR *);
void asn2t3_encode_put_bstring(FRAME_PTR *encodingBuffer, 
			       t3rt_codecs_result_t *codec_result,
			       t3rt_binary_string_t encoded_data,
			       t3rt_context_t ctx);
int asn2t3_decode_set_buf_and_decode(ASNCODG *codg, 
				     FRAME_PTR *decodingBuffer, 
				     ERR_RET *errorHandlerBuf, 
				     t3rt_codecs_result_t *codec_result,
				     t3rt_binary_string_iter_t * encoded_data,
				     asn2t3_ber_decoder decoding_function,
				     void *home,
				     t3rt_context_t ctx);

int asn2t3_decode_set_buf_and_decode_per(ASNPERG *codg, 
					 FRAME_PTR *decodingBuffer, 
					 ERR_RET *errorHandlerBuf, 
					 t3rt_codecs_result_t *codec_result,
					 t3rt_binary_string_iter_t * encoded_data,
					 asn2t3_per_decoder decoding_function,
					 void *home,
					 t3rt_context_t ctx);
t3rt_value_t asn2t3_decode_set_value(FRAME_PTR *decodingBuffer, 
				     t3rt_type_t type,
				     void *home,
				     t3rt_convert_ext2rts_function_t trans_func,
				     t3rt_delete_ext_function_t dest_func,
				     t3rt_alloc_strategy_t strategy,
				     t3rt_context_t ctx);
#endif

/* Run Time encoding directive */

typedef enum t3asnRtsCodecSelector {
  T3ASN_RTS_CODEC_NONE,
  T3ASN_RTS_CODEC_BER_DEFINITE_LENGTH,
  T3ASN_RTS_CODEC_BER_INDEFINITE_LENGTH,
  T3ASN_RTS_CODEC_PER_BASIC_UNALIGNED,
  T3ASN_RTS_CODEC_PER_BASIC_ALIGNED,
  T3ASN_RTS_CODEC_OWN
} T3asnRtsCodecSelector;

T3asnRtsCodecSelector t3asn_get_module_encoding_directive(const char *module_name,
							  t3rt_context_t ctx);

/* string functions for t3strings -> asn2c strings, implemented from tst */

extern sint32 asn2t3g_temp;

#if ASN_STA_STRI | ASN_DYN_STRI | ASN_SEG_STRI | ASN_HAS_TIME
extern void t32asn_anystrival (BYTE_TYPE *, 
			       t3rt_value_t, 
			       int, 
			       t3rt_context_t context);
#endif /* ASN_STA_STRI | ASN_DYN_STRI | ASN_SEG_STRI | ASN_HAS_TIME */

#define t32asn_AnyStri(home, value, k) \
  do { t32asn_anystrival ( (BYTE_TYPE *)((home)->st), \
                     value, k, context); \
       (home)->n = (uint32)asn2t3g_temp; \
     } while (0)
#define t32asn_AnyStri16(home, value, k) \
  do { t32asn_anystrival ( (BYTE_TYPE *)((home)->st), \
                     value, k, context); \
       (home)->n = (uint16)asn2t3g_temp; \
     } while (0)
#define t32asn_AnyStri8(home, value, k) \
  do { t32asn_anystrival ( (BYTE_TYPE *)((home)->st), \
                     value, k, context); \
       (home)->n = (uint8)asn2t3g_temp; \
     } while (0)
#define t32asn_AnyStri0(home, value, k) \
  t32asn_anystrival (  \
    (BYTE_TYPE *)((home)->st), value, k, context)

#define t32asn_BitString(a,b)          t32asn_AnyStri(a,b,TYP_BITSTR)
#define t32asn_OctetString(a,b)        t32asn_AnyStri(a,b,TYP_OCTSTR)
#define t32asn_T61String(a,b)          t32asn_AnyStri(a,b,TYP_TELSTR)
#define t32asn_VideotexString(a,b)     t32asn_AnyStri(a,b,TYP_VIDSTR)
#define t32asn_GraphicString(a,b)      t32asn_AnyStri(a,b,TYP_GRASTR)
#define t32asn_GeneralString(a,b)      t32asn_AnyStri(a,b,TYP_GENSTR)
#define t32asn_NumericString(a,b)      t32asn_AnyStri(a,b,TYP_NUMSTR)
#define t32asn_PrintableString(a,b)    t32asn_AnyStri(a,b,TYP_PRISTR)
#define t32asn_IA5String(a,b)          t32asn_AnyStri(a,b,TYP_IA5STR)
#define t32asn_VisibleString(a,b)      t32asn_AnyStri(a,b,TYP_VISSTR)
#define t32asn_ObjectDescriptor(a,b)   t32asn_AnyStri(a,b,TYP_OBJDESCR)

#define t32asn_BitString16(a,b)        t32asn_AnyStri16(a,b,TYP_BITSTR)
#define t32asn_OctetString16(a,b)      t32asn_AnyStri16(a,b,TYP_OCTSTR)
#define t32asn_T61String16(a,b)        t32asn_AnyStri16(a,b,TYP_TELSTR)
#define t32asn_VideotexString16(a,b)   t32asn_AnyStri16(a,b,TYP_VIDSTR)
#define t32asn_GraphicString16(a,b)    t32asn_AnyStri16(a,b,TYP_GRASTR)
#define t32asn_GeneralString16(a,b)    t32asn_AnyStri16(a,b,TYP_GENSTR)
#define t32asn_NumericString16(a,b)    t32asn_AnyStri16(a,b,TYP_NUMSTR)
#define t32asn_PrintableString16(a,b)  t32asn_AnyStri16(a,b,TYP_PRISTR)
#define t32asn_IA5String16(a,b)        t32asn_AnyStri16(a,b,TYP_IA5STR)
#define t32asn_VisibleString16(a,b)    t32asn_AnyStri16(a,b,TYP_VISSTR)
#define t32asn_ObjectDescriptor16(a,b) t32asn_AnyStri16(a,b,TYP_OBJDESCR)

#define t32asn_BitString8(a,b)         t32asn_AnyStri8(a,b,TYP_BITSTR)
#define t32asn_OctetString8(a,b)       t32asn_AnyStri8(a,b,TYP_OCTSTR)
#define t32asn_T61String8(a,b)         t32asn_AnyStri8(a,b,TYP_TELSTR)
#define t32asn_VideotexString8(a,b)    t32asn_AnyStri8(a,b,TYP_VIDSTR)
#define t32asn_GraphicString8(a,b)     t32asn_AnyStri8(a,b,TYP_GRASTR)
#define t32asn_GeneralString8(a,b)     t32asn_AnyStri8(a,b,TYP_GENSTR)
#define t32asn_NumericString8(a,b)     t32asn_AnyStri8(a,b,TYP_NUMSTR)
#define t32asn_PrintableString8(a,b)   t32asn_AnyStri8(a,b,TYP_PRISTR)
#define t32asn_IA5String8(a,b)         t32asn_AnyStri8(a,b,TYP_IA5STR)
#define t32asn_VisibleString8(a,b)     t32asn_AnyStri8(a,b,TYP_VISSTR)
#define t32asn_ObjectDescriptor8(a,b)  t32asn_AnyStri8(a,b,TYP_OBJDESCR)

#define t32asn_BitString0(a,b)         t32asn_AnyStri0(a,b,TYP_BITSTR)
#define t32asn_OctetString0(a,b)       t32asn_AnyStri0(a,b,TYP_OCTSTR)
#define t32asn_T61String0(a,b)         t32asn_AnyStri0(a,b,TYP_TELSTR)
#define t32asn_VideotexString0(a,b)    t32asn_AnyStri0(a,b,TYP_VIDSTR)
#define t32asn_GraphicString0(a,b)     t32asn_AnyStri0(a,b,TYP_GRASTR)
#define t32asn_GeneralString0(a,b)     t32asn_AnyStri0(a,b,TYP_GENSTR)
#define t32asn_NumericString0(a,b)     t32asn_AnyStri0(a,b,TYP_NUMSTR)
#define t32asn_PrintableString0(a,b)   t32asn_AnyStri0(a,b,TYP_PRISTR)
#define t32asn_IA5String0(a,b)         t32asn_AnyStri0(a,b,TYP_IA5STR)
#define t32asn_VisibleString0(a,b)     t32asn_AnyStri0(a,b,TYP_VISSTR)
#define t32asn_ObjectDescriptor0(a,b)  t32asn_AnyStri0(a,b,TYP_OBJDESCR)

#if ASN_DYN_STRI
extern void t32asn_dynanystrival ( BYTE_TYPE **, t3rt_value_t, int, t3rt_context_t);
#endif /* ASN_DYN_STRI */

#define t32asn_DynAnyStri(home, value, k) \
  do { t32asn_dynanystrival ( (BYTE_TYPE **)&((home)->st),\
                        value, k, context); \
       (home)->n = (uint32)asn2t3g_temp; \
     } while (0)
#define t32asn_DynAnyStri16(home, value, k) \
  do { t32asn_dynanystrival ( (BYTE_TYPE **)&((home)->st),\
                        value, k, context); \
       (home)->n = (uint16)asn2t3g_temp; \
     } while (0)
#define t32asn_DynAnyStri8(home, value, k) \
  do { t32asn_dynanystrival ( (BYTE_TYPE **)&((home)->st),\
                        value, k, context); \
       (home)->n = (uint8)asn2t3g_temp; \
     } while (0)
#define t32asn_DynAnyStri0(home, value, k) \
  t32asn_dynanystrival ( (BYTE_TYPE **)&((home)->st), \
                   value, k, context); \

#define t32asn_DynBitString(a,b)          t32asn_DynAnyStri(a,b,TYP_BITSTR)
#define t32asn_DynOctetString(a,b)        t32asn_DynAnyStri(a,b,TYP_OCTSTR)
#define t32asn_DynT61String(a,b)          t32asn_DynAnyStri(a,b,TYP_TELSTR)
#define t32asn_DynVideotexString(a,b)     t32asn_DynAnyStri(a,b,TYP_VIDSTR)
#define t32asn_DynGraphicString(a,b)      t32asn_DynAnyStri(a,b,TYP_GRASTR)
#define t32asn_DynGeneralString(a,b)      t32asn_DynAnyStri(a,b,TYP_GENSTR)
#define t32asn_DynNumericString(a,b)      t32asn_DynAnyStri(a,b,TYP_NUMSTR)
#define t32asn_DynPrintableString(a,b)    t32asn_DynAnyStri(a,b,TYP_PRISTR)
#define t32asn_DynIA5String(a,b)          t32asn_DynAnyStri(a,b,TYP_IA5STR)
#define t32asn_DynVisibleString(a,b)      t32asn_DynAnyStri(a,b,TYP_VISSTR)
#define t32asn_DynObjectDescriptor(a,b)   t32asn_DynAnyStri(a,b,TYP_OBJDESCR)

#define t32asn_DynBitString16(a,b)        t32asn_DynAnyStri16(a,b,TYP_BITSTR)
#define t32asn_DynOctetString16(a,b)      t32asn_DynAnyStri16(a,b,TYP_OCTSTR)
#define t32asn_DynT61String16(a,b)        t32asn_DynAnyStri16(a,b,TYP_TELSTR)
#define t32asn_DynVideotexString16(a,b)   t32asn_DynAnyStri16(a,b,TYP_VIDSTR)
#define t32asn_DynGraphicString16(a,b)    t32asn_DynAnyStri16(a,b,TYP_GRASTR)
#define t32asn_DynGeneralString16(a,b)    t32asn_DynAnyStri16(a,b,TYP_GENSTR)
#define t32asn_DynNumericString16(a,b)    t32asn_DynAnyStri16(a,b,TYP_NUMSTR)
#define t32asn_DynPrintableString16(a,b)  t32asn_DynAnyStri16(a,b,TYP_PRISTR)
#define t32asn_DynIA5String16(a,b)        t32asn_DynAnyStri16(a,b,TYP_IA5STR)
#define t32asn_DynVisibleString16(a,b)    t32asn_DynAnyStri16(a,b,TYP_VISSTR)
#define t32asn_DynObjectDescriptor16(a,b) t32asn_DynAnyStri16(a,b,TYP_OBJDESCR)

#define t32asn_DynBitString8(a,b)         t32asn_DynAnyStri8(a,b,TYP_BITSTR)
#define t32asn_DynOctetString8(a,b)       t32asn_DynAnyStri8(a,b,TYP_OCTSTR)
#define t32asn_DynT61String8(a,b)         t32asn_DynAnyStri8(a,b,TYP_TELSTR)
#define t32asn_DynVideotexString8(a,b)    t32asn_DynAnyStri8(a,b,TYP_VIDSTR)
#define t32asn_DynGraphicString8(a,b)     t32asn_DynAnyStri8(a,b,TYP_GRASTR)
#define t32asn_DynGeneralString8(a,b)     t32asn_DynAnyStri8(a,b,TYP_GENSTR)
#define t32asn_DynNumericString8(a,b)     t32asn_DynAnyStri8(a,b,TYP_NUMSTR)
#define t32asn_DynPrintableString8(a,b)   t32asn_DynAnyStri8(a,b,TYP_PRISTR)
#define t32asn_DynIA5String8(a,b)         t32asn_DynAnyStri8(a,b,TYP_IA5STR)
#define t32asn_DynVisibleString8(a,b)     t32asn_DynAnyStri8(a,b,TYP_VISSTR)
#define t32asn_DynObjectDescriptor8(a,b)  t32asn_DynAnyStri8(a,b,TYP_OBJDESCR)

#define t32asn_DynBitString0(a,b)         t32asn_DynAnyStri0(a,b,TYP_BITSTR)
#define t32asn_DynOctetString0(a,b)       t32asn_DynAnyStri0(a,b,TYP_OCTSTR)
#define t32asn_DynT61String0(a,b)         t32asn_DynAnyStri0(a,b,TYP_TELSTR)
#define t32asn_DynVideotexString0(a,b)    t32asn_DynAnyStri0(a,b,TYP_VIDSTR)
#define t32asn_DynGraphicString0(a,b)     t32asn_DynAnyStri0(a,b,TYP_GRASTR)
#define t32asn_DynGeneralString0(a,b)     t32asn_DynAnyStri0(a,b,TYP_GENSTR)
#define t32asn_DynNumericString0(a,b)     t32asn_DynAnyStri0(a,b,TYP_NUMSTR)
#define t32asn_DynPrintableString0(a,b)   t32asn_DynAnyStri0(a,b,TYP_PRISTR)
#define t32asn_DynIA5String0(a,b)         t32asn_DynAnyStri0(a,b,TYP_IA5STR)
#define t32asn_DynVisibleString0(a,b)     t32asn_DynAnyStri0(a,b,TYP_VISSTR)
#define t32asn_DynObjectDescriptor0(a,b)  t32asn_DynAnyStri0(a,b,TYP_OBJDESCR)

#if ASN_SEG_STRI
extern void t32asn_seganystrival (LIST *, t3rt_value_t, int, t3rt_context_t context);
#endif /* ASN_SEG_STRI */

#define t32asn_SegAnyStri(l,value,k) \
  t32asn_seganystrival ( l,value,k, context)

#define t32asn_SegBitString(a,b)        t32asn_SegAnyStri(a,b,TYP_BITSTR)
#define t32asn_SegOctetString(a,b)      t32asn_SegAnyStri(a,b,TYP_OCTSTR)
#define t32asn_SegT61String(a,b)        t32asn_SegAnyStri(a,b,TYP_TELSTR)
#define t32asn_SegVideotexString(a,b)   t32asn_SegAnyStri(a,b,TYP_VIDSTR)
#define t32asn_SegGraphicString(a,b)    t32asn_SegAnyStri(a,b,TYP_GRASTR)
#define t32asn_SegGeneralString(a,b)    t32asn_SegAnyStri(a,b,TYP_GENSTR)
#define t32asn_SegNumericString(a,b)    t32asn_SegAnyStri(a,b,TYP_NUMSTR)
#define t32asn_SegPrintableString(a,b)  t32asn_SegAnyStri(a,b,TYP_PRISTR)
#define t32asn_SegIA5String(a,b)        t32asn_SegAnyStri(a,b,TYP_IA5STR)
#define t32asn_SegVisibleString(a,b)    t32asn_SegAnyStri(a,b,TYP_VISSTR)
#define t32asn_SegObjectDescriptor(a,b) t32asn_SegAnyStri(a,b,TYP_OBJDESCR)



  /* 
   * BIT STRING, OCTET STRING, character strings, asn2c rts to ttcn3 rts
   */

#if ASN_STA_STRI | ASN_DYN_STRI | ASN_SEG_STRI

extern void asn2t3_anystrival (sint32, 
			       const BYTE_TYPE *, 
			       t3rt_value_t,
			       int,
			       t3rt_alloc_strategy_t,
			       t3rt_context_t);

#define asn2t3_AnyStri0(len,home,value,k)     \
  asn2t3_anystrival ( (sint32)(len), (BYTE_TYPE*)(home)->st, value, k, strategy, context)

#define asn2t3_BitString0(len, home, value)        asn2t3_AnyStri0(len, home, value, TYP_BITSTR)
#define asn2t3_OctetString0(len, home, value)      asn2t3_AnyStri0(len, home, value, TYP_OCTSTR)
#define asn2t3_T61String0(len, home, value)        asn2t3_AnyStri0(len, home, value, TYP_TELSTR)
#define asn2t3_VideotexString0(len, home, value)   asn2t3_AnyStri0(len, home, value, TYP_VIDSTR)
#define asn2t3_GraphicString0(len, home, value)    asn2t3_AnyStri0(len, home, value, TYP_GRASTR)
#define asn2t3_GeneralString0(len, home, value)    asn2t3_AnyStri0(len, home, value, TYP_GENSTR)
#define asn2t3_NumericString0(len, home, value)    asn2t3_AnyStri0(len, home, value, TYP_NUMSTR)
#define asn2t3_PrintableString0(len, home, value)  asn2t3_AnyStri0(len, home, value, TYP_PRISTR)
#define asn2t3_IA5String0(len, home, value)        asn2t3_AnyStri0(len, home, value, TYP_IA5STR)
#define asn2t3_VisibleString0(len, home, value)    asn2t3_AnyStri0(len, home, value, TYP_VISSTR)
#define asn2t3_ObjectDescriptor0(len, home, value) asn2t3_AnyStri0(len, home, value, TYP_OBJDESCR)

#define asn2t3_AnyStri(home, value,k)     \
  asn2t3_anystrival ((sint32)((home)->n), (BYTE_TYPE*)(home)->st, value, k, strategy, context)

#define asn2t3_BitString(home, value)        asn2t3_AnyStri(home, value, TYP_BITSTR)
#define asn2t3_OctetString(home, value)      asn2t3_AnyStri(home, value, TYP_OCTSTR)
#define asn2t3_T61String(home, value)        asn2t3_AnyStri(home, value, TYP_TELSTR)
#define asn2t3_VideotexString(home, value)   asn2t3_AnyStri(home, value, TYP_VIDSTR)
#define asn2t3_GraphicString(home, value)    asn2t3_AnyStri(home, value, TYP_GRASTR)
#define asn2t3_GeneralString(home, value)    asn2t3_AnyStri(home, value, TYP_GENSTR)
#define asn2t3_NumericString(home, value)    asn2t3_AnyStri(home, value, TYP_NUMSTR)
#define asn2t3_PrintableString(home, value)  asn2t3_AnyStri(home, value, TYP_PRISTR)
#define asn2t3_IA5String(home, value)        asn2t3_AnyStri(home, value, TYP_IA5STR)
#define asn2t3_VisibleString(home, value)    asn2t3_AnyStri(home, value, TYP_VISSTR)
#define asn2t3_ObjectDescriptor(home, value) asn2t3_AnyStri(home, value, TYP_OBJDESCR)
#endif /* ASN_STA_STRI | ASN_DYN_STRI | ASN_SEG_STRI */

#if ASN_SEG_STRI
extern void asn2t3_seganystrival (const LIST *, t3rt_value_t, int, t3rt_alloc_strategy_t, t3rt_context_t);
#endif /* ASN_SEG_STRI */

#define asn2t3_SegAnyStri(l,value,k) \
  asn2t3_seganystrival (l,value,k,strategy,context)

#define asn2t3_SegBitString(a,b)        asn2t3_SegAnyStri(a,b,TYP_BITSTR)
#define asn2t3_SegOctetString(a,b)      asn2t3_SegAnyStri(a,b,TYP_OCTSTR)
#define asn2t3_SegT61String(a,b)        asn2t3_SegAnyStri(a,b,TYP_TELSTR)
#define asn2t3_SegVideotexString(a,b)   asn2t3_SegAnyStri(a,b,TYP_VIDSTR)
#define asn2t3_SegGraphicString(a,b)    asn2t3_SegAnyStri(a,b,TYP_GRASTR)
#define asn2t3_SegGeneralString(a,b)    asn2t3_SegAnyStri(a,b,TYP_GENSTR)
#define asn2t3_SegNumericString(a,b)    asn2t3_SegAnyStri(a,b,TYP_NUMSTR)
#define asn2t3_SegPrintableString(a,b)  asn2t3_SegAnyStri(a,b,TYP_PRISTR)
#define asn2t3_SegIA5String(a,b)        asn2t3_SegAnyStri(a,b,TYP_IA5STR)
#define asn2t3_SegVisibleString(a,b)    asn2t3_SegAnyStri(a,b,TYP_VISSTR)
#define asn2t3_SegObjectDescriptor(a,b) asn2t3_SegAnyStri(a,b,TYP_OBJDESCR)

#if ASN_HAS_OBJID

extern void t32asn_objidval (OBJECTIDENTIFIER *,
		      t3rt_value_t,
		      t3rt_context_t);

extern void asn2t3_objidval (OBJECTIDENTIFIER *,
		      t3rt_value_t,
		      t3rt_context_t);

#endif /* ASN_HAS_OBJID */


  /* 
   * GeneralizedTime and UTCTime 
   */

#if ASN_HAS_COMMONTIME

extern void t32asn_commontimeval (COMMONTIME *, int, t3rt_value_t, t3rt_context_t);

#define t32asn_Commontime(a,k,v)      t32asn_commontimeval (a,k,v,context)
#define t32asn_UTCTimeCT(a,v)         t32asn_Commontime (a,TYP_UTCTIME,v)
#define t32asn_GeneralizedTimeCT(a,v) t32asn_Commontime (a,TYP_GENTIME,v)

#endif /* ASN_HAS_COMMONTIME */

#if ASN_HAS_DATETIMEZ

extern void t32asn_datetimezval (DATETIMEZ *, int, t3rt_value_t, t3rt_context_t);

#define t32asn_Datetimez(a,k,v)         t32asn_datetimezval (a,k,v,context)
#define t32asn_UTCTimeDT(a,v)         t32asn_Datetimez (a,TYP_UTCTIME,v)
#define t32asn_GeneralizedTimeDT(a,v) t32asn_Datetimez (a,TYP_GENTIME,v)

#endif /* ASN_HAS_DATETIMEZ */

#if ASN_HAS_COMMONTIME

extern void asn2t3_commontimeval (const COMMONTIME *,
				  int,
				  t3rt_value_t,
				  t3rt_alloc_strategy_t,
				  t3rt_context_t context);

#define asn2t3_Commontime(a,k,v)      asn2t3_commontimeval(a,k,v,strategy,context)
#define asn2t3_UTCTimeCT(a,v)         asn2t3_Commontime(a,TYP_UTCTIME,v)
#define asn2t3_GeneralizedTimeCT(a,v) asn2t3_Commontime(a,TYP_GENTIME,v)

#endif /* ASN_HAS_COMMONTIME */

#if ASN_HAS_DATETIMEZ

extern void asn2t3_datetimezval (const DATETIMEZ *,
				 int,
				 t3rt_value_t,
				 t3rt_alloc_strategy_t,
				 t3rt_context_t context);

#define asn2t3_Datetimez(a,k,v)       asn2t3_datetimezval (a,k,v,strategy,context)
#define asn2t3_UTCTimeDT(a,v)         asn2t3_Datetimez (a,TYP_UTCTIME,v)
#define asn2t3_GeneralizedTimeDT(a,v) asn2t3_Datetimez (a,TYP_GENTIME,v)

#endif /* ASN_HAS_DATETIMEZ */

#if ASN_HAS_FRAME
extern t3rt_codecs_result_t t3asn_frame (ASNG_F(ASNUTIG *asnutig)
					 FRAME_PTR *frame,
					 t3rt_value_t any_value,
					 t3rt_context_t context);

extern t3rt_codecs_result_t asnt3_frame (FRAME_PTR frame,
					 t3rt_type_t any_type,
					 t3rt_value_t any_value,
					 t3rt_alloc_strategy_t strategy,
					 t3rt_context_t context);

#endif

#endif /* ASN2T3RTS_H */
