/*
//================================================================
//
// $Id: asntool.typ,v 2.1 2002/07/12 08:13:44 xmso Exp $
//
// NAME
//      asntool.typ
//
// DESCRIPTION
//      Type and constant definitions for the ASN2C RTS 
//      module ASNTOOL. 
//
// AUTHOR
//      Markku Turunen
//
// Copyright (c) Nokia Research Center
//
// $Log: asntool.typ,v $
// Revision 2.1  2002/07/12 08:13:44  xmso
// ASN2C 1.07.
//
// Revision 1.1.1.1  2001/10/15 11:53:07  xsto
// CASN Tool
//
// Revision 1.5  2000/04/03 09:53:51  rinnerah
// layout changes
//
//================================================================
*/

#ifndef ASNTOOL_TYP
#define ASNTOOL_TYP

/*======================================================*/

#ifndef ASNTYP_TYP
#include "asntyp.typ"
#endif

/*======================================================*/

#if ASN_RCS_ID
static char asntool_typ_rcsid [] =
  "$Id: asntool.typ,v 2.1 2002/07/12 08:13:44 xmso Exp $";
#endif

/*============================================================*/
/*
 *  Usage: see manual pages for the function asnTool in asntool.ext.
 */

typedef struct entryTabRec 
        {
        ENTRYDESCR *edesc;
        int         nrEntries;
        } EntryTab;

#define DEF_ENTRYTAB(etab) \
              { (etab), sizeof (etab) / sizeof (ENTRYDESCR) }

#define END_ENTRYTAB \
              { NULL, 0 }

/*======================================================*/

typedef void (*ASNTOOLFUNC) (ENTRYDESCR *edesc, 
                             FRAME_PTR  *frame, 
                             ASNHOME   **asnHome);

#define AT_ENTRY_NAME_ARG   0
#define AT_BINARY_INPUT     1
#define AT_BINARY_OUTPUT    2
#define AT_INTERACTIVE_ONLY 3

typedef struct asnToolCmdRec 
        {
        const char  *cmd;           /* Command name                       */
        int          flags;         /* AT_ flags for the command          */
        const char  *funcHelpText;  /* One line help text for the command */
        ASNTOOLFUNC  func;          /* The function that implements the   */
                                    /* command.                           */
        } AsnToolCmd;

#define DEF_ASNTOOLCMD(c,i,h,f) \
                { (c), (i), (h), (ASNTOOLFUNC)(f) }

#define END_ASNTOOLCMD \
                { NULL, FALSE, NULL, (ASNTOOLFUNC)NULL }

/*======================================================*/

#endif /* ASNTOOL_TYP */

