/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3pl_communication.h
 */


#ifndef __t3pl_communication_h
#define __t3pl_communication_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts.h"



typedef enum t3rt__snapshot_return_internal_t {
  t3rt_snapshot_return_timeout,
  t3rt_snapshot_return_data_received,
  t3rt_snapshot_return_timeout_and_data_received
} t3rt_snapshot_return_t;




/*
 * Pre-initializes the communication module
 */

void
t3pl_communication_pre_initialize(int argc, char * argv [], t3rt_context_t ctx);


/*
 * Initializes the communication module
 */

void
t3pl_communication_initialize(t3rt_context_t ctx);


/*
 * Finalizes the communication module
 */

void
t3pl_communication_finalize(t3rt_context_t ctx);



/*
 * Create and initialize a port. Includes any platform dependent
 * communications mechanism, address and queue initializations.
 */

void
t3pl_port_create(t3rt_value_t port_value,
                 t3rt_binary_string_t address,
                 const char* name,
                 long index,
                 t3rt_context_t ctx);

void
t3pl_port_create_control_port_for_cpc(t3rt_binary_string_t address,
                                      t3rt_context_t ctx);

/*
 * Start a port
 */

void
t3pl_port_start(t3rt_binary_string_t port_address,
                t3rt_context_t ctx);

/*
 * Stop a port
 */

void
t3pl_port_stop(t3rt_binary_string_t port_address,
               t3rt_context_t ctx);

/*
 * Halt a port
 */

void
t3pl_port_halt(t3rt_binary_string_t port_address,
               t3rt_context_t ctx);
               
/*
 * Destroy a port
 */

void
t3pl_port_destroy(t3rt_binary_string_t port_address,
                  t3rt_context_t ctx);


/*
 * Discard any data contents of the port
 */

void
t3pl_port_clear(t3rt_binary_string_t port_address,
                t3rt_context_t ctx);


/*
 * Map a local port to a system port
 */

void
t3pl_port_map(t3rt_binary_string_t port_address, 
              const char *tsi_port_name, /* Port or port array name */
              long index,       /* Index in port array or -1 */
              t3rt_context_t ctx);

/*
 * Unmap the specified system port
 */

void
t3pl_port_unmap(t3rt_binary_string_t port_address,
                t3rt_context_t ctx);


/*
 * Send to the specified port in another component
 */

void
t3pl_port_component_send(t3rt_binary_string_t dest_component,
                         t3rt_binary_string_t port_address,
                         t3rt_binary_string_t data,
                         t3rt_context_t ctx);

/*
 * Send to the specified system port
 */

void
t3pl_port_sut_send(t3rt_binary_string_t port_address,
                   t3rt_binary_string_t sut_address,
                   t3rt_binary_string_t data,
                   t3rt_binary_string_t sender_port_address,
                   t3rt_context_t ctx);

void
t3pl_port_sut_send_mc(t3rt_binary_string_t port_address,
                      t3rt_binary_string_t sut_address_list[], /* NULL-terminated list */
                      t3rt_binary_string_t data,
                      t3rt_binary_string_t sender_port_address,
                      t3rt_context_t ctx);
                   
void
t3pl_port_sut_send_bc(t3rt_binary_string_t port_address,
                      t3rt_binary_string_t data,
                      t3rt_binary_string_t sender_port_address,
                      t3rt_context_t ctx);
                   

/*
 * Procedure based communication interface
 */

void *
t3pl_port_sut_call(t3rt_binary_string_t port_to_call,
                   t3rt_binary_string_t sut_address,
                   t3rt_binary_string_t caller_port,
                   t3rt_binary_string_t address,
                   t3rt_type_t          signature_type,
                   t3rt_binary_string_t parameters[],
                   t3rt_context_t ctx);

void *
t3pl_port_sut_call_mc(t3rt_binary_string_t port_to_call,
                      t3rt_binary_string_t sut_address_list[], /* NULL-terminated list */
                      t3rt_binary_string_t caller_port,
                      t3rt_binary_string_t address,
                      t3rt_type_t          signature_type,
                      t3rt_binary_string_t parameters[],
                      t3rt_context_t ctx);
                   
void *
t3pl_port_sut_call_bc(t3rt_binary_string_t port_to_call,
                      t3rt_binary_string_t caller_port,
                      t3rt_binary_string_t address,
                      t3rt_type_t          signature_type,
                      t3rt_binary_string_t parameters[],
                      t3rt_context_t ctx);
                   
void
t3pl_port_sut_call_done(void * handle, t3rt_context_t ctx);

void
t3pl_port_sut_call_abort(void * handle, t3rt_context_t ctx);

void
t3pl_port_sut_reply(t3rt_binary_string_t destination_port,
                    t3rt_binary_string_t sut_address,
                    t3rt_binary_string_t caller_port,
                    t3rt_binary_string_t address,
                    t3rt_type_t          signature_type,
                    t3rt_binary_string_t parameters[],
                    t3rt_binary_string_t return_value,
                    t3rt_context_t ctx);

void
t3pl_port_sut_reply_mc(t3rt_binary_string_t destination_port,
                       t3rt_binary_string_t sut_address_list[], /* NULL-terminated list */
                       t3rt_binary_string_t caller_port,
                       t3rt_binary_string_t address,
                       t3rt_type_t          signature_type,
                       t3rt_binary_string_t parameters[],
                       t3rt_binary_string_t return_value,
                       t3rt_context_t ctx);
                    
void
t3pl_port_sut_reply_bc(t3rt_binary_string_t destination_port,
                       t3rt_binary_string_t caller_port,
                       t3rt_binary_string_t address,
                       t3rt_type_t          signature_type,
                       t3rt_binary_string_t parameters[],
                       t3rt_binary_string_t return_value,
                       t3rt_context_t ctx);

void 
t3pl_port_sut_raise(t3rt_binary_string_t destination_port,
                    t3rt_binary_string_t sut_address,
                    t3rt_binary_string_t caller_port,
                    t3rt_binary_string_t address,
                    t3rt_type_t          signature_type,
                    t3rt_binary_string_t exception_value,
                    t3rt_context_t ctx);

void 
t3pl_port_sut_raise_mc(t3rt_binary_string_t destination_port,
                       t3rt_binary_string_t sut_address_list[], /* NULL-terminated list */
                       t3rt_binary_string_t caller_port,
                       t3rt_binary_string_t address,
                       t3rt_type_t          signature_type,
                       t3rt_binary_string_t exception_value,
                       t3rt_context_t ctx);
                       
void 
t3pl_port_sut_raise_bc(t3rt_binary_string_t destination_port,
                       t3rt_binary_string_t caller_port,
                       t3rt_binary_string_t address,
                       t3rt_type_t          signature_type,
                       t3rt_binary_string_t exception_value,
                       t3rt_context_t ctx);


/*
 * Perform the SUT action (implicit send in TTCN-2)
 */

void
t3pl_port_sut_action(t3rt_value_t string_or_template,
                     t3rt_context_t ctx);


/*
 * Retrieves the system port address
 */

void
t3pl_port_retrieve_system_port(const char* system_port_name,
                               long index, /* Index in port array or -1 */
                               t3rt_binary_string_t system_port_address,
                               t3rt_context_t ctx);


/*
 * Releases the system port address
 */

void
t3pl_port_release_system_port(t3rt_binary_string_t system_port_address,
                              t3rt_context_t ctx);


/*
 * Returns the port for controlling the system "component".
 */

t3rt_binary_string_t
t3pl_component_get_system_control_port(t3rt_context_t ctx);


/*
 * Set the component type of the system component
 */

void
t3pl_component_set_system_component_type(t3rt_type_t component_type,
                                         t3rt_context_t ctx);


/* 
 * Blocks the current component waiting for some external stimuli
 * (i.e. some message received or timer timing out).  This function
 * will return information if there was data received and/or a timeout
 * occurred.  In either case the time_to_soonest_timeout is updated
 * according to how long it really took.
 */

t3rt_snapshot_return_t
t3pl_component_wait (double * real_time_wait,
                     double * time_to_soonest_timeout, 
                     t3rt_context_t ctx);


/*
 * Same to t3pl_component_wait but:
 * 1) Processes only control messages (even inside event queue)
 * 2) Do not block
*/                      
                     
void 
t3pl_component_control (t3rt_context_t ctx);
                     
#ifdef __cplusplus
}
#endif

#endif


/* End of File */

