/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3pl_memory.h
 */


#ifndef __t3pl_memory_h
#define __t3pl_memory_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts.h"


/*
 * After a call to this function, the 't3rt_memory_allocate' function must be working.
 */

void
t3pl_memory_pre_initialize (int argc, char * argv []);


/*
 * After a call to this function, all memory primitives must be available.
 */

void
t3pl_memory_initialize (t3rt_context_t ctx);


/*
 * Finalizes memory module.
 */

void
t3pl_memory_finalize (t3rt_context_t ctx);


/*
 * Allocate 'size' number of bytes
 */

void *
t3pl_memory_allocate (const t3rt_alloc_strategy_t strategy,
                      const unsigned long size, 
                      t3rt_context_t context);


/*
 * Deallocate the given memory block
 */

void
t3pl_memory_deallocate (const t3rt_alloc_strategy_t strategy,
                        void *mem, 
                        t3rt_context_t context); 


/*
 * Reallocate the given memory block
 */

void *
t3pl_memory_reallocate (const t3rt_alloc_strategy_t strategy,
                        void *mem, 
                        const unsigned long new_size, 
                        t3rt_context_t context);


#ifdef __cplusplus
}
#endif

#endif

/* End of File */

