/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3pl_time.h
 */


#ifndef __t3pl_time_h
#define __t3pl_time_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts.h"


/*
 * This function is presently considered to be a no-op since its provided 
 * functionality is not required for that phase
 */

void
t3pl_time_pre_initialize (int argc, char * argv [], t3rt_context_t ctx);


/*
 * Initialize the timer module
 */

void
t3pl_time_initialize (t3rt_context_t ctx);


/*
 * Finalize the timer module
 */

void
t3pl_time_finalize (t3rt_context_t ctx);


/*
 * Obtains TriTimerId corresponding to internal RTS timer handle
 * Note: return type is t3rt_binary_string_t
 */

t3rt_binary_string_t t3pl_timer_decode(t3rt_timer_handle_t handle,
                                       t3rt_alloc_strategy_t strategy,  
                                       t3rt_context_t ctx);

/*
 * Create a timer instance into the "stopped" state
 */

void
t3pl_timer_create (t3rt_timer_handle_t *handle,
                   t3rt_context_t context);


/* 
 * Delete the timer instance. It will never be used again
 */

void
t3pl_timer_delete(t3rt_timer_handle_t *handle,
                  t3rt_context_t context);


/* 
 * Start a created timer instance. Also used to restart the timer. 
 * This should set the timer into the "running" state
 */

void
t3pl_timer_start (const t3rt_timer_handle_t handle, 
                  double duration,
                  t3rt_context_t context);


/*
 * Stop a timer instance. This should set the timer into the "stopped" state
 */

void
t3pl_timer_stop (const t3rt_timer_handle_t handle,
                 t3rt_context_t context);


/*
 * Read the current value of a timer
 */

t3rt_timer_state_t
t3pl_timer_read(const t3rt_timer_handle_t handle,
                double * elapsed_time,
                t3rt_context_t context);

#ifdef __cplusplus
}
#endif

#endif

/* End of File */

