/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_binarystrings.h
 */

#ifndef __t3rts_binarystrings_h
#define __t3rts_binarystrings_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts_common.h"


typedef struct t3rt__binary_string_struct_internal_t *  t3rt_binary_string_t; 


#include "t3rts_memory.h"
#include "t3rts_context_decl.h"



/*------------------------------------------------------------------------
  This iterator is used for iterating the contents of the string. 
  This is intended to replace a indexing scheme. Modifying the string can 
  potentionally corrupt iterators for the same string.

  */

typedef struct t3rt_binary_string_iter_internal_t {
  t3rt_binary_string_t  string;
  unsigned long         bit_index;
} t3rt_binary_string_iter_t;


/*
 * Creates an empty binary string of given size
 */

t3rt_binary_string_t
t3rt_binary_string_allocate (t3rt_alloc_strategy_t strategy, 
                             unsigned long alloc_length,
                             t3rt_context_t context); 




/*
 * Deallocate the string
 */

void
t3rt_binary_string_deallocate (t3rt_binary_string_t string,
                               t3rt_context_t context);

void
t3rt_binary_string_deallocate_all (t3rt_binary_string_t *string,
                                   t3rt_context_t context);


t3rt_binary_string_t
t3rt_binary_string_construct (t3rt_alloc_strategy_t strategy,
                              unsigned long length, 
                              const unsigned char *data,
                              t3rt_context_t context);


/*
 * Make a copy of the string
 */

t3rt_binary_string_t
t3rt_binary_string_copy (t3rt_binary_string_t string, 
                         t3rt_alloc_strategy_t strategy,
                         t3rt_context_t context);


/*
 * Clear the contents. This will only set the used bits to zero
 */

void
t3rt_binary_string_clear (t3rt_binary_string_t string,
                          t3rt_context_t context);


/*
 * The number of used bits in the string
 */

unsigned long
t3rt_binary_string_length (t3rt_binary_string_t string,
                           t3rt_context_t context); 



/*
 * Compares two bitstring for equality
 */

t3rt_boolean_t
t3rt_binary_string_is_equal (t3rt_binary_string_t s1, 
                             t3rt_binary_string_t s2,
                             t3rt_context_t context);



/*
 * Aligns the binary string by padding the last byte with zeroes if not fully used
 */

void
t3rt_binary_string_pad (t3rt_binary_string_t string,
                        t3rt_context_t context); 


/*
 * Append the appstr to the string
 */

void
t3rt_binary_string_append (t3rt_binary_string_t string, 
                           t3rt_binary_string_t appstr,
                           t3rt_context_t context);


void
t3rt_binary_string_append_bits (t3rt_binary_string_t string, 
                                unsigned char data, 
                                unsigned char number_of_bits,
                                t3rt_context_t context);

void
t3rt_binary_string_append_1byte (t3rt_binary_string_t string, 
                                 unsigned char data,
                                 t3rt_context_t context);

void
t3rt_binary_string_append_2bytes (t3rt_binary_string_t string, 
                                  unsigned short data,
                                  t3rt_context_t context);

void
t3rt_binary_string_append_4bytes (t3rt_binary_string_t string, 
                                  unsigned long data,
                                  t3rt_context_t context);

void
t3rt_binary_string_append_nbytes (t3rt_binary_string_t string, 
                                  const unsigned char *data, 
                                  unsigned long bytesize,
                                  t3rt_context_t context);

void
t3rt_binary_string_append_nbits (t3rt_binary_string_t string, 
                                 const unsigned char *data, 
                                 unsigned long length,
                                 t3rt_context_t context);

void
t3rt_binary_string_assign (t3rt_binary_string_t dest, 
                           t3rt_binary_string_t src,
                           t3rt_context_t context);




/* Sets the iterator at the beginning of the string. */
void
t3rt_binary_string_start (t3rt_binary_string_t string, 
                          t3rt_binary_string_iter_t *iter,
                          t3rt_context_t context);

/* Sets the iterator to the indicated bit position of the string.  */
void
t3rt_binary_string_set_at (t3rt_binary_string_t string, 
                           unsigned long index, 
                           t3rt_binary_string_iter_t *iter,
                           t3rt_context_t context);

/* Returns the remaining room in this iterator. */
unsigned long
t3rt_bstring_iter_remaining_room(t3rt_binary_string_iter_t *iter,
                                 t3rt_context_t context);

/* Move the iterator forward 'n_bits' bits. */
void 
t3rt_bstring_iter_forward_nbits (t3rt_binary_string_iter_t *iter, 
                                 unsigned long n_bits,
                                 t3rt_context_t context);

/* Move the iterator backward one bit. */
void
t3rt_bstring_iter_backward_nbits (t3rt_binary_string_iter_t *iter,
                                  unsigned long n_bits,
                                  t3rt_context_t context);

/* Move the iterator forward to the start of the next byte. */
void
t3rt_bstring_iter_next_byte (t3rt_binary_string_iter_t *iter,
                             t3rt_context_t context);

/* Checks if the iterator is positions at the beginning of a byte. 
   I.e. that it is byte aligned. */
t3rt_boolean_t
t3rt_bstring_iter_is_at_boundary (t3rt_binary_string_iter_t *iter,
                                  t3rt_context_t context);

/* Move the iterator forward to the start of the next byte. */
unsigned char
t3rt_bstring_iter_bits_to_byte_boundary (t3rt_binary_string_iter_t *iter,
                                         t3rt_context_t context);

/* Predicate to check if the iterator is positioned at the end of the 
   string. */
t3rt_boolean_t
t3rt_bstring_iter_at_end (t3rt_binary_string_iter_t *iter,
                          t3rt_context_t context);

/* Predicate to check if the iterator is positioned at the beginning 
   of the string.  */
t3rt_boolean_t
t3rt_bstring_iter_at_start (t3rt_binary_string_iter_t *iter,
                            t3rt_context_t context);

/* This returns true if the bit at the current position is set. */
t3rt_boolean_t
t3rt_bstring_iter_is_bit_set (t3rt_binary_string_iter_t *iter,
                              t3rt_context_t context);

/* Extracts 'n' number of bits where n is less or equal to 8. */
unsigned char
t3rt_bstring_iter_get_bits (t3rt_binary_string_iter_t *iter, 
                            unsigned char n,
                            t3rt_context_t context);

/* Extracts the next 8 bits. */
unsigned char
t3rt_bstring_iter_get_1byte (t3rt_binary_string_iter_t *iter,
                             t3rt_context_t context);

/* Extracts the next 16 bits. */
unsigned short
t3rt_bstring_iter_get_2bytes (t3rt_binary_string_iter_t *iter,
                              t3rt_context_t context);

/* Extracts the next 32 bits. */
unsigned long
t3rt_bstring_iter_get_4bytes (t3rt_binary_string_iter_t *iter,
                              t3rt_context_t context);

/* Extracts the next n bytes. */
void
t3rt_bstring_iter_get_nbytes (t3rt_binary_string_iter_t *iter, 
                              unsigned long n, 
                              unsigned char *data,
                              t3rt_context_t context);

/* Extracts the next n bits. */
void
t3rt_bstring_iter_get_nbits (t3rt_binary_string_iter_t *iter, 
                             unsigned long n_bits, 
                             unsigned char *data,
                             t3rt_context_t context);



#ifdef __cplusplus
}
#endif

#endif

/* End of File */

