/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_codecs.h
 */

#ifndef __t3rts_codecs_h
#define __t3rts_codecs_h

#ifdef __cplusplus
extern "C" {
#endif

typedef enum t3rt__codecs_result_internal_t {
  t3rt_codecs_result_not_applicable_c,
  t3rt_codecs_result_failed_c,
  t3rt_codecs_result_succeeded_c
} t3rt_codecs_result_t;


typedef enum t3rt__codecs_strategy_internal_t {
  t3rt_codecs_strategy_registered_c,
  t3rt_codecs_strategy_builtin_c
} t3rt_codecs_strategy_t;



#include "t3rts_common.h"
#include "t3rts_context_decl.h"
#include "t3rts_values_general.h"
#include "t3rts_binarystrings.h"
#include "t3rts_widestrings.h"

typedef void (*t3rt_codecs_init_function_t)(t3rt_context_t ctx);

typedef void (*t3rt_codecs_setup_function_t)(t3rt_type_t type,
                                             t3rt_context_t ctx);

void
t3rt_codecs_register(t3rt_codecs_init_function_t init_function,
                     t3rt_codecs_setup_function_t setup_function,
                     t3rt_context_t ctx);


t3rt_codecs_result_t
t3rt_encode(t3rt_value_t value,
            t3rt_binary_string_t encoded_data,
            t3rt_context_t ctx);

t3rt_codecs_result_t
t3rt_decode(t3rt_binary_string_iter_t * encoded_data,
            t3rt_type_t type,
            t3rt_alloc_strategy_t strategy,
            t3rt_value_t * decoded_value,
            t3rt_context_t ctx);


t3rt_codecs_result_t
t3rt_builtin_encode(t3rt_value_t value,
                    t3rt_binary_string_t encoded_data,
                    t3rt_context_t ctx);

t3rt_codecs_result_t
t3rt_builtin_decode(t3rt_binary_string_iter_t * encoded_data,
                    t3rt_type_t type,
                    t3rt_alloc_strategy_t strategy,
                    t3rt_value_t * decoded_value,
                    t3rt_context_t ctx);


/*
 * t3rt_tci_encode() and t3rt_tci_decode() are envelops for tciEncode() and tciDecode().
 * TCI based encoders and decoders should be pluged into runtime system
 * by registering these functions using t3rt_codecs_register() 
 *
*/ 

extern t3rt_codecs_result_t
t3rt_tci_encode(t3rt_value_t value, 
                t3rt_binary_string_t encoded_data, 
                t3rt_context_t ctx);

extern t3rt_codecs_result_t
t3rt_tci_decode(t3rt_binary_string_iter_t * encoded_data,
                t3rt_type_t type,
                t3rt_alloc_strategy_t strategy,
                t3rt_value_t * decoded_value,
                t3rt_context_t ctx);

#ifdef __cplusplus
}
#endif

#endif

/* End of File */

