/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_logging.h
 */

#ifndef __t3rts_logging_h
#define __t3rts_logging_h

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned long   t3rt_log_event_kind_t;
typedef unsigned long   t3rt_log_message_kind_t;

typedef struct t3rt__log_struct_internal_t *            t3rt_log_t;
typedef struct t3rt__log_mechanism_struct_internal_t *  t3rt_log_mechanism_t;

#include "t3rts_context_decl.h"


#define t3rt_log_unknown_event_kind_name_c "unknown_event_kind"


typedef enum t3rt_log_mechanism_version_internal_t {
  t3rt_log_mechanism_version_1_c,
  t3rt_log_mechanism_version_current_c = t3rt_log_mechanism_version_1_c
} t3rt_log_mechanism_version_t;



typedef enum t3rt_log_predefined_message_kind_internal_t {
  t3rt_log_msg_info_c,
  t3rt_log_msg_ttcn3_c,
  t3rt_log_msg_warning_c,
  t3rt_log_msg_error_c,
  t3rt_log_msg_debug_c
} t3rt_log_predefined_message_kind_t;

/* Convenience macros as the above enumerations are usually casted: */
#define t3rt_log_kind_msg_info_c \
 (t3rt_log_message_kind_t)t3rt_log_msg_info_c
#define t3rt_log_kind_msg_ttcn3_c \
 (t3rt_log_message_kind_t)t3rt_log_msg_ttcn3_c
#define t3rt_log_kind_msg_warning_c \
 (t3rt_log_message_kind_t)t3rt_log_msg_warning_c
#define t3rt_log_kind_msg_error_c \
 (t3rt_log_message_kind_t)t3rt_log_msg_error_c
#define t3rt_log_kind_msg_debug_c \
 (t3rt_log_message_kind_t)t3rt_log_msg_debug_c


#include "t3rts_common.h"
#include "t3rts_memory.h"
#include "t3rts_values_general.h"
#include "t3rts_widestrings.h"
#include "t3rts_sourcetracking.h"


/* A function of this type is responsible for initiliazing the log mechanism.
   It will be called once (during initialization of the RTS. */
typedef void (* t3rt_log_mechanism_init_function_t)
                        (t3rt_log_mechanism_t log_mechanism,
                         t3rt_context_t context);

/* A function of this type is responsible for finalizing the log mechanism.
   It will be called once (during shutdown of the RTS. */
typedef void (* t3rt_log_mechanism_finalize_function_t)
                        (t3rt_log_mechanism_t log_mechanism);


/* A function of this type is responsible for setting the 'handle'
   and function pointer attributes of the 'log' object. */
typedef void (* t3rt_log_mechanism_open_function_t)(t3rt_log_t log,
                                                    t3rt_context_t ctx);

/* A function of this type is responsible for closing the log stream. */
typedef void (* t3rt_log_mechanism_close_function_t)(t3rt_log_t log,
                                                     t3rt_context_t ctx);


/* A function of this type is responsible for logging 'string' to the given
   'log'. This is never called for event streams. */
typedef void (* t3rt_log_mechanism_log_string_function_t)
     (t3rt_log_t log,
      t3rt_log_message_kind_t msg_kind,
      t3rt_source_location_t source_location,
      const char *string,
      t3rt_binary_string_t origin,
      const char *origin_name,
      t3rt_boolean_t forwarded,
      t3rt_binary_string_t aux,
      t3rt_context_t ctx);

/*A function of this type is responsible for logging 'string' to the given
  'log'. This is never called for event streams. */
typedef void (* t3rt_log_mechanism_log_wide_string_function_t)
     (t3rt_log_t log,
      t3rt_log_message_kind_t msg_kind,
      t3rt_source_location_t source_location,
      t3rt_wide_string_t string,
      t3rt_binary_string_t origin,
      const char *origin_name,
      t3rt_boolean_t forwarded,
      t3rt_binary_string_t aux,
      t3rt_context_t ctx);


/* A function of this type is responsible for logging the 'event' to the given
   'log'. This is only called for event streams. */
typedef void (* t3rt_log_mechanism_log_event_function_t)
     (t3rt_log_t log,
      t3rt_log_event_kind_t event,
      t3rt_source_location_t source_location,
      t3rt_value_t params[],
      t3rt_binary_string_t origin,
      const char *origin_name,
      t3rt_boolean_t forwarded,
      t3rt_binary_string_t aux,
      t3rt_context_t ctx);



void
t3rt_log_register_listener(const char * mechanism_name,
                           t3rt_log_mechanism_version_t version,
                           t3rt_log_mechanism_init_function_t init_function,
                           t3rt_log_mechanism_finalize_function_t finalize_function,
                           t3rt_log_mechanism_open_function_t open_function,
                           t3rt_log_mechanism_close_function_t close_function,
                           t3rt_log_mechanism_log_event_function_t log_e_function);


void
t3rt_log_mechanism_set_auxiliary (t3rt_log_mechanism_t log_mechanism, 
                                  void * aux,
                                  t3rt_context_t context);

void *
t3rt_log_mechanism_get_auxiliary (t3rt_log_mechanism_t log_mechanism, 
                                  t3rt_context_t context);


void
t3rt_log_set_auxiliary (t3rt_log_t log, 
                        void * aux,
                        t3rt_context_t context);

void *
t3rt_log_get_auxiliary (t3rt_log_t log, 
                        t3rt_context_t context);


t3rt_log_mechanism_t
t3rt_log_get_log_mechanism (t3rt_log_t log, 
                            t3rt_context_t context);


void
t3rt_log_string_to_all(t3rt_log_message_kind_t msg_kind,
                       const char *string,
                       t3rt_context_t ctx);

void
t3rt_log_wide_string_to_all(t3rt_log_message_kind_t msg_kind,
                            t3rt_wide_string_t string,
                            t3rt_context_t ctx);

void
t3rt_log_list_to_all(t3rt_log_message_kind_t msg_kind,
                     t3rt_value_t values[],
                     t3rt_context_t ctx);
                            
void
t3rt_log_event_to_all(t3rt_log_event_kind_t event_kind,
                      t3rt_value_t params[],
                      t3rt_context_t ctx);

void
t3rt_log_string(const char* dest,
                t3rt_log_message_kind_t msg_kind,
                const char *string,
                t3rt_context_t ctx);

void
t3rt_log_wide_string(const char* dest,
                     t3rt_log_message_kind_t msg_kind,
                     t3rt_wide_string_t string,
                     t3rt_context_t ctx);

void
t3rt_log_event(const char* dest,
               t3rt_log_event_kind_t event_kind,
               t3rt_value_t params[],
               t3rt_context_t ctx);



const char*
t3rt_log_message_kind_name(t3rt_log_message_kind_t kind);


t3rt_boolean_t
t3rt_log_is_concentrator(t3rt_context_t ctx);


#ifdef __cplusplus
}
#endif

#endif

/* End of File */

