/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_memory.h
 */

#ifndef __t3rts_memory_h
#define __t3rts_memory_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts_common.h"

typedef enum t3rt_alloc_strategy_internal_t { 
                t3rt_perm_alloc_c, 
                t3rt_temp_alloc_c, 
                t3rt_static_alloc_c,
                t3rt_temp_alloc_outer_c /* To allocate in the enclosing memory
                                           scope. Not applicable for realloc. */ 
} t3rt_alloc_strategy_t;



/*
 * Type for temporary memory scopes
 */
typedef struct t3rt_memory_scope_struct_internal_t {
  struct t3rt__memory_block_list_struct_t       *first_block; 
  struct t3rt__memory_block_list_struct_t       *last_block;  
  struct t3rt_memory_scope_struct_internal_t *outer_scope; /* Enclosing memory scope. */
} t3rt_memory_scope_t;




#include "t3rts_context_decl.h"


/*
 * Start a new temporary memory area.
 */

void
t3rt_memory_temp_begin(t3rt_memory_scope_t *memory_scope,
                       t3rt_context_t ctx);


/*
 * Abandons the temporary opened temporary memory area.
 */

void 
t3rt_memory_temp_end(t3rt_memory_scope_t *memory_scope,
                     t3rt_context_t ctx);


/*
 * Clears the current memory area.
 */

void 
t3rt_memory_temp_clear(t3rt_memory_scope_t *memory_scope,
                       t3rt_context_t ctx);


/*
 * Allocates memory according to strategy
 */

void *
t3rt_memory_temp_allocate (unsigned long size, t3rt_context_t context);



#ifdef __cplusplus
}
#endif

#endif

/* End of File */

