/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_ports.h
 */

#ifndef __t3rts_ports_h
#define __t3rts_ports_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts_common.h"
#include "t3rts_values_general.h"
#include "t3rts_context.h" 

#include "t3pl_communication.h"




/*
 * Clears the port's input queue. 't3rt_value_all_c' is applicable.
 */

void
t3rt_port_clear (t3rt_value_t port, t3rt_context_t ctx);

/*
 * Starts the port, i.e. enables it. Updates corresponding PortRecordValue 
 * accordingly.
 *
 * The 't3rt_value_all_c' constant is applicable.
 */

void
t3rt_port_start (t3rt_value_t port, t3rt_context_t ctx);


/*
 * Stops the port, i.e. disables it. Updates corresponding PortRecordValue 
 * accordingly. 
 *
 * The 't3rt_value_all_c' constant is applicable.
 */

void
t3rt_port_stop (t3rt_value_t port, t3rt_context_t ctx);

/*
 * Halts the port, i.e. disables it allowing processing of already received messages. 
 *  Updates corresponding PortRecordValue accordingly. 
 *
 * The 't3rt_value_all_c' constant is applicable.
 */

void
t3rt_port_halt (t3rt_value_t port, t3rt_context_t ctx);


/*
 * Is the port enabled for communication or not? 
 */

t3rt_boolean_t
t3rt_port_is_enabled (t3rt_value_t port, t3rt_context_t ctx);


/*
 * Sends value to the SUT.
 */

void
t3rt_port_sut_action (t3rt_value_t string_or_template, t3rt_context_t ctx);


/*
 * Sends value through the port to the specified component. The 't3rt_no_value_c' 
 * should be used for 'component' when the operation do not specify an explicit 
 * destination.
 */

void
t3rt_port_send (t3rt_value_t port, t3rt_value_t value, t3rt_value_t component, 
                t3rt_context_t ctx);


/*
 * Makes a procedure based call through the port to the specified component. 
 * The constant 't3rt_duration_forever_c' is used to denote infinite waiting
 * and the 't3rt_duration_nowait_c' constant denotes 'nowait'.
 * The 't3rt_no_value_c' constant should be used for 'component' when the 
 * operation do not specify an explicit destination. 
 */

void
t3rt_port_call(t3rt_value_t port, t3rt_value_t template_value, 
               double timeout, t3rt_value_t component, t3rt_context_t ctx);


/*
 * Replies to synchronous call through the port to the specified component.
 * The 't3rt_no_value_c' constant should be used for 'component' when
 * the operation do not specify an explicit source.
 */

void
t3rt_port_reply(t3rt_value_t port, t3rt_value_t template_value,
                t3rt_value_t return_value, t3rt_value_t component,
                t3rt_context_t ctx);


/*
 * Raises an exception through the port to the specified component.
 * The 't3rt_no_value_c' constant should be used for 'component'
 * when the operation do not specify an explicit destination.
 */

void
t3rt_port_raise(t3rt_value_t port, t3rt_type_t signature_type, 
                t3rt_value_t value, t3rt_value_t component, 
                t3rt_context_t ctx);

/* 
 * Tries to receive value through the port from the specified
 * component and tries to match it against template value.  If match
 * succeeded, the message is removed from the port input queue unless
 * 'no_remove' is set (TTCN3 'check' operation).
 *
 * 't3rt_value_any_c' is applicable for 'port'.  't3rt_no_value_c' is
 * applicable for 'template_value'.  't3rt_value_no_return_c' is
 * applicable for 'value' and 'sender'.  The 't3rt_no_value_c' should
 * be used for 'component' when the operation do not specify an
 * explicit source.
 */

t3rt_boolean_t
t3rt_port_try_receive(t3rt_value_t port, t3rt_value_t template_value, 
                      t3rt_value_t component, t3rt_boolean_t no_remove, 
                      t3rt_value_t value, t3rt_value_t sender,
                      t3rt_context_t ctx);

/*
 * Tries to receive value through the port from the specified
 * component and tries to match it against template value.  If match
 * succeeded, the message is removed from the port input queue;
 * otherwise message is also removed from the queue, and function
 * proceeds with the next message in the queue.
 *
 * 't3rt_value_any_c' is applicable for 'port'.  't3rt_no_value_c' is
 * applicable for 'template_value'.  't3rt_value_no_return_c' is
 * applicable for 'value' and 'sender'.  The 't3rt_no_value_c' should
 * be used for 'component' when the operation do not specify an
 * explicit source.
 */

t3rt_boolean_t
t3rt_port_try_trigger(t3rt_value_t port, t3rt_value_t template_value, 
                      t3rt_value_t component, t3rt_value_t value, 
                      t3rt_value_t sender, t3rt_context_t ctx);


/*
 * Tries to receive call through the port from the specified component
 * and tries to match it against template value.  If match succeeded,
 * the message is removed from the port input queue unless 'no_remove'
 * is set (TTCN3 'check' operation).
 *
 * 't3rt_value_any_c' is applicable for 'port'.  't3rt_no_value_c' is
 * applicable for 'template_value'.  't3rt_value_no_return_c' is
 * applicable for 'sender'.  The 't3rt_no_value_c' should be used for
 * 'component' when the operation do not specify an explicit source.
 */

t3rt_boolean_t
t3rt_port_try_getcall(t3rt_value_t port, t3rt_value_t template_value,
                      t3rt_value_t component, t3rt_boolean_t no_remove,
                      unsigned long params_count, t3rt_value_t *params,
                      t3rt_value_t sender, t3rt_context_t ctx);


/*
 * Tries to receive reply through the port from the specified
 * component and tries to match it against template value.  If match
 * succeeded, the message is removed from the port input queue unless
 * 'no_remove' is set (TTCN-3 'check' operation).
 *
 * 't3rt_value_any_c' is applicable for 'port'.  't3rt_no_value_c' is
 * applicable for 'template_value'.  't3rt_value_no_return_c' is
 * applicable for 'sender'.  The 't3rt_no_value_c' should be used for
 * 'component' when the operation do not specify an explicit
 * source.  Reply value is stored as the first element in 'params'.
 */

t3rt_boolean_t
t3rt_port_try_getreply(t3rt_value_t port, t3rt_value_t template_value,
                       t3rt_value_t return_value, t3rt_value_t component,
                       t3rt_boolean_t no_remove,
                       unsigned long params_count, t3rt_value_t *params,
                       t3rt_value_t sender, t3rt_context_t ctx);


/*
 * Tries to catch exception value through the port from the specified
 * component and tries to match it against template value. If match
 * succeeded, the message is removed from the port input queue unless
 * 'no_remove' is set (TTCN-3 'check' operation).
 *
 * 't3rt_value_any_c' is applicable for
 * 'port'.  't3rt_undefined_type_c' is applicable for
 * 'type'.  't3rt_no_value_c' is applicable for
 * 'template_value'.  't3rt_value_no_return_c' is applicable for
 * 'value' and 'sender'. The 't3rt_no_value_c' should be used for
 * 'component' when the operation do not specify an explicit source.
 */

t3rt_boolean_t
t3rt_port_try_catch(t3rt_value_t port, t3rt_type_t type, 
                    t3rt_value_t template_value, 
                    t3rt_value_t component, t3rt_boolean_t no_remove, 
                    t3rt_value_t value, t3rt_value_t sender, 
                    t3rt_context_t ctx);


/* 
 * Tries to catch timeout exception through the port. If succeeded,
 * the timeout message is removed from the port input queue.
 * The 't3rt_value_any_c' constant is NOT applicable for 'port'.
 */

t3rt_boolean_t
t3rt_port_try_catch_timeout(t3rt_value_t port, t3rt_context_t ctx); 


/*
 * Inserts specified data on behalf of sender into the local port
 * input queue.
 */

void
t3rt_port_insert_message(t3rt_binary_string_t port_addr,
                         t3rt_binary_string_t sut_address,
                         t3rt_binary_string_t bstring,
                         t3rt_context_t ctx);


void
t3rt_port_insert_call(t3rt_binary_string_t port_addr,
                      t3rt_binary_string_t sut_address,
                      t3rt_type_t signature_type,
                      t3rt_binary_string_t parameters[],
                      t3rt_binary_string_t sender,
                      t3rt_context_t ctx);



/*
 * Inserts specified reply value on behalf of sender into the local
 * port input queue.
 *
 * This will also send a 'wakeup' message to the control port of this
 * component to interrupt the 't3pl_component_snapshot' call that the
 * main thread of this component is assumed to be blocked in.
 */

void
t3rt_port_insert_reply(t3rt_binary_string_t port_addr,
                       t3rt_binary_string_t sut_address,
                       t3rt_type_t signature_type,
                       t3rt_binary_string_t reply_data[],
                       t3rt_binary_string_t return_value,
                       t3rt_binary_string_t sender,
                       t3rt_context_t ctx);


/*
 * Inserts specified exception value on behalf of sender into the
 * local port input queue.
 *
 * The 'exception' can be 't3rt_timeout_exception_c'.
 * 
 * This will also send a 'wakeup' message to the control port of this
 * component to interrupt the 't3pl_component_snapshot' call that the
 * main thread of this component is assumed to be blocked in.
 */

void
t3rt_port_insert_exception(t3rt_binary_string_t port_addr,
                           t3rt_binary_string_t sut_address,
                           t3rt_type_t signature_type,
                           t3rt_binary_string_t exception_value,
                           t3rt_binary_string_t sender,
                           t3rt_context_t ctx);

#ifdef __cplusplus
}
#endif

#endif

/* End of File */

