/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_symboltable.h
 *
 */

#ifndef __t3rts_symboltable_h
#define __t3rts_symboltable_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts_common.h"
#include "t3rts_types.h"
#include "t3rts_values_general.h"
#include "t3rts_errorhandling.h"
#include "t3rts_control.h"
 
typedef enum t3rt_symbol_entry_kind_internal_t {
    /* These are only used to access extension attributes. */
    t3rt_symbol_entry_kind_module,
    t3rt_symbol_entry_kind_imported_module,
    t3rt_symbol_entry_kind_group,
        
    /* These use the 'type_descriptor' attribute only: */
    t3rt_symbol_entry_kind_userdefined_type,
    t3rt_symbol_entry_kind_signature_type,
    t3rt_symbol_entry_kind_template_type,
        
    /* These use the 'value_descriptor' attribute only: */
    t3rt_symbol_entry_kind_constant,
    t3rt_symbol_entry_kind_external_constant,

    /* These use the 'type_descriptor' and 'value_descriptor' attribute: */
    t3rt_symbol_entry_kind_module_parameter,
    
    /* These use the 'function_pointer' attribute only: */
    t3rt_symbol_entry_kind_initialize_function,
    t3rt_symbol_entry_kind_module_params_initialize_function,
    t3rt_symbol_entry_kind_finalize_function,

    t3rt_symbol_entry_kind_external_function,

    t3rt_symbol_entry_kind_control_part_function,
    t3rt_symbol_entry_kind_function, 
    t3rt_symbol_entry_kind_test_step,

    t3rt_symbol_entry_kind_testcase	
    /* The 'type_descriptor' is used for the component type     */
    /* of the test case and the 'function_pointer' attribute    */
    /* contains the generated function.                         */
} t3rt_symbol_entry_kind_t;
                                 


typedef struct t3rt_symbol_entry_struct_internal_t {
    const char *              name;
    t3rt_symbol_entry_kind_t  kind;
    t3rt_type_t               type_descriptor;  /* These three fields ... */
    t3rt_value_t              value_descriptor; /* ... are mostly ... */
    void *                    function_ptr;     /* ... mutually exclusive. */
    void *                    attr_descriptor;  /* Always NULL until attribute lists are implemented*/
    void *                    auxiliary;        /* used for internal run time extensions */
} t3rt_symbol_entry_struct_t;

typedef t3rt_symbol_entry_struct_t *        t3rt_symbol_entry_t;


#define t3rt_symbol_table_entry_name(e, ctx)      (((e) != NULL) ? (e)->name : "")
#define t3rt_symbol_table_entry_kind(e, ctx)      (((e) != NULL) ? (e)->kind : (t3rt_symbol_entry_kind_t)-1)
#define t3rt_symbol_table_entry_type(e, ctx)      (((e) != NULL) ? (e)->type_descriptor : t3rt_undefined_type)
#define t3rt_symbol_table_entry_value(e, ctx)     (((e) != NULL) ? (e)->value_descriptor : t3rt_no_value_c)
#define t3rt_symbol_table_entry_function(e, ctx)  (((e) != NULL) ? (e)->function_ptr : NULL)
#define t3rt_symbol_table_entry_attribute(e, ctx) (((e) != NULL) ? (e)->attr_descriptor : NULL)
#define t3rt_symbol_table_entry_auxiliary(e, ctx) (((e) != NULL) ? (e)->auxiliary : NULL)


typedef struct t3rt_module_entry_struct_internal_t {
  const char* name;
  t3rt_module_register_function_t register_function;
} t3rt_module_entry_struct_t;

typedef t3rt_module_entry_struct_t * t3rt_module_entry_t;



/*
 * Registers module symbols in the global symbol table. 
 * Also registers module parameters information.
 */

void 
t3rt_module_register (const char * module_name, 
                      t3rt_boolean_t is_root, 
                      t3rt_symbol_entry_struct_t symbol_table [], 
                      unsigned long symbol_table_size,
                      const char * language,
                      t3rt_context_t context);


/*
 * Lookup the element in the symbol table of the specified module and return it.
 */

t3rt_symbol_entry_t
t3rt_find_element (const char * module_name, 
                   const char * element_name,
                   t3rt_context_t context); 

/*
 * Lookup the element in all symbol tables, store found symbols in list and return number found.
 */
unsigned long t3rt_find_element_in_all_modules(t3rt_symbol_entry_t **symbols, 
                   const char * element_name,
                   t3rt_context_t context);

/*
 * Lookup the element in the symbol table of the specified module and return it.
 * Raise testcase error with provided message if element was not found (originally was a macro)
 */

t3rt_symbol_entry_t
t3rt_find_element_with_check(const char * module_name, 
                             const char *element_name, 
                             t3rt_context_t ctx);



/*
 * Returns the name of the root module 
 */

const char *
t3rt_root_module_name (t3rt_context_t context);


#ifdef __cplusplus
}
#endif

#endif

/* End of File */

