/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_timers.h
 */

#ifndef __t3rts_timers_h
#define __t3rts_timers_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts_common.h"
#include "t3rts_values_general.h"

#include "t3pl_time.h"


/*
 * Starts timer with the indicated duration. To start timer with its default 
 * duration, pass 't3rt_duration_default_c' as duration value.
 */

void
t3rt_timer_start (t3rt_value_t timer, double duration, t3rt_context_t ctx);


/*
 * Stops timer. 'timer' may be 't3rt_value_all_c' constant
 */

void
t3rt_timer_stop (t3rt_value_t timer, t3rt_context_t ctx);


/*
 * Returns timer elapsed time
 */

double
t3rt_timer_read (t3rt_value_t timer, t3rt_context_t ctx);



/*
 * Checks if timer is running. 'timer' may be 't3rt_value_any_c' constant
 */

t3rt_boolean_t
t3rt_timer_is_running (t3rt_value_t timer, t3rt_context_t ctx);


/*
 * Checks if timer is timed out. 'timer' may be 't3rt_value_any_c' constant
 */

t3rt_boolean_t
t3rt_timer_is_timed_out (t3rt_value_t timer, t3rt_context_t ctx);


/*
 * Checks if timer has timed out within an alternative statement.
 */

t3rt_boolean_t
t3rt_timer_try_timed_out(t3rt_value_t timer, t3rt_context_t ctx);


/*
 * Informs the RTS that this timer has timed out.
 */

void
t3rt_timer_timed_out(const t3rt_timer_handle_t handle, t3rt_context_t ctx);

#ifdef __cplusplus
}
#endif

#endif

/* End of File */

