/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_types.h
 */

#ifndef __t3rts_types_h
#define __t3rts_types_h

#ifdef __cplusplus
extern "C" {
#endif

/* template restrictions */
typedef enum t3rt_template_restriction_internal_t {
    t3rt_restr_none,
    t3rt_restr_omit,
    t3rt_restr_value,
    t3rt_restr_present
} t3rt_template_restriction_t;

typedef enum t3rt_verdict_internal_t {
        t3rt_verdict_none_c,
        t3rt_verdict_pass_c,
        t3rt_verdict_inconc_c,
        t3rt_verdict_fail_c,
        t3rt_verdict_error_c
} t3rt_verdict_t;



typedef enum t3rt_type_kind_internal_t {
    t3rt_type_kind_integer,
    t3rt_type_kind_float,
    t3rt_type_kind_boolean,
    t3rt_type_kind_objectidentifier,
    t3rt_type_kind_verdicttype,
    t3rt_type_kind_default,
    t3rt_type_kind_charstring,
    t3rt_type_kind_bitstring,
    t3rt_type_kind_hexstring,
    t3rt_type_kind_octetstring,
    t3rt_type_kind_universal_charstring,
    t3rt_type_kind_char,
    t3rt_type_kind_universal_char,
    t3rt_type_kind_record,
    t3rt_type_kind_recordof,
    t3rt_type_kind_set,
    t3rt_type_kind_setof,
    t3rt_type_kind_enumerated,
    t3rt_type_kind_union,
    t3rt_type_kind_address,
    t3rt_type_kind_port_ref,
    t3rt_type_kind_component_ref,
    t3rt_type_kind_array,
    t3rt_type_kind_template,
    t3rt_type_kind_timer,
    t3rt_type_kind_signature,
    t3rt_type_kind_signature_noblock,
    t3rt_type_kind_port,
    t3rt_type_kind_component,
    t3rt_type_kind_binary_string,
    t3rt_type_kind_test_case,
    t3rt_type_kind_test_step,
    t3rt_type_kind_function
} t3rt_type_kind_t;



typedef struct t3rt_type_struct_internal_t *t3rt_type_t;
typedef const struct t3rt_type_info_struct_internal_t *t3rt_type_info_t;
typedef struct t3rt_encoding_attr_struct_internal_t *t3rt_encoding_attr_t;




#include "t3rts_common.h"
#include "t3rts_context_decl.h"
#include "t3rts_values_general.h"
#include "t3rts_binarystrings.h"
#include "t3rts_codecs.h"
#include "t3rts_control.h"
#include "t3rts_widestrings.h"


typedef t3rt_value_t (*t3rt_type_postprocess_function_t)
    (t3rt_value_t value,
     t3rt_context_t ctx);


typedef t3rt_value_t (*t3rt_template_postprocess_function_t)
    (t3rt_value_t value,
     t3rt_value_t params[],
     t3rt_context_t ctx);


typedef t3rt_codecs_result_t (*t3rt_encoder_function_t) (t3rt_value_t value,
                                                         t3rt_binary_string_t buf,
                                                         t3rt_context_t ctx);

typedef t3rt_codecs_result_t (*t3rt_decoder_function_t) (t3rt_binary_string_iter_t * iter,
                                                         t3rt_type_t type,
                                                         t3rt_alloc_strategy_t strategy,
                                                         t3rt_value_t * decoded_value,
                                                         t3rt_context_t ctx);

typedef t3rt_boolean_t (*t3rt_type_check_function_t) (t3rt_type_t type,
                                                      t3rt_value_t value,
                                                      t3rt_context_t ctx);

typedef t3rt_value_t (*t3rt_type_constraint_function_t)
                                (t3rt_type_t type_or_template_ref,
                                 t3rt_value_t params [],
                                 t3rt_alloc_strategy_t strategy,
                                 t3rt_context_t ctx);

typedef t3rt_boolean_t (*t3rt_template_match_function_t) (t3rt_type_t template_ref,
                                                          t3rt_value_t params[],
                                                          t3rt_value_t value,
                                                          t3rt_context_t ctx);

typedef t3rt_value_t (*t3rt_template_valueof_function_t)
                                (t3rt_type_t template_ref,
                                 t3rt_value_t params [],
                                 t3rt_alloc_strategy_t strategy,
                                 t3rt_context_t ctx);


typedef unsigned long (*t3rt_template_sizeof_function_t)
                                (t3rt_type_t template_ref,
                                 t3rt_value_t params [],
                                 t3rt_context_t ctx);


typedef unsigned int   t3rt_field_properties_t;

typedef struct t3rt_field_info_internal_t {
    const char *            name;            
    t3rt_field_properties_t properties;      
    t3rt_type_t             type;
    t3rt_value_t            default_value;
} t3rt_field_info_t;


/* A group of the three lowest bits - usual field_info properties */
#define t3rt_get_field_info_ordinary_properties(field_info) \
            ((field_info)->properties & 7)

#define t3rt__ordinary_properties(properties) \
            (properties & 7)

/* The second one of the two bits - template restrictions */
#define t3rt_get_field_info_templ_restr_properties(field_info) \
            ((field_info)->properties & 24)


#define t3rt_type_array_length_c         "array length"
#define t3rt_type_array_base_index_c     "array base index"
#define t3rt_type_array_contained_type_c "array contained type"

typedef struct t3rt_enum_or_array_info_internal_t {
    const char *        name;
    t3rt_long_integer_t number;
} t3rt_enum_or_array_info_t;


typedef struct t3rt_template_info_internal_t {
    t3rt_type_t                      template_base_type;
    const char *                     description;
    t3rt_template_valueof_function_t valueof_message_template_func;
    t3rt_template_valueof_function_t valueof_call_template_func;
    t3rt_template_valueof_function_t valueof_reply_template_func;
    t3rt_template_sizeof_function_t  sizeof_func;
    t3rt_template_match_function_t   match_message_func; /* Message based match function. */
    t3rt_template_match_function_t   match_call_func;    /* Proc based match func for call. */
    t3rt_template_match_function_t   match_reply_func;   /* Proc based match func for reply. */
} t3rt_template_info_t;


typedef struct t3rt_type_info_struct_internal_t {
    const char *                name;
    const char *                module_name;
    t3rt_type_kind_t            kind;
    t3rt_type_t                 parent;
    t3rt_boolean_t              parent_resolved;

    void *                      postprocess_func;
        /* 't3rt_type_postprocess_function_t' or  */
        /* 't3rt_template_postprocess_function_t' */

    t3rt_type_check_function_t  check_func;
    t3rt_type_constraint_function_t constraint_func;

    t3rt_template_info_t *       template_info;
    unsigned long                field_count;
    t3rt_field_info_t *          field_info;
    t3rt_enum_or_array_info_t *  enum_or_array_info;
    void *                       auxiliary;
} t3rt_type_info_struct_t;


typedef struct t3rt_encoding_attr_struct_internal_t {
    const char* specifier;
    t3rt_boolean_t override;
} t3rt_encoding_attr_struct_t;


typedef struct t3rt_type_struct_internal_t {
    const char*                     module_name;
    const char*                     name;
    t3rt_encoding_attr_struct_t    *encode_attribute; /* Index 0 for top type and rest for fields. */
    t3rt_encoding_attr_struct_t    *variant_attribute; /* Index 0 for top type and rest for fields. */
    t3rt_encoding_attr_struct_t    *display_attribute; /* Index 0 for top type and rest for fields. */
    t3rt_encoding_attr_struct_t    *extension_attribute; /* Index 0 for top type and rest for fields. */
    t3rt_encoder_function_t         encoder;
    t3rt_decoder_function_t         decoder;
    t3rt_type_info_t                type_info;
} t3rt_type_struct_t;


#include "t3rts_memory.h"




extern t3rt_type_struct_t t3rt_integer_type_struct;
extern t3rt_type_struct_t t3rt_boolean_type_struct;
extern t3rt_type_struct_t t3rt_float_type_struct;
extern t3rt_type_struct_t t3rt_verdicttype_type_struct;
extern t3rt_type_struct_t t3rt_default_type_struct;
extern t3rt_type_struct_t t3rt_charstring_type_struct;
extern t3rt_type_struct_t t3rt_bitstring_type_struct;
extern t3rt_type_struct_t t3rt_octetstring_type_struct;
extern t3rt_type_struct_t t3rt_hexstring_type_struct;
extern t3rt_type_struct_t t3rt_universal_charstring_type_struct;
extern t3rt_type_struct_t t3rt_char_type_struct;
extern t3rt_type_struct_t t3rt_universal_char_type_struct;
extern t3rt_type_struct_t t3rt_address_type_struct;
extern t3rt_type_struct_t t3rt_timer_type_struct;
extern t3rt_type_struct_t t3rt_objectidentifier_type_struct;
extern t3rt_type_struct_t t3rt_binary_string_type_struct;

extern const t3rt_type_info_struct_t t3rt_integer_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_boolean_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_float_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_verdicttype_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_default_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_charstring_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_bitstring_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_octetstring_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_hexstring_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_universal_charstring_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_address_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_char_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_universal_char_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_timer_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_objectidentifier_type_info_struct;
extern const t3rt_type_info_struct_t t3rt_binary_string_type_info_struct;


/* Globally accessible constant descriptor representing illegal types. */
extern const t3rt_type_t t3rt_illegal_type;

/* Globally accessible constant descriptor representing undefined types.
 * Used e.g. when address type is not explicitly defined. */
extern const t3rt_type_t t3rt_undefined_type;


/* Globally accessible constant descriptor representing template types in
 * type info structures (when template is a parameter to another template. */
extern const t3rt_type_t t3rt_template_as_field_type;


extern const t3rt_type_t t3rt_integer_type;
extern const t3rt_type_t t3rt_boolean_type;
extern const t3rt_type_t t3rt_float_type;
extern const t3rt_type_t t3rt_verdicttype_type;
extern const t3rt_type_t t3rt_default_type;
extern const t3rt_type_t t3rt_charstring_type;
extern const t3rt_type_t t3rt_bitstring_type;
extern const t3rt_type_t t3rt_octetstring_type;
extern const t3rt_type_t t3rt_hexstring_type;
extern const t3rt_type_t t3rt_universal_charstring_type;
extern const t3rt_type_t t3rt_char_type;
extern const t3rt_type_t t3rt_universal_char_type;
extern const t3rt_type_t t3rt_address_type;
extern const t3rt_type_t t3rt_timer_type;
extern const t3rt_type_t t3rt_objectidentifier_type;

extern const t3rt_type_t t3rt_binary_string_type;



/* Predefined constants (for usage in static declarations!) */
/* The number of these properties should be less then 8(!) 
   becouse of field_info representation. Otherwise inside representation
   should be changed in Tester-compiler and Tester run-time system.
   
   A group of the three lowest bits - usual field_info properties */

#define t3rt_field_no_property_c             0
#define t3rt_field_property_mandatory_c      1
#define t3rt_field_property_optional_c       2
#define t3rt_field_property_in_value_c       3
#define t3rt_field_property_out_value_c      4
#define t3rt_field_property_inout_value_c    5
#define t3rt_field_property_return_value_c   6
#define t3rt_field_property_template_c       7

/*  The next two bits - template restrictions */
#define t3rt_field_property_none_templ_restr_c     0
#define t3rt_field_property_omit_templ_restr_c     8
#define t3rt_field_property_value_templ_restr_c    16
#define t3rt_field_property_present_templ_restr_c  24


#define t3rt_STATIC_integer_type              \
                        (t3rt_type_t)&t3rt_integer_type_struct
#define t3rt_STATIC_boolean_type              \
                        (t3rt_type_t)&t3rt_boolean_type_struct
#define t3rt_STATIC_float_type                \
                        (t3rt_type_t)&t3rt_float_type_struct
#define t3rt_STATIC_verdicttype_type          \
                        (t3rt_type_t)&t3rt_verdicttype_type_struct
#define t3rt_STATIC_default_type              \
                        (t3rt_type_t)&t3rt_default_type_struct
#define t3rt_STATIC_charstring_type           \
                        (t3rt_type_t)&t3rt_charstring_type_struct
#define t3rt_STATIC_bitstring_type            \
                        (t3rt_type_t)&t3rt_bitstring_type_struct
#define t3rt_STATIC_octetstring_type          \
                        (t3rt_type_t)&t3rt_octetstring_type_struct
#define t3rt_STATIC_hexstring_type            \
                        (t3rt_type_t)&t3rt_hexstring_type_struct
#define t3rt_STATIC_universal_charstring_type \
                        (t3rt_type_t)&t3rt_universal_charstring_type_struct
#define t3rt_STATIC_char_type                 \
                        (t3rt_type_t)&t3rt_char_type_struct
#define t3rt_STATIC_universal_char_type       \
                        (t3rt_type_t)&t3rt_universal_char_type_struct
#define t3rt_STATIC_address_type       \
                        (t3rt_type_t)&t3rt_address_type_struct
#define t3rt_STATIC_timer_type                \
                        (t3rt_type_t)&t3rt_timer_type_struct
#define t3rt_STATIC_objectidentifier_type     \
                        (t3rt_type_t)&t3rt_objectidentifier_type_struct
#define t3rt_STATIC_binary_string_type        \
                        (t3rt_type_t)&t3rt_binary_string_type_struct



/* Use odd numbers only: */
#define t3rt_STATIC_illegal_type                   (t3rt_type_t)-1
#define t3rt_STATIC_undefined_type                 (t3rt_type_t)-3
#define t3rt_STATIC_template_as_field_type         (t3rt_type_t)-5

/* Special constant for non-existing index. */
#define t3rt_no_field_index_c                     ((unsigned long)-1)
#define t3rt_no_enum_number_c                     ((unsigned long)-1)


/*
 * Creates a new value instance of the type
 */

t3rt_value_t
t3rt_type_instantiate_value (t3rt_type_t type,
                             t3rt_alloc_strategy_t strategy,
                             t3rt_context_t ctx);


/*
 * Creates a new value instance of the type, but also gives it a label name
 */

t3rt_value_t
t3rt_type_instantiate_named_value(t3rt_type_t type,
                                  const char* name,
                                  t3rt_alloc_strategy_t strategy,
                                  t3rt_context_t ctx);


/*
 * Creates a new external value instance of the type
 */

t3rt_value_t
t3rt_type_instantiate_external_value (t3rt_type_t type,
                                      t3rt_alloc_strategy_t strategy,
                                      t3rt_context_t ctx);


/*
 * Creates a new dynamic template instance of the given type
 */

t3rt_value_t
t3rt_type_instantiate_dynamic_template (t3rt_type_t type,
                                        t3rt_alloc_strategy_t strategy,
                                        t3rt_template_restriction_t templ_restr,
                                        t3rt_context_t ctx);

/*
 * Creates a new dynamic template instance of the type, but also gives it a label name
 */

t3rt_value_t
t3rt_type_instantiate_named_dynamic_template(t3rt_type_t type,
                                        const char* name,
                                        t3rt_alloc_strategy_t strategy,
                                        t3rt_template_restriction_t templ_restr,
                                        t3rt_context_t ctx);
/*
 * Creates a new template instance of the template type
 */

t3rt_value_t
t3rt_type_instantiate_template (t3rt_type_t template_type,
                                t3rt_alloc_strategy_t strategy,
                                t3rt_value_t params[],
                                t3rt_template_restriction_t templ_restr,
                                t3rt_context_t ctx);


/*
 * Built-in check if a value corresponds to the type.
 */

t3rt_boolean_t
t3rt_type_check_builtin (t3rt_type_t type,
                         t3rt_value_t value,
                         t3rt_context_t ctx);


/*
 * Checks if a value corresponds to the type.
 */

t3rt_boolean_t
t3rt_type_check (t3rt_type_t type,
                 t3rt_value_t value,
                 t3rt_context_t ctx);

/*
 * Checks if a character string contains only characters from the given ranges
 */

t3rt_boolean_t
t3rt_type_check_char_range(t3rt_value_t value,
			   const char *ranges,
			   unsigned long range_count,
			   t3rt_context_t ctx);

/*
 * Checks if a universal character string contains only characters from the given ranges
 */

t3rt_boolean_t
t3rt_type_check_universal_char_range(t3rt_value_t value,
				     const t3rt_wide_char_t *ranges,
				     unsigned long range_count,
				     t3rt_context_t ctx);





/*
 *  Check if type descriptors are equal.
 */
t3rt_boolean_t
t3rt_type_is_equal(t3rt_type_t type1, t3rt_type_t type2, t3rt_context_t ctx);


/*
 * Checks if a value matches to the template type.
 */

t3rt_boolean_t
t3rt_template_match (t3rt_type_t template_ref,
                     t3rt_value_t params [],
                     t3rt_value_t value,
                     t3rt_context_t ctx);

/*
 *  Function for matching against signature template.
 */ 
t3rt_boolean_t
t3rt_template_match_signature(t3rt_type_t template_ref, 
                              t3rt_value_t params[],
                              t3rt_value_t value,
                              t3rt_boolean_t is_call,
                              t3rt_context_t ctx);


/*
 * Checks if a value is a valid message for the port type.
 */

t3rt_boolean_t
t3rt_type_check_port_message (t3rt_type_t port_type, t3rt_value_t value,
                              t3rt_context_t ctx);



t3rt_type_kind_t
t3rt_type_kind (t3rt_type_t type, t3rt_context_t ctx);


t3rt_type_t
t3rt_type_parent (t3rt_type_t type, t3rt_context_t ctx);

void
t3rt__type_resolve_parent_info (t3rt_type_t type, t3rt_context_t ctx);

/*
 * Retreives the base type of this template type
 */

t3rt_type_t
t3rt_type_template_base_type (t3rt_type_t type, t3rt_context_t ctx);



void
t3rt_type_set_encoder (t3rt_type_t type,
                       t3rt_encoder_function_t encoder_function,
                       t3rt_context_t ctx);


t3rt_encoder_function_t
t3rt_type_get_encoder (t3rt_type_t type, t3rt_context_t ctx);



void
t3rt_type_set_decoder (t3rt_type_t type,
                       t3rt_decoder_function_t decoder_function,
                       t3rt_context_t ctx);



t3rt_decoder_function_t
t3rt_type_get_decoder (t3rt_type_t type, t3rt_context_t ctx);


/*
 * Returns the 'encode' attribute associated with the type.
 */

t3rt_encoding_attr_t
t3rt_type_encode_attribute(t3rt_type_t type, t3rt_context_t ctx);


/*
 * Returns the 'encode' attribute associated with a type's field.
 */

t3rt_encoding_attr_t
t3rt_type_field_encode_attribute_by_index(t3rt_type_t type,
                                          unsigned long index,
                                          t3rt_context_t ctx);
t3rt_encoding_attr_t
t3rt_type_field_encode_attribute_by_name(t3rt_type_t type,
                                         const char *fieldname,
                                         t3rt_context_t ctx);

/*
 * Returns the 'variant' attribute associated with the type.
 */

t3rt_encoding_attr_t
t3rt_type_variant_attribute(t3rt_type_t type, t3rt_context_t ctx);


/*
 * Returns the 'variant' attribute associated with a type's field.
 */

t3rt_encoding_attr_t
t3rt_type_field_variant_attribute_by_index(t3rt_type_t type,
                                           unsigned long index,
                                           t3rt_context_t ctx);
t3rt_encoding_attr_t
t3rt_type_field_variant_attribute_by_name(t3rt_type_t type,
                                          const char *fieldname,
                                          t3rt_context_t ctx);

/*
 * Returns the 'display' attribute associated with the type.
 */

t3rt_encoding_attr_t
t3rt_type_display_attribute(t3rt_type_t type, t3rt_context_t ctx);


/*
 * Returns the 'display' attribute associated with a type's field.
 */

t3rt_encoding_attr_t
t3rt_type_field_display_attribute_by_index(t3rt_type_t type,
                                           unsigned long index,
                                           t3rt_context_t ctx);
t3rt_encoding_attr_t
t3rt_type_field_display_attribute_by_name(t3rt_type_t type,
                                          const char *fieldname,
                                          t3rt_context_t ctx);
                                          
/*
 * Returns the 'extension' attribute associated with the type.
 */

t3rt_encoding_attr_t
t3rt_type_extension_attribute(t3rt_type_t type, t3rt_context_t ctx);


/*
 * Returns the 'extension' attribute associated with a type's field.
 */

t3rt_encoding_attr_t
t3rt_type_field_extension_attribute_by_index(t3rt_type_t type,
                                             unsigned long index,
                                             t3rt_context_t ctx);
t3rt_encoding_attr_t
t3rt_type_field_extension_attribute_by_name(t3rt_type_t type,
                                            const char *fieldname,
                                            t3rt_context_t ctx);
                                          
/*
 * Retreive type name the type in the module.
 *
 * If the type is imported, this will be the fully qualified name
 * "<importedmodule>.<typename>".
 */

const char *
t3rt_type_name (t3rt_type_t type, t3rt_context_t ctx);

/*
 * Retreives the template description. 
 * For inlined templates it's the same as a defininition in source file.
 * For explicit templates NULL is returned.
 */

const char *
t3rt_template_description(t3rt_type_t template_ref, t3rt_context_t ctx);

/*
 * Retreives the name of the type in the module where it is defined.
 *
 */

const char*
t3rt_type_definition_name(t3rt_type_t type, t3rt_context_t ctx);


/*
 * Retreive module name where the type is referenced (i.e. defined in
 * or imported to).
 *
 * If the type is imported, this will be the fully qualified name
 * "<importedmodule>.<typename>".
 */


const char*
t3rt_type_module(t3rt_type_t type, t3rt_context_t ctx);

/*
 * Retreive module name where the type is defined (i.e. imported from).
 */

const char*
t3rt_type_definition_module(t3rt_type_t type, t3rt_context_t ctx);


/*
 * Always a concatenation of <importedmodule>.<typename> or, if not
 * an imported type, <localmodule>.<typename>.
 *
 */

const char*
t3rt_type_qualified_name(t3rt_type_t type, t3rt_context_t ctx);




/*
 * Returns number of sub-fields of the specified type
 */

unsigned long
t3rt_type_field_count (t3rt_type_t type, t3rt_context_t ctx);


/*
 * Returns the name associated with indicated sub-field of the specified type
 */

const char *
t3rt_type_field_name (t3rt_type_t type,
                      unsigned long field_index,
                      t3rt_context_t ctx);


/*
 * Returns the index associated with indicated sub-field of the specified type
 */

unsigned long
t3rt_type_field_index (t3rt_type_t type, const char *field_name,
                       t3rt_context_t ctx);


/*
 * Returns the type associated with indicated sub-field of the specified type
 */

t3rt_type_t
t3rt_type_field_type (t3rt_type_t type, unsigned long field_index,
                      t3rt_context_t ctx);


/*
 * Returns the properties of the given field.
 */

t3rt_field_properties_t
t3rt_type_field_properties(t3rt_type_t type, unsigned long field_index,
                           t3rt_context_t ctx);

/*
 * Returns the default value of the given field.
 */

t3rt_value_t
t3rt_type_field_default_value(t3rt_type_t type, unsigned long field_index,
                              t3rt_context_t ctx);

/*
 * Returns number of named values of the specified enumerated type
 */

unsigned long
t3rt_type_enum_named_values_count (t3rt_type_t type, t3rt_context_t ctx);


/*
 * Returns the name associated with indicated position of the specified enumerated type
 */

const char *
t3rt_type_enum_name_by_index (t3rt_type_t type, unsigned long index,
                              t3rt_context_t ctx);


/*
 * Returns the number associated with indicated position of the specified enumerated type
 */

t3rt_long_integer_t
t3rt_type_enum_number_by_index (t3rt_type_t type, unsigned long index,
                                t3rt_context_t ctx);


/*
 * Returns the name associated with indicated number of the specified enumerated type
 */

const char *
t3rt_type_enum_name_by_number (t3rt_type_t type, t3rt_long_integer_t named_value_number,
                               t3rt_context_t ctx);


/*
 * Returns the number associated with indicated name of the specified enumerated type
 */

t3rt_long_integer_t
t3rt_type_enum_number_by_name (t3rt_type_t type, const char *named_value_name,
                               t3rt_context_t ctx);


/*
 * Returns the free text string specifier of the encoding attribute.
 */
const char*
t3rt_encoding_attr_get_specifier(t3rt_encoding_attr_t attr,
                                 t3rt_context_t ctx);

/*
 * Predicate telling if the encoding attribute is supposed to override the
 * encoding attributes of sub-elements.
 */
t3rt_boolean_t
t3rt_encoding_attr_is_override(t3rt_encoding_attr_t attr,
                               t3rt_context_t ctx);


/*
 *  Access to array type information.
 */

unsigned long
t3rt_type_array_size(t3rt_type_t type, t3rt_context_t ctx);

unsigned long
t3rt_type_array_base_index(t3rt_type_t type, t3rt_context_t ctx);

t3rt_type_t
t3rt_type_array_contained_type(t3rt_type_t type, t3rt_context_t ctx);

#ifdef __cplusplus
}
#endif

#endif

/* End of File */

