/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_value_assignments.h
 */

#ifndef __t3rts_values_assignments_h
#define __t3rts_values_assignments_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts_common.h"

#include "t3rts_values_general.h" 
#include "t3rts_widestrings.h"
#include "t3rts_binarystrings.h"
#include "t3rts_context.h"


                                          
/* 
 * First, this function checks if 'rvalue' is compatible with the type of the 
 * 'lvalue' (done by calling the 't3rt_type_check' function). Then, for the 
 * values of basic types, it simply copies the target value from 'rvalue' into 
 * 'lvalue'. For all other types, it does an element-wise assignment recursively.
 */

void
t3rt_value_assign (t3rt_value_t lvalue, 
                   const t3rt_value_t rvalue, 
                   t3rt_context_t context);

/******************************************************************************************
* t3rt_value_init in opposite to the t3rt_value_assign 
* does not require that rvalue at assignment should be initialized
*
* This is necessary for initialization of compound values 
* since tey may not be fully initialized at the variable declaration
*******************************************************************************************/

void
t3rt_value_init (t3rt_value_t lvalue, 
                 const t3rt_value_t rvalue, 
                 t3rt_context_t context);


/*
 * This function performs the assignment and generates a log event for variable 
 * modification
 */

void
t3rt_value_assign_and_log (t3rt_value_t lvalue, 
                           const t3rt_value_t rvalue, 
                           t3rt_context_t context);


/*
 * Assigns the default_duration into the indicated position of 
 * the 'vector'.
 *
 */

void
t3rt_value_set_timer_in_array_default_duration (t3rt_value_t vector, 
                                  const unsigned long index, 
                                  const double default_duration, 
                                  t3rt_context_t context);

/*
 * Assigns the content of the 'element' into the indicated position of 
 * the 'vector'.
 * Also check that the resulting vector value is accepted by its 
 * type's restrictions.
 *
 */

void
t3rt_value_assign_vector_element (t3rt_value_t vector, 
                                  const unsigned long index, 
                                  const t3rt_value_t element, 
                                  t3rt_context_t context);

/******************************************************************************************
* t3rt_init_vector_element(partial) in opposite to the t3rt_assign_vector_element(partial)
* does not require that rvalue at assignment should be initialized
*
* This is necessary for initialization of compound values 
* since tey may not be fully initialized at the variable declaration
*******************************************************************************************/

void
t3rt_value_init_vector_element (t3rt_value_t vector, 
                                const unsigned long index, 
                                const t3rt_value_t element, 
                                t3rt_context_t context);

/* Same as t3rt_value_assign_vector_element.
 * Prevents type checking to be called. 
 * For all but the last element in a structured literal when initializing 
 * a vector value, the t3rt_value_assign_vector_element_partial should be
 * used. For the last element, t3rt_value_assign_vector_element should be 
 * used.
 */

void
t3rt_value_assign_vector_element_partial (t3rt_value_t vector,
                                          const unsigned long index,
                                          const t3rt_value_t element,
                                          t3rt_context_t context);

void
t3rt_value_init_vector_element_partial (t3rt_value_t vector,
                                        const unsigned long index,
                                        const t3rt_value_t element,
                                        t3rt_context_t context);

/*
 * Assigns the content of the 'one_char' string into the indicated position 
 * of the 'string'
 */

void
t3rt_value_assign_string_element (t3rt_value_t string, 
                                  const unsigned long index, 
                                  const t3rt_value_t one_char, 
                                  t3rt_context_t context);



#ifdef __cplusplus
}
#endif

#endif

/* End of File */

