/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_values_general.h
 */

#ifndef __t3rts_values_general_h
#define __t3rts_values_general_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts_common.h"


typedef void *          t3rt_timer_handle_t;


typedef struct t3rt__value_struct_internal_t *t3rt_value_t;


#include "t3rts_memory.h"
#include "t3rts_types.h"

#include "t3rts_widestrings.h"
#include "t3rts_binarystrings.h"
#include "t3rts_context_decl.h"
#include "t3rts_control.h"


typedef enum t3rt_value_list_kind_internal_t {
    t3rt_value_list_normal_c,     /* value == list */
    t3rt_value_list_complement_c, /* value != list */
    t3rt_value_list_subset_c,     /* value <= list */
    t3rt_value_list_superset_c    /* value >= list */
} t3rt_value_list_kind_t;

typedef enum t3_permutation_kind_internal_t
{
    t3rt_not_permutated_c,
    t3rt_permutation_head_tail_c, /* 1 element permutation */
    t3rt_permutation_head_c,
    t3rt_permutation_body_c,
    t3rt_permutation_tail_c
} t3rt_permutation_kind_t;

typedef struct t3_length_constraint_internal_struct_t
{
    t3rt_value_t lb;
    t3rt_value_t ub;
} t3rt_length_constraint_t;


typedef long t3rt_port_call_id_t;


typedef enum t3rt__timer_state_internal_t {
  t3rt_timer_state_stopped,
  t3rt_timer_state_running,
  t3rt_timer_state_timedout
} t3rt_timer_state_t;


typedef t3rt_value_t (*t3rt_convert_ext2rts_function_t) (void * external_value,
                                                         t3rt_alloc_strategy_t strategy,
                                                         t3rt_context_t ctx);

typedef void (*t3rt_delete_ext_function_t) (void * external_value,
                                            t3rt_context_t ctx);



/* Predefined constants */

extern const t3rt_value_t t3rt_illegal_value_c;

extern const t3rt_value_t t3rt_omit_value_c;
extern const t3rt_value_t t3rt_anyone_value_c;
extern const t3rt_value_t t3rt_anyornone_value_c;
extern const t3rt_value_t t3rt_no_value_c;
extern const t3rt_value_t t3rt_not_used_value_c;
extern const t3rt_value_t t3rt_value_any_c;
extern const t3rt_value_t t3rt_value_all_c;
extern const t3rt_value_t t3rt_value_no_return_c;
extern const t3rt_value_t t3rt_timeout_exception_c;
extern const t3rt_value_t t3rt_value_null_address_c;
extern const t3rt_value_t t3rt_value_infinity_c;
extern const t3rt_value_t t3rt_value_default_c;

extern const double t3rt_duration_forever_c;
extern const double t3rt_duration_nowait_c;
extern const double t3rt_duration_default_c;
extern const double t3rt_duration_undefined_c;

extern const t3rt_value_t t3rt_value_true_c;
extern const t3rt_value_t t3rt_value_false_c;
extern const t3rt_value_t t3rt_value_verdict_pass_c;
extern const t3rt_value_t t3rt_value_verdict_fail_c;
extern const t3rt_value_t t3rt_value_verdict_inconc_c;
extern const t3rt_value_t t3rt_value_verdict_none_c;
extern const t3rt_value_t t3rt_value_verdict_error_c;
extern const t3rt_value_t t3rt_value_null_default_reference_c;
extern const t3rt_value_t t3rt_value_null_component_reference_c;



/* Special allocations */


/*
 * Returns a newly created "deep" copy of the value.
 */

t3rt_value_t
t3rt_value_copy (const t3rt_value_t value, 
                 const t3rt_alloc_strategy_t strategy, 
                 t3rt_context_t context);


t3rt_value_t
t3rt_value_add_vector_element (t3rt_value_t vector_value, 
                               t3rt_value_t element_value, 
                               t3rt_context_t context);


/*
 * Returns the newly created uninitialized value for the alternative
 */

t3rt_value_t
t3rt_value_set_union_alternative_by_index(t3rt_value_t union_value, 
                                          unsigned long alt_index, 
                                          t3rt_context_t context);

t3rt_value_t
t3rt_value_try_set_union_alternative_by_index(t3rt_value_t union_value,
                                              unsigned long alt_index,
                                              t3rt_context_t ctx);


t3rt_value_t
t3rt_value_set_union_alternative_by_name(t3rt_value_t union_value, 
                                         const char* alt_name, 
                                         t3rt_context_t context);



/* Deallocations */


/*
 * Deletes the value and (recursively) all the value elements
 */

void
t3rt_value_delete (t3rt_value_t *value, 
                   t3rt_context_t context);


/* Predicates */




/*
 * Checks if value and all its elements (recursively) are initialized
 */

t3rt_boolean_t
t3rt_value_is_initialized (t3rt_value_t value, 
                           t3rt_context_t context);

/*
 * Checks whether value is a dynamic template
 */

t3rt_boolean_t
t3rt_value_is_dynamic_template (t3rt_value_t value, 
                                t3rt_context_t context);


/* Access functions */


/*
 * Calls the 't3rt_type_kind' function.
 */

t3rt_type_kind_t
t3rt_value_kind (t3rt_value_t value, 
                 t3rt_context_t context);


/*
 * Returns the type descriptor for the type of the value
 */

t3rt_type_t
t3rt_value_type (const t3rt_value_t value, 
                 t3rt_context_t context);

                 
/*
 * Returns the parent value of the value (e.g. record value for a field value)
 */

t3rt_value_t
t3rt_value_parent (const t3rt_value_t value, 
                   t3rt_context_t context);

/*
 * Retreives the label of the value. This label is an arbitrary value
 */

t3rt_value_t
t3rt_value_label (const t3rt_value_t value, 
                  t3rt_context_t context);





/*
 * Returns the memory allocation strategy used for allocation of the value
 */

t3rt_alloc_strategy_t
t3rt_value_allocation_strategy (const t3rt_value_t value, 
                                t3rt_context_t context);


/*
 * Returns the length of the string value. 
 */

unsigned long
t3rt_value_string_length (t3rt_value_t string_value, 
                          t3rt_context_t context);


/*
 * Returns size of the vector
 */

unsigned long
t3rt_value_vector_size (t3rt_value_t vector_value, 
                        t3rt_context_t context);



/*
 * Returns the value of indicated field
 */

t3rt_value_t
t3rt_value_field_by_index (t3rt_value_t value, 
                           unsigned long field_index, 
                           t3rt_context_t context);


/*
 * Returns the value of indicated left-hand-side  field 
 */

t3rt_value_t
t3rt_value_field_by_index_lhs(t3rt_value_t value,
                              unsigned long field_index,
                              t3rt_context_t ctx);

/*
 * Returns the value of indicated field.
 * For values behavior is the same as t3rt_value_field_by_index.
 * For template variables when dereferencing '?' instantiated value is not linked
 * to the dereferenced one.
 */

t3rt_value_t
t3rt_value_try_field_by_index (t3rt_value_t value, 
                               unsigned long field_index, 
                               t3rt_context_t context);

/*
 * Returns the value of indicated field
 */

t3rt_value_t
t3rt_value_field_by_name (t3rt_value_t value, 
                          const char *field_name, 
                          t3rt_context_t context);


/*
 * Returns the value of indicated element of the vector
 */

t3rt_value_t
t3rt_value_vector_element (t3rt_value_t value, 
                           unsigned long element_index, 
                           t3rt_context_t context);


/*
 * Returns the newly created one character string value containing 
 * the indicated element of the string
 */

t3rt_value_t
t3rt_value_string_element (t3rt_value_t string_value, 
                           unsigned long element_index, 
                           t3rt_alloc_strategy_t strategy, 
                           t3rt_context_t context);



/*
 * Returns the value of the union value
 */

t3rt_value_t
t3rt_value_union_value (t3rt_value_t union_value, 
                        t3rt_context_t context);



/*
 * Returns the index of the current union alternative. Returns -1 if 
 * union alternative is not set yet.
 */

unsigned long
t3rt_value_union_index (t3rt_value_t union_value, 
                        t3rt_context_t context);



/* Basic initializations */


/*
 * Sets the label of the value. This label is an arbitrary value
 */

void
t3rt_value_set_label (t3rt_value_t value, 
                      t3rt_value_t label, 
                      t3rt_context_t context);

void
t3rt_value_set_templ_restr (t3rt_value_t value, 
                            t3rt_template_restriction_t templ_restr, 
                            t3rt_context_t context);

t3rt_value_t
t3rt_value_set_integer(t3rt_value_t value,
                       t3rt_long_integer_t number,
                       t3rt_context_t context);


t3rt_value_t
t3rt_value_set_boolean (t3rt_value_t boolean_value, 
                        const t3rt_boolean_t flag, 
                        t3rt_context_t context);


t3rt_value_t
t3rt_value_set_enum (t3rt_value_t int_value, 
                     t3rt_long_integer_t number, 
                     t3rt_context_t context);


t3rt_value_t
t3rt_value_set_float (t3rt_value_t float_value, 
                      const double number, 
                      t3rt_context_t context);


t3rt_value_t
t3rt_value_set_verdict (t3rt_value_t verdict_value, 
                        const t3rt_verdict_t verdict, 
                        t3rt_context_t context);


t3rt_value_t
t3rt_value_set_null(t3rt_value_t address_value, 
                    t3rt_context_t context);


t3rt_value_t
t3rt_value_set_address_value(t3rt_value_t address_value, 
			     t3rt_value_t contained_value,
                             t3rt_context_t context);

t3rt_value_t
t3rt_value_set_string (t3rt_value_t string_value, 
                       const char *string, 
                       t3rt_context_t context);


t3rt_value_t
t3rt_value_set_universal_charstring (t3rt_value_t universal_string_value, 
                                     const t3rt_wide_string_t data,
                                     t3rt_context_t context);

t3rt_value_t
t3rt_value_set_universal_charstring_to_ascii (t3rt_value_t universal_charstring_value, 
                                              const char * data,
                                              t3rt_context_t context);

t3rt_value_t
t3rt_value_set_universal_charstring_from_wchar_array(t3rt_value_t universal_charstring_value, 
                                                     const t3rt_wide_char_t * data,
                                                     unsigned long length,
                                                     t3rt_context_t context);

t3rt_value_t
t3rt_value_set_char (t3rt_value_t char_value, 
                     const char single_char, 
                     t3rt_context_t context);


t3rt_value_t
t3rt_value_set_universal_char (t3rt_value_t universal_char_value, 
                               const t3rt_wide_char_t single_wchar,
                               t3rt_context_t context);

t3rt_value_t
t3rt_value_set_universal_char_to_ascii (t3rt_value_t universal_char_value, 
                                        const char single_char, 
                                        t3rt_context_t context);

t3rt_value_t
t3rt_value_set_binary_string (t3rt_value_t bstring_value, 
                              const t3rt_binary_string_t data,
                              t3rt_context_t context);

t3rt_value_t
t3rt_value_set_external_value (t3rt_value_t external_value, 
                               void * ext_val, 
                               t3rt_convert_ext2rts_function_t ext2rts_convert_func,
                                   t3rt_delete_ext_function_t ext_delete_func,
                               t3rt_context_t context);


/*
 * Sets the indicated field to be not present. Applicable for record 
 * values only
 */

void
t3rt_value_set_omit (t3rt_value_t record_or_set_value, 
                     const unsigned long field_index,
                     t3rt_context_t context);


/*
 * This routine is intended to be used in generated code only
 */

t3rt_value_t
t3rt_value_instantiate_omitted_field_value(t3rt_value_t value,
                                           unsigned long field_index,
                                           t3rt_context_t ctx);

/*
 * Removes specified vector element and decreases size of vector by one.
 *
 * This function operates on setof and recordof values.
 */

void
t3rt_value_remove_vector_element (t3rt_value_t vector_value, 
                                  const unsigned long index,
                                  t3rt_context_t context);



/*
 * Sets size of the specified vector, by either adding or removing elements.
 *
 * This function operates on setof and recordof values.
 */

void
t3rt_value_set_vector_size (t3rt_value_t vector_value,
                            const unsigned long new_size,
                            t3rt_context_t context);


/*
 * Make the vector empty. This will empty the vector if it has elements. 
 * The vector will be initialized and checked against it type.
 */

void
t3rt_value_set_vector_empty(t3rt_value_t vector_value,
                            t3rt_context_t ctx);

/* 
 * Set the default duration of this timer.
 */

t3rt_value_t
t3rt_value_set_timer_default_duration (t3rt_value_t value, 
                                       const double default_duration,
                                       t3rt_context_t context);



/* 
 * Add a number to the end of the object identifier value.
 */

t3rt_value_t
t3rt_value_add_objectid_element(t3rt_value_t objectid,
                                unsigned long element,
                                t3rt_context_t ctx);

/* Target language access functions */


/*
 * Extracts an integer from the integer value
 */

t3rt_long_integer_t
t3rt_value_get_integer(const t3rt_value_t integer_value,
                       t3rt_context_t context);


/*
 * Extracts the number from the enumerated value
 */

t3rt_long_integer_t
t3rt_value_get_enum_number (const t3rt_value_t enum_value, 
                            t3rt_context_t context);


/*
 * Extracts the name from the enumerated value
 */

const char*
t3rt_value_get_enum_name (const t3rt_value_t enum_value, 
                          t3rt_context_t context);


/*
 * Extracts a float from the float value
 */

double
t3rt_value_get_float (const t3rt_value_t float_value, 
                      t3rt_context_t context);


/*
 * Extracts a boolean from the boolean value
 */

t3rt_boolean_t
t3rt_value_get_boolean (const t3rt_value_t boolean_value, 
                        t3rt_context_t context);



/*
 * Extracts a string from the string value
 */

const char*
t3rt_value_get_string (const t3rt_value_t string_value, 
                       t3rt_context_t context);


/*
 * Extracts a wide string from the universal string value
 */

t3rt_wide_string_t
t3rt_value_get_universal_charstring (const t3rt_value_t string_value, 
                                     t3rt_context_t context);


/*
 * Extracts a character from the character value
 */

char
t3rt_value_get_char (const t3rt_value_t char_value, 
                     t3rt_context_t context);

/*
 * Extracts a wide character from the universal character value
 */

const t3rt_wide_char_t *
t3rt_value_get_universal_char (const t3rt_value_t universal_char_value, 
                               t3rt_context_t context);


/*
 * Extracts a binary string from the binary string value
 */

t3rt_binary_string_t
t3rt_value_get_binary_string (const t3rt_value_t string_value, 
                              t3rt_context_t context);


/*
 * Extracts a verdict from the verdict value
 */

t3rt_verdict_t
t3rt_value_get_verdict (const t3rt_value_t verdict_value, 
                        t3rt_context_t context);


/*
 * Extracts the underlying value from the address value. 
 * 
 */

t3rt_value_t
t3rt_value_get_address_value(const t3rt_value_t address_value, 
                             t3rt_context_t context);


/*
 * Extracts the address from the port value
 */

t3rt_binary_string_t
t3rt_value_get_port_address (const t3rt_value_t port_value, 
                             t3rt_context_t context);


/*
 * Extracts an external value
 */

void *
t3rt_value_get_external_value (const t3rt_value_t external_value, 
                               t3rt_context_t context);



unsigned long
t3rt_value_get_objectid_element (t3rt_value_t objectid_value,
                                 unsigned long index,
                                 t3rt_context_t context);



/* Check */


/*
 * This verifies that the value fulfills the restrictions of its type. 
 * Calls the 't3rt_type_check' function.
 */

t3rt_boolean_t
t3rt_value_check (t3rt_value_t value, 
                  t3rt_context_t context);


/* Printout functions for values. */


t3rt_wide_string_t
t3rt_value_to_wide_string (t3rt_value_t val, t3rt_context_t ctx);

const char *
t3rt_value_to_string (t3rt_value_t val, t3rt_context_t ctx);


const char *
t3rt_verdict_string(t3rt_verdict_t verdict);


#ifdef __cplusplus
}
#endif

#endif

/* End of File */

