/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_values_predefined.h
 */

/*
$Id: t3rts_values_predefined.h,v 2.19 2007/03/23 09:19:55 x-rupaya Exp $
*/

#ifndef __t3rts_values_predefined_h
#define __t3rts_values_predefined_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts_common.h"
 
#include "t3rts_values_general.h"
#include "t3rts_widestrings.h"
#include "t3rts_memory.h"


/* FP Support operations */

void
t3rt_set_epsilon_double (double epsilon, t3rt_context_t context);

double
t3rt_epsilon_double (t3rt_context_t context);


/* Predefined operators */


t3rt_long_integer_t
t3rt_mod(t3rt_long_integer_t x, t3rt_long_integer_t y, t3rt_context_t ctx);


t3rt_long_integer_t
t3rt_rem(t3rt_long_integer_t x, t3rt_long_integer_t y, t3rt_context_t ctx);


/*
 * Returns a newly created string value that contains concatenated string. 
 * The requirement for concatenation is that the two string have to be of 
 * the same type kind. The type of the resulting value is based on this 
 * type kind. So, if two hexstrings are concatenated and they are of type 
 * T1 and T2 respectively, the result will be a string of type hexstring.
 */

t3rt_value_t
t3rt_concatenate (t3rt_value_t string1, 
                  t3rt_value_t string2, 
                  t3rt_alloc_strategy_t strategy, 
                  t3rt_context_t ctx);


t3rt_boolean_t
t3rt_is_equal (t3rt_value_t value1, 
               t3rt_value_t value2, 
               t3rt_context_t ctx);

t3rt_boolean_t
t3rt_is_greater (t3rt_value_t value1, 
                 t3rt_value_t value2, 
                 t3rt_context_t ctx);

t3rt_boolean_t
t3rt_is_lesser (t3rt_value_t value1, 
                t3rt_value_t value2, 
                t3rt_context_t ctx);

t3rt_value_t
t3rt_not4b (t3rt_value_t string, 
            t3rt_alloc_strategy_t strategy, 
            t3rt_context_t ctx);


t3rt_value_t
t3rt_and4b (t3rt_value_t string1, 
            t3rt_value_t string2,  
            t3rt_alloc_strategy_t strategy, 
            t3rt_context_t ctx);


t3rt_value_t
t3rt_or4b (t3rt_value_t string1, 
           t3rt_value_t string2, 
           t3rt_alloc_strategy_t strategy, 
           t3rt_context_t ctx);


t3rt_value_t
t3rt_xor4b (t3rt_value_t string1, 
            t3rt_value_t string2, 
            t3rt_alloc_strategy_t strategy, 
            t3rt_context_t ctx);


t3rt_value_t
t3rt_rotateleft (t3rt_value_t string, 
                 unsigned long count, 
                 t3rt_alloc_strategy_t strategy, 
                 t3rt_context_t ctx);


t3rt_value_t
t3rt_rotateright (t3rt_value_t string, 
                  unsigned long count, 
                  t3rt_alloc_strategy_t strategy, 
                  t3rt_context_t ctx);



t3rt_value_t
t3rt_shiftleft (t3rt_value_t value, 
                unsigned long count, 
                t3rt_alloc_strategy_t strategy, 
                t3rt_context_t ctx);


t3rt_value_t
t3rt_shiftright (t3rt_value_t value, 
                 unsigned long count, 
                 t3rt_alloc_strategy_t strategy, 
                 t3rt_context_t ctx);



/* Predefined functions */


t3rt_value_t
t3rt_int2char (t3rt_value_t int_value, 
               t3rt_alloc_strategy_t strategy, 
               t3rt_context_t ctx);

/* Same as 't3rt_int2char' but return value is a string with 1 element */
t3rt_value_t
t3rt_int2charstr (t3rt_value_t int_value, 
                  t3rt_alloc_strategy_t strategy, 
                  t3rt_context_t ctx);

t3rt_value_t
t3rt_char2int (t3rt_value_t char_value, 
               t3rt_alloc_strategy_t strategy, 
               t3rt_context_t ctx);


t3rt_value_t
t3rt_int2unichar (t3rt_value_t int_value, 
                  t3rt_alloc_strategy_t strategy, 
                  t3rt_context_t ctx);

/* Same as 't3rt_int2charstr' but return value is a string with 1 element */
t3rt_value_t
t3rt_int2unicharstr (t3rt_value_t int_value, 
                     t3rt_alloc_strategy_t strategy, 
                     t3rt_context_t ctx);

t3rt_value_t
t3rt_unichar2int (t3rt_value_t wide_char_value, 
                  t3rt_alloc_strategy_t strategy, 
                  t3rt_context_t ctx);


t3rt_value_t
t3rt_bit2int (t3rt_value_t bitstring, 
              t3rt_alloc_strategy_t strategy, 
              t3rt_context_t ctx);


t3rt_value_t
t3rt_hex2int (t3rt_value_t hexstring, 
              t3rt_alloc_strategy_t strategy, 
              t3rt_context_t ctx);


t3rt_value_t
t3rt_oct2int (t3rt_value_t octetstring, 
              t3rt_alloc_strategy_t strategy, 
              t3rt_context_t ctx);

/* Passing string that doesn't represent valid integer results in run-time error */
t3rt_value_t
t3rt_str2int (t3rt_value_t charstring, 
              t3rt_alloc_strategy_t strategy, 
              t3rt_context_t ctx);

/* Same as 't3rt_str2int' but returns zero for invalid integer string */
t3rt_value_t
t3rt_str2int_zero (t3rt_value_t charstring, 
                   t3rt_alloc_strategy_t strategy, 
                   t3rt_context_t ctx);

t3rt_value_t
t3rt_int2bit (t3rt_value_t int_value, 
              unsigned long length, 
              t3rt_alloc_strategy_t strategy, 
              t3rt_context_t ctx);


t3rt_value_t
t3rt_int2hex (t3rt_value_t int_value, 
              unsigned long length, 
              t3rt_alloc_strategy_t strategy, 
              t3rt_context_t ctx);


t3rt_value_t
t3rt_int2oct (t3rt_value_t int_value, 
              unsigned long length, 
              t3rt_alloc_strategy_t strategy, 
              t3rt_context_t ctx);


t3rt_value_t
t3rt_int2str (t3rt_value_t int_value, 
              t3rt_alloc_strategy_t strategy, 
              t3rt_context_t ctx);


t3rt_value_t
t3rt_bit2str(t3rt_value_t bitstring, 
             t3rt_alloc_strategy_t strategy, 
             t3rt_context_t ctx);

t3rt_value_t
t3rt_hex2str(t3rt_value_t hexstring, 
             t3rt_alloc_strategy_t strategy, 
             t3rt_context_t ctx);

t3rt_value_t
t3rt_oct2str(t3rt_value_t octetstring, 
             t3rt_alloc_strategy_t strategy, 
             t3rt_context_t ctx);

t3rt_value_t
t3rt_str2oct(t3rt_value_t charstring, 
             t3rt_alloc_strategy_t strategy, 
             t3rt_context_t ctx);

t3rt_value_t
t3rt_oct2char(t3rt_value_t octetstring, 
              t3rt_alloc_strategy_t strategy, 
              t3rt_context_t ctx);

t3rt_value_t
t3rt_char2oct(t3rt_value_t charstring, 
              t3rt_alloc_strategy_t strategy, 
              t3rt_context_t ctx);

t3rt_value_t
t3rt_bit2hex(t3rt_value_t bitstring, 
             t3rt_alloc_strategy_t strategy, 
             t3rt_context_t ctx);

t3rt_value_t
t3rt_hex2oct(t3rt_value_t hexstring, 
             t3rt_alloc_strategy_t strategy, 
             t3rt_context_t ctx);

t3rt_value_t
t3rt_bit2oct(t3rt_value_t bitstring, 
             t3rt_alloc_strategy_t strategy, 
             t3rt_context_t ctx);

t3rt_value_t
t3rt_hex2bit(t3rt_value_t hexstring, 
             t3rt_alloc_strategy_t strategy, 
             t3rt_context_t ctx);

t3rt_value_t
t3rt_oct2hex(t3rt_value_t octetstring, 
             t3rt_alloc_strategy_t strategy, 
             t3rt_context_t ctx);

t3rt_value_t
t3rt_oct2bit(t3rt_value_t octetstring, 
             t3rt_alloc_strategy_t strategy, 
             t3rt_context_t ctx);

t3rt_value_t
t3rt_int2float(t3rt_value_t int_value, 
               t3rt_alloc_strategy_t strategy, 
               t3rt_context_t ctx);

t3rt_value_t
t3rt_float2int(t3rt_value_t float_value, 
               t3rt_alloc_strategy_t strategy, 
               t3rt_context_t ctx);

/* Passing string that doesn't represent valid float results in run-time error */
t3rt_value_t
t3rt_str2float(t3rt_value_t str_value, 
               t3rt_alloc_strategy_t strategy, 
               t3rt_context_t ctx);

/* Same as 't3rt_str2float' but returns zero for invalid float string */
t3rt_value_t
t3rt_str2float_zero(t3rt_value_t str_value, 
                    t3rt_alloc_strategy_t strategy, 
                    t3rt_context_t ctx);

t3rt_value_t
t3rt_enum2int(t3rt_value_t enum_value,
              t3rt_alloc_strategy_t strategy, 
              t3rt_context_t ctx);
                    
t3rt_value_t
t3rt_rnd(t3rt_value_t seed_value, /* t3rt_no_value_c for system seed */
         t3rt_alloc_strategy_t strategy, 
         t3rt_context_t ctx);

t3rt_value_t
t3rt_substr(t3rt_value_t string_value, 
            unsigned long index, 
            unsigned long return_count, 
            t3rt_alloc_strategy_t strategy, 
            t3rt_context_t ctx);

t3rt_value_t
t3rt_decomp(t3rt_value_t objid_value, 
            unsigned long index, 
            unsigned long return_count, 
            t3rt_alloc_strategy_t strategy, 
            t3rt_context_t ctx);

t3rt_value_t
t3rt_replace(t3rt_value_t string_value, 
             unsigned long index, 
             unsigned long return_count, 
             t3rt_value_t str_replace_with,
             t3rt_alloc_strategy_t strategy, 
             t3rt_context_t ctx);
            

/*
 * This will call the 't3rt_value_string_length' function
 */

unsigned long
t3rt_lengthof (t3rt_value_t string, t3rt_context_t ctx);


/*
 * For template values, this function returns sizeof(valueof(value)), 
 * if valueof(value) is defined. 
 */ 

unsigned long
t3rt_sizeof (t3rt_value_t structured_value, t3rt_context_t ctx);

/*
 * Returns upper boundary index for constraint recordof/setof types
 */ 

unsigned long
t3rt_sizeoftype (t3rt_value_t structured_value, t3rt_context_t ctx);



/*
 * Builds and returns the unique dynamic template value defined by the template value
 */

t3rt_value_t
t3rt_templateof (t3rt_value_t template_value, 
               t3rt_alloc_strategy_t strategy, 
               t3rt_context_t context);

/*
 * Builds and returns the unique value defined by the template value
 */

t3rt_value_t
t3rt_valueof (t3rt_value_t template_value, 
              t3rt_alloc_strategy_t strategy, 
              t3rt_context_t context);


t3rt_value_t
t3rt_valueof_signature (t3rt_value_t signature_template_value,
                        t3rt_alloc_strategy_t strategy,
                        t3rt_boolean_t is_call,
                        t3rt_context_t ctx);

t3rt_boolean_t
t3rt_match_continue_on_fail (t3rt_boolean_t default_value,
                             t3rt_context_t ctx);

/*
 * Checks the value against the type defined by the 'template value's 
 * type and its actual parameters. Calls the 't3rt_type_check' function. 
 */

t3rt_boolean_t
t3rt_match (t3rt_value_t template_value, 
            t3rt_value_t value, 
            t3rt_context_t context);

            
/* 
 * matching function for signature templates 
 */

t3rt_boolean_t 
t3rt_match_signature(t3rt_value_t template_value, /* Signature template value */
                     t3rt_value_t value, 
                     t3rt_boolean_t is_call, 
                     t3rt_context_t context);


/* 
 * matching helper function for record of matches with '*' symbol 
 * 'length_constraint" is used ONLY to restrict the length of AnyElementOrNone (*)
 */

t3rt_boolean_t
t3rt_recordof_match(t3rt_value_t value, 
                    t3rt_value_t templates[], 
                    t3rt_permutation_kind_t permutation_kind[], 
                    t3rt_length_constraint_t length_constraint[], 
                    t3rt_context_t ctx);

/* 
 * matching helper function for set of matches
 * length constraint is used ONLY to restrict the length of AnyElementOrNone (*) 
 */

t3rt_boolean_t
t3rt_setof_match(t3rt_value_t value, 
                 t3rt_value_t templates[], 
                 t3rt_length_constraint_t length_constraint[], 
                 t3rt_context_t ctx);

/*
 * matching helper funciton for subset match
 */

t3rt_boolean_t
t3rt_subset_match(t3rt_value_t value, t3rt_value_t templates[], t3rt_context_t ctx);

/*
 * matching helper funciton for superset match
 */

t3rt_boolean_t
t3rt_superset_match(t3rt_value_t value, t3rt_value_t templates[], t3rt_context_t ctx);



/*
 * Checks if indicated field is present in the value (not omitted)
 */

t3rt_boolean_t
t3rt_ispresent (t3rt_value_t record_or_set_value, 
                unsigned long field_index, 
                t3rt_context_t context);


/*
 * Checks if indicated alternative in the union value is selected
 */

t3rt_boolean_t
t3rt_ischosen (t3rt_value_t union_value, 
               unsigned long alt_index, 
               t3rt_context_t context);

/*
 * Checks if indicated value is completely initialized and resolves to specific value
 */

t3rt_boolean_t
t3rt_isvalue (t3rt_value_t value, 
              t3rt_context_t context);

/* C.38
 * Encode specific value and return bitstring
 */

t3rt_value_t t3rt_encvalue (t3rt_value_t value, 
          t3rt_alloc_strategy_t strategy,
          t3rt_context_t context);

/* C.39
 * Decode bitstring and store it in value.
- The return value 0 indicates that decoding was successful.
- The return value 1 indicates an unspecified cause of decoding failure.
- The return value 2 indicates that decoding could not be completed as encoded_value did not contain enough bits.
 */

t3rt_value_t t3rt_decvalue (t3rt_value_t bitstring,
          t3rt_value_t value,
          t3rt_alloc_strategy_t strategy,
          t3rt_context_t context);

/*
 * Logs the string value on the info log channel as a ttcn3 messgage
 */

void
t3rt_log (t3rt_value_t char_string, t3rt_context_t ctx);

#ifdef __cplusplus
}
#endif

#endif

/* End of File */
