/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_widestrings.h
 */

#ifndef __t3rts_widestrings_h
#define __t3rts_widestrings_h

#ifdef __cplusplus
extern "C" {
#endif

#define  t3rt_wide_char_size_c     4        /* Number of bytes per wide character. */

typedef  unsigned char   t3rt_wide_char_t [t3rt_wide_char_size_c];


typedef struct t3rt__wide_string_struct_internal_t *t3rt_wide_string_t; 

#include "t3rts_common.h"
#include "t3rts_memory.h" 
#include "t3rts_context_decl.h"


/* 
 * Converts wide character content into the corresponding integer code number (ISO-10646)
 */

void
t3rt_wchar2int (const t3rt_wide_char_t wchar, 
                unsigned long * wchar_code,
                t3rt_context_t context);

/* 
 * Converts wide character content into the corresponding quadruple
 */

void
t3rt_wchar2quad (const t3rt_wide_char_t wchar, 
                 unsigned char * group,
                 unsigned char * plane,
                 unsigned char * row,
                 unsigned char * cell,
                 t3rt_context_t context);

/* 
 * Converts character (ISO-646) into the wide character content (ISO-10646)
 */

void
t3rt_char2wchar (char char_code,
                 t3rt_wide_char_t * wchar, 
                 t3rt_context_t context);


/* 
 * Converts integer code number (ISO-10646) into the wide character content
 */

void
t3rt_int2wchar (unsigned long wchar_code,
                t3rt_wide_char_t * wchar, 
                t3rt_context_t context);

/* 
 * Converts quadruple into the wide character content
 */

void
t3rt_quad2wchar (unsigned char group,
                 unsigned char plane,
                 unsigned char row,
                 unsigned char cell,
                 t3rt_wide_char_t * wchar, 
                 t3rt_context_t context);


/*
 * Compare two wide char characters
 */

int
t3rt_wchar_cmp(const t3rt_wide_char_t wchar1,
	       const t3rt_wide_char_t wchar2,
	       t3rt_context_t context);


                 	       
/* 
 * Creates an empty wide string and preallocates space for the given length
 * 
 * The alloc_size is given in "number of wide characters". 
 */

t3rt_wide_string_t 
t3rt_wide_string_allocate (t3rt_alloc_strategy_t strategy, 
                           unsigned long alloc_size,
                           t3rt_context_t context); 


/*
 * Deallocates the wide string
 */

void
t3rt_wide_string_deallocate (t3rt_wide_string_t * wstring,
                             t3rt_context_t context);


/*
 * Constructs a wide string out of the null terminated ASCII string
 */

t3rt_wide_string_t
t3rt_wide_string_construct_from_ascii (const char * ascii_string, 
                                       t3rt_alloc_strategy_t strategy,
                                       t3rt_context_t context); 


/*
 * Constructs a single character wide string out of a wide character
 */

t3rt_wide_string_t
t3rt_wide_string_construct_from_wchar(const t3rt_wide_char_t character,
                                      t3rt_alloc_strategy_t strategy,
                                      t3rt_context_t context);

/*
 * Sets the contents of the wide string to a copy of the character array 
 * of given length
 */

void
t3rt_wide_string_set (t3rt_wide_string_t wstring, 
                      unsigned long length, 
                      const t3rt_wide_char_t value[],
                      t3rt_context_t context);


/*
 * Sets the contents of the wide string to a copy of the null-terminated 
 * character string
 */

void
t3rt_wide_string_set_ascii (t3rt_wide_string_t wstring, 
                            const char * ascii_string,
                            t3rt_context_t context);


/*
 * Sets the contents of the wide string to a copy of the array of wide chars
 */

void
t3rt_wide_string_set_wchar_array(t3rt_wide_string_t wstring,
                                 const t3rt_wide_char_t * string,
                                 unsigned long length,
                                 t3rt_context_t context);


/*
 * Makes a copy of the wide string
 */

t3rt_wide_string_t
t3rt_wide_string_copy (t3rt_wide_string_t wstring, 
                       t3rt_alloc_strategy_t strategy,
                       t3rt_context_t context);



/*
 * Returns the number of the wide characters in the wide string
 */

unsigned long
t3rt_wide_string_length (t3rt_wide_string_t wstring,
                         t3rt_context_t context);


/*
 * Compares two wide strings for equality
 */

t3rt_boolean_t 
t3rt_wide_string_is_equal (t3rt_wide_string_t wstring1, 
                           t3rt_wide_string_t wstring2,
                           t3rt_context_t context);


/*
 * Returns the actual character array of the wide string
 */

const t3rt_wide_char_t *
t3rt_wide_string_content (t3rt_wide_string_t wstring,
                          t3rt_context_t context);




/*
 * Appends the appwstr to the wide string
 */

void
t3rt_wide_string_append (t3rt_wide_string_t wstring, 
                         t3rt_wide_string_t appwstr,
                         t3rt_context_t context);



/*
 * Assigns the src wide string to the dest wide string
 */

void
t3rt_wide_string_assign (t3rt_wide_string_t dest, 
                         const t3rt_wide_string_t src,
                         t3rt_context_t context);


/*
 * Makes a left-rotated copy of the wide string
 */

t3rt_wide_string_t
t3rt_wide_string_rotateleft (t3rt_wide_string_t wstring, 
                             unsigned long char_count,
                             t3rt_alloc_strategy_t strategy,
                             t3rt_context_t context);

/*
 * Makes a right-rotated copy of the wide string
 */

t3rt_wide_string_t
t3rt_wide_string_rotateright (t3rt_wide_string_t wstring, 
                              unsigned long char_count,
                              t3rt_alloc_strategy_t strategy,
                              t3rt_context_t context);

/*
 * This function sets the wide character at the specified index position
 * Character at that position will be overwritten. 
 */

void
t3rt_wide_string_set_element (t3rt_wide_string_t wstring, 
                              unsigned long index,
                              const t3rt_wide_char_t wchar,
                              t3rt_context_t context);

/*
 * This function sets the wide character, which corresponds to the specified ASCII
 * character, at the specified index position
 * Character at that position will be overwritten. 
 */

void
t3rt_wide_string_set_element_to_ascii_char (t3rt_wide_string_t wstring, 
                                            unsigned long index,
                                            char chr,
                                            t3rt_context_t context);

/*
 * This function returns the wide character at the specified index position
 *
 * 'wchar' has to be allocated by the caller.
 * Content of 'wchar' will be overwritten. 
 */

void
t3rt_wide_string_element (const t3rt_wide_string_t wstring, 
                          unsigned long index,
                          t3rt_wide_char_t * wchar,
                          t3rt_context_t context);


/***********************************************************************
 * Support for the parametrized wide string formatting
 ***********************************************************************/

/****************************************************************************
 *  Main formatting function that drives the conversion process and invokes
 * support functions. Format string is represented by the ASCII string.
 ****************************************************************************/

t3rt_wide_string_t
t3rt_format_char_string (const char * fmt_cstring, 
                         t3rt_context_t context, 
                         ...);

/****************************************************************************
 *  Main formatting function that drives the conversion process and invokes
 * support functions. Format string is represented by the wide string.
 ****************************************************************************/

t3rt_wide_string_t
t3rt_format_wide_string (const t3rt_wide_string_t fmt_wstring, 
                         t3rt_context_t context, 
                         ...);


#ifdef __cplusplus
}
#endif

#endif

/* End of File */

