/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: t3rts_xml_log.h
 */
 
#ifndef __t3rts_xml_logging_h
#define __t3rts_xml_logging_h

#ifdef __cplusplus
extern "C" {
#endif

/*           XML log mechanism registration              */

/*
 * t3rt_register_xml_log_mechanism
 * 
 * This function may be used to register XML log mechanism with user-provided handlers
 * for processing XML data.
 *
 * pInitFunc -     Valid pointer to a function (MUST NOT be NULL).
 *                 This function is called during XML log mechanism initialization and intended to open
 *                 necessary file descriptors, create semaphores, establish socket connections, etc
 *                 Buffer length is provided too (buffer is not NULL-terminated).
 *
 * pFinalizeFunc - Valid pointer to a function (MUST NOT be NULL).
 *                 This function is called during XML log mechanism finalization and intended to close
 *                 any opened file descriptors, destroy semaphores, etc.
 *                 Buffer length is provided too (buffer is not NULL-terminated).
 *
 * pEventFunc -    Valid pointer to a function (MUST NOT be NULL).
 *                 This function is called for every event and provides buffer with XML data describing this event,
 *                 Buffer length is provided too (buffer is not NULL-terminated).
 *                 This function MUST be thread safe.
 */

extern 
void t3rt_register_xml_log_mechanism(void (*pInitFunc)(const char *xmlLogHeader, unsigned long headerSize, t3rt_context_t ctx),
                                     void (*pEventFunc)(const char *xmlEventData, unsigned long dataSize, t3rt_context_t ctx),
                                     void (*pFinalizeFunc)(const char *xmlLogFooter, unsigned long footerSize));

#ifdef __cplusplus
}
#endif

#endif
