/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/**************************************************************************
 * File Name: t3tri.h
 */

/*
 * C-mapping issues:
 *
 * TriEnqueueCall -> triEnqueueCall
 * TriStatus      -> TriStatus
 * TRI_ERROR      -> TRI_Error
 *
 */

#ifndef _t3tri_h
#define _t3tri_h

#ifdef __cplusplus
extern "C" {
#endif

#define TRI_Error -1
#define TRI_OK     0 /* All negative values are reserved for future extension of TRI functionality.*/

/*  data is a non-null-terminated string. 
 *  bits is the number of bits used in data. bits value -1 is used to denote omitted value.
 *	The aux field is for future extensibility of TRI functionality.
 */
typedef struct _BinaryString
{  
  unsigned char*    data;  
  long int          bits;  
  void*             aux;
} BinaryString;


/* 	The moduleName and objectName fields are the TTCN-3 identifiers literally.
 *  The aux field is for future extensibility of TRI functionality.
 */
typedef struct _QualifiedName
{
  char* moduleName;
  char* objectName;
  void* aux;
} QualifiedName;


typedef BinaryString  TriActionTemplate;
typedef BinaryString  TriAddress;
typedef BinaryString  TriException;
typedef QualifiedName TriFunctionId;
typedef BinaryString  TriMessage;
typedef QualifiedName TriSignatureId;
typedef QualifiedName TriTestCaseId;
typedef double        TriTimerDuration;
typedef BinaryString  TriTimerId; /* Note: Pending ETSI statement on timer
                                     and snapshot semantics may influence
                                     future representation! */
typedef long          TriStatus;

/*  No special values mark the end of addrList[]. The length field shall be used 
 *  to traverse this array properly.
 */
typedef struct _TriAddressList
  {
    TriAddress** addrList;
    long int length;
  } TriAddressList;

/*compInst is for component instance.*/
typedef struct _TriComponentId
{
  BinaryString  compInst;
  char*         compName;
  QualifiedName compType;
} TriComponentId;

/*  No special values mark the end of compIdList[]. The length field shall be used 
 *  to traverse this array properly.
 */
typedef struct _TriComponentIdList
  {
    TriComponentId** compIdList;
    long int length;
  } TriComponentIdList;  

typedef enum
{
  TRI_IN    = 0,
  TRI_INOUT = 1,
  TRI_OUT   = 2
} TriParameterPassingMode;

typedef struct _TriParameter
{
  BinaryString            par;
  TriParameterPassingMode mode;
} TriParameter;

/*  No special values mark the end of parList[]. The length field shall be used
 *  to traverse this array properly.
 */
typedef struct _TriParameterList
{
  TriParameter **parList;
  long int       length;
} TriParameterList;


/*  compInst is for component instance. For a singular (non-array) declaration,
 *  the portIndex value should be -1. The aux field is for future extensibility
 *  of TRI functionality.
 */
typedef struct _TriPortId
{
  TriComponentId compInst;
  char*          portName;
  long int       portIndex;
  QualifiedName  portType;
  void*          aux;
} TriPortId;


/*  No special values mark the end of portIdList[]. The length field shall be
 *  used to traverse this array properly.
 */
typedef struct _TriPortIdList
{
  TriPortId **portIdList;
  long int    length;
} TriPortIdList;


void 
triEnqueueMsg (const TriPortId      *tsiPortId, 
               const TriAddress     *sutAddress,
               const TriComponentId *componentId, 
               const TriMessage     *receivedMessage);

void
triEnqueueCall (const TriPortId        *tsiPortId,
                const TriAddress       *sutAddress,
                const TriComponentId   *componentId,
                const TriSignatureId   *signatureId,
                const TriParameterList *parameterList);


void 
triEnqueueReply (const TriPortId        *tsiPortId,
                 const TriAddress       *sutAddress,
                 const TriComponentId   *componentId,
                 const TriSignatureId   *signatureId,
                 const TriParameterList *parameterList,
                 const TriParameter     *returnValue);


void 
triEnqueueException (const TriPortId      *tsiPortId,
                     const TriAddress     *sutAddress,
                     const TriComponentId *componentId,
                     const TriSignatureId *signatureId,
                     const TriException   *exception);


void 
triTimeout (const TriTimerId *timerId);



/**************************************************************************
 *
 * TE -> SA
 *
 * Function to be implemented by the SUT Adaptor
 *
 */

extern TriStatus 
triSAReset (void);

extern TriStatus 
triExecuteTestcase (const TriTestCaseId *testCaseId,  
                    const TriPortIdList *tsiPortList);

extern TriStatus
triEndTestcase (void);

extern TriStatus 
triMap  (const TriPortId *compPortId,  
         const TriPortId *tsiPortId);

extern TriStatus 
triUnmap (const TriPortId *compPortId, 
          const TriPortId *tsiPortId);


extern TriStatus 
triSend (const TriComponentId *componentId, 
         const TriPortId      *tsiPortId, 
         const TriAddress     *sutAddress, 
         const TriMessage     *sendMessage);

extern TriStatus 
triSendMC (const TriComponentId *componentId,
           const TriPortId      *tsiPortId,
           const TriAddressList *sutAddresses,
           const TriMessage     *sendMessage);

extern TriStatus
triSendBC (const TriComponentId *componentId,
           const TriPortId      *tsiPortId,
           const TriMessage     *sendMessage);

extern TriStatus 
triCall (const TriComponentId   *componentId, 
         const TriPortId        *tsiPortId,  
         const TriAddress       *sutAddress,  
         const TriSignatureId   *signatureId,  
         const TriParameterList *parameterList);

extern TriStatus
triCallMC (const TriComponentId   *componentId,
           const TriPortId        *tsiPortId, 
           const TriAddressList   *sutAddresses, 
           const TriSignatureId   *signatureId, 
           const TriParameterList *parameterList);

extern TriStatus
triCallBC (const TriComponentId   *componentId,
           const TriPortId        *tsiPortId,
           const TriSignatureId   *signatureId,
           const TriParameterList *parameterList);

extern TriStatus 
triReply (const TriComponentId    *componentId, 
          const TriPortId         *tsiPortId,  
          const TriAddress        *sutAddress,  
          const TriSignatureId    *signatureId,  
          const TriParameterList  *parameterList,  
          const TriParameter      *returnValue);

extern TriStatus 
triReplyMC (const TriComponentId   *componentId,
            const TriPortId        *tsiPortId,
            const TriAddressList   *sutAddresses,
            const TriSignatureId   *signatureId,
            const TriParameterList *parameterList,
            const TriParameter     *returnValue);

extern TriStatus
triReplyBC (const TriComponentId   *componentId,
            const TriPortId        *tsiPortId,
            const TriSignatureId   *signatureId,
            const TriParameterList *parameterList,
            const TriParameter     *returnValue);

extern TriStatus
triRaise (const TriComponentId  *componentId,
          const TriPortId       *tsiPortId,
          const TriAddress      *sutAddress,
          const TriSignatureId  *signatureId,
          const TriException    *exception);

extern TriStatus
triRaiseMC (const TriComponentId *componentId,
            const TriPortId      *tsiPortId,
            const TriAddressList *sutAddresses,
            const TriSignatureId *signatureId,
            const TriException   *exception);

extern TriStatus
triRaiseBC (const TriComponentId *componentId,
            const TriPortId      *tsiPortId,
            const TriSignatureId *signatureId,
            const TriException   *exception);

extern TriStatus 
triSUTActionInformal (char* description);


extern TriStatus 
triSUTActionTemplate (const TriActionTemplate* templateValue);


/**************************************************************************
 *
 * TE -> PA
 *
 * Function to be implemented by the Platform Adaptor
 *
 */

extern TriStatus
triPAReset (void);


extern TriStatus
triStartTimer (const TriTimerId *timerId,
               TriTimerDuration  timerDuration);


extern TriStatus
triStopTimer (const TriTimerId *timerId);


extern TriStatus 
triReadTimer (const TriTimerId *timerId,
              TriTimerDuration *elapsedTime);


extern TriStatus
triTimerRunning (const TriTimerId *timerId,
                 unsigned char    *running);


extern TriStatus 
triExternalFunction (const TriFunctionId *functionId,		     
                     TriParameterList    *parameterList,
                     TriParameter        *returnValue);

#ifdef __cplusplus
}
#endif

#endif

