/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: tci_cd_required.h
 *
 * Description:
 *      This file declares TCI CD required functions
 */
 
#ifndef __tci_cd_required_h
#define __tci_cd_required_h

#ifdef __cplusplus
extern "C" {
#endif

#include "tci_conditional.h"


                                              /* TCI-CD operations required from TE */

/* Type getTypeForName (in String typeName)
 * Returns a type representing a TTCN-3 type. 
 * Predefined TTCN-3 types can be retrieved from the TE by using the TTCN-3 keywords for the predefined types. 
 * In this case typeName denotes to the basic TTCN-3 type like "charstring", "bitstring" etc. 
 * Returns the distinct value null if the requested type can not be returned. 
 * Note that the anytype and address can not be obtained with module set to null. 
 * Although they are predefined types they might be distinct between modules. 
 * For example, address can either be the unmodified predefined type, or a user-defined type in a module. 
 * Other predefined types can not be redefined.
 *
 * typeName has to be the fully qualified type name, i.e. module.typeName
*/
TciType T3TCI(tciGetTypeForName) (IDL_ATTRIB(in) String typeName);

/* Type getInteger()	
 * Constructs and returns a basic TTCN-3 integer type.
*/
TciType T3TCI(tciGetIntegerType) ();	

/* Type getFloat()	
 * Constructs and returns a basic TTCN-3 float type.
*/
TciType T3TCI(tciGetFloatType) ();

/* Type getBoolean()	
 * Constructs and returns a basic TTCN-3 boolean type.
*/
TciType T3TCI(tciGetBooleanType) ();

/* Type getChar()	
 * Constructs and returns a basic TTCN-3 char type.
*/
TciType T3TCI(tciGetCharType) ();	

/* Type getUniversalChar()	
 * Constructs and returns a basic TTCN-3 universal char type.
*/
TciType T3TCI(tciGetUniversalCharType) ();	

/* Type getObjid()	
 * Constructs and returns a basic TTCN-3 object id type.
*/
TciType T3TCI(tciGetTciObjidType) ();

/* Type getCharstring()
 * Constructs and returns a basic TTCN-3 charstringtype.
*/
TciType T3TCI(tciGetTciCharstringType) ();
	
/* Type getUniversalCharstring()	
 * Constructs and returns a basic TTCN-3 universal charstring type.
*/
TciType T3TCI(tciGetUniversalCharstringType) ();

/* Type getHexstring()
 * Constructs and returns a basic TTCN-3 hexstring type.
*/
TciType T3TCI(tciGetHexstringType) ();
	
/* Type getBitstring()	
 * Constructs and returns a basic TTCN-3 bitstring type.
*/
TciType T3TCI(tciGetBitstringType) ();
	
/* Type getOctetstring()	
 * Constructs and returns a basic TTCN-3 octetstring type.
*/
TciType T3TCI(tciGetOctetstringType) ();
	
/* Type getVerdict()	
 * Constructs and returns a basic TTCN-3 verdict type.
*/  
TciType T3TCI(tciGetVerdictType) ();

/* void tciErrorReq(in String message)	
 * The TE will be notified about an unrecoverable error situation within the CD 
 * and forward the error indication to the test management
*/
void T3TCI(tciErrorReq) (IDL_ATTRIB(in) String message);	

#ifdef __cplusplus
}
#endif

#endif
