/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: tci_data.h
 *
 * Description:
 *      This file declares TCI data structures used in various
 *      TCI functions
 */
 
#ifndef __tci_data_h
#define __tci_data_h

#ifdef __cplusplus
extern "C" {
#endif

#include "tci_conditional.h"


typedef struct t3rt_type_struct_internal_t *TciType;
typedef struct tci__value_internal *TciValue;
typedef struct tci__template_internal *TciValueTemplate;
typedef struct tci__template_internal *TciNonValueTemplate;


/* 
 * TciValueList
 * A value of TciValueList is a sequence of TciValue objects.
*/

typedef struct _TciValueList
  {
    long int length;
    IDL_ATTRIB(size_is(length))
    TciValue *valueList;
  } *TciValueList;

/*
 * TciModuleIdType	
 * A value of TciModuleIdType is the name of a TTCN-3 module 
 * as specified in the TTCN-3 ATS. This abstract type is used 
 * for module handling
*/

typedef QualifiedName TciModuleIdType;

/* 
 * TciModuleParameterIdType	
 * A value of TciModuleParameterIdType is the qualified name 
 * of a TTCN-3 module parameter as specified in the TTCN-3 ATS. 
 * This abstract type is used for module parameter handling
*/

typedef QualifiedName TciModuleParameterIdType;

/* 
 * TciTestCaseIdType	
 * A value of TciTestCaseIdType is the qualified name 
 * of a TTCN-3 testcase as specified in the TTCN-3 ATS. 
 * This abstract type is used for testcase handling
*/

typedef QualifiedName TciTestCaseIdType;

/* Note: IBM Rational extension
 * TciTestCaseParameterIdType	
 * A value of TciTestCaseParameterIdType is the name 
 * of a TTCN-3 testcase formal parameter as specified in the TTCN-3 ATS. 
 * This abstract type is used for testcase handling
*/

typedef String TciTestCaseParameterIdType;

/* Note: IBM Rational extension
 * TciTestCaseParameterIdListType	
 * A value of type TciTestCaseParameterIdListType is a list 
 * of TciTestCaseParameterIdType. 
 * This abstract type is used when retrieving the list of test case parameter names 
*/

/* length 0 shall be interpreted as "empty list". */

typedef struct _TciTestCaseParameterIdListType
  {  
    long int length;  
	IDL_ATTRIB(size_is(length))
    TciTestCaseParameterIdType *idList;
  } *TciTestCaseParameterIdListType;	

/* 
 * TciModuleIdListType	
 * A value of type TciModuleIdListType is a list of TciModuleIdType. 
 * This abstract type is used when retrieving the list of modules 
 * which are imported by a TTCN-3 module
*/

/* length 0 shall be interpreted as "empty list" */

typedef struct _TciModuleIdListType
  {  
    long int length;  
	IDL_ATTRIB(size_is(length))
    TciModuleIdType *idList;
  } *TciModuleIdListType;

/* 
 * TciModuleParameterType	
 * A value of type TciModuleParameterType is a structure 
 * of TciModuleParameterIdType and Value. 
 * This abstract type is used to represent the parameter name 
 * and the default value of a module parameter
 */

typedef struct _TciModuleParameterType
  { 
    TciModuleParameterIdType parName;  
    TciValue defaultValue;
  } TciModuleParameterType;

/* 
 * TciModuleParameterListType	
 * A value of type TciModuleParameterListType is a list 
 * of TciModuleParameterType. This abstract type is used 
 * when retrieving the module parameters of a TTCN-3 module
*/

/* length 0 shall be interpreted as "empty list" */

typedef struct _TciModuleParameterListType
  {  
    long int length;
	IDL_ATTRIB(size_is(length))
    TciModuleParameterType *modParList;
  } *TciModuleParameterListType;

/* 
 * TciTestCaseIdListType	
 * A value of type TciTestCaseIdListType is a list of TciTestCaseIdType. 
 * This abstract type is used when retrieving the list of test cases 
 * which are either defined or imported in TTCN-3 root module
*/

/* length 0 shall be interpreted as "empty list". */

typedef struct _TciTestCaseIdListType
  {  
    long int length;  
	IDL_ATTRIB(size_is(length))
    TciTestCaseIdType *idList;
  } *TciTestCaseIdListType;	

/* 
 * TciParameterPassingModeType	
 * A value of type TciParameterPassingModeType is either 
 * IN, INOUT, or OUT. This abstract type is used when starting 
 * a test case or when the termination of a test case is indicated
*/

typedef enum 
  {
    TCI_IN_PAR,  
    TCI_INOUT_PAR,  
    TCI_OUT_PAR
  } TciParameterPassingModeType;

/* 
 * TciParameterType	
 * A value of type TciParameterType includes a TTCN-3 Value 
 * and a value of TciParameterPassingModeType 
 * to represent the parameter passing mode specified 
 * for the parameter in the TTCN-3 ATS
*/

typedef struct _TciParameterType
  {  
    String parName;
    TciParameterPassingModeType parPassMode;  
    TciValue parValue;
  } TciParameterType;

/* TciParameterListType	
 * A value of type TciParameterListType is a list of TciParameterType. 
 * This abstract type is used when starting a test case 
 * or when the termination of a test case is indicated
*/

/* length 0 shall be interpreted as "empty list" */

typedef struct _TciParameterListType
  {  
    long int length;  
	IDL_ATTRIB(size_is(length))
    TciParameterType *parList;
  } *TciParameterListType;

/* 
 * TciParameterTypeType	
 * A value of type TciParameterTypeType is a structure 
 * of Type and TciParameterPassingModeType. 
 * This abstract type is used to represent the type 
 * and the parameter passing mode of a test case parameter
*/

typedef struct _TciParameterTypeType
  {  
    TciParameterPassingModeType parPassMode;  
    TciType parType;
  } TciParameterTypeType;
 
/* 
 * TciParameterTypeListType	
 * A value of type TciParameterTypeListType is a list 
 * of TciParameterTypeType. This abstract type is used 
 * to represent the list of parameters of a test case
*/

/* length 0 shall be interpreted as "empty list" */

typedef struct _TciParameterTypeListType
  {  
    long int length;  
	IDL_ATTRIB(size_is(length))
    TciParameterTypeType *parList;
  } *TciParameterTypeListType;

/* TciTestComponentKindType	
 * A value of type TciParameterListType is a literal 
 * of the set of kinds of TTCN-3 test components, 
 * e.g. MTC, PTC, and CONTROL. This abstract type is used 
 * for component handling
*/

typedef enum
  {  
    TCI_CTRL_COMP,  
    TCI_MTC_COMP,  
    TCI_PTC_COMP,  
    TCI_SYS_COMP,
    TCI_ALIVE_COMP
  } TciTestComponentKindType;

/* The Status Types 
 * The following abstract data types are defined and used for the logging 
 * of component and timer status:
 */

typedef enum 
  {
    inactiveC, 
    runningC,
    stoppedC,
    killedC
  } ComponentStatus;

typedef enum 
  {
    runningT,
    inactiveT, 
    expiredT
  } TimerStatus;

typedef enum 
  {
    startedP,
    haltedP, 
    stoppedP
  } PortStatus;

/* 
 * TciTypeClassType	
 * A value of type TciTypeClassType is a literal 
 * of the set of type classes in TTCN-3 such as 
 * boolean, float, record, etc. This abstract type is used 
 * for value handling
*/

typedef enum
  {  
    TCI_ADDRESS_TYPE,  
    TCI_ANYTYPE_TYPE,  
    TCI_BITSTRING_TYPE,  
    TCI_BOOLEAN_TYPE,  
    TCI_CHAR_TYPE,  
    TCI_CHARSTRING_TYPE,  
    TCI_COMPONENT_TYPE,  
    TCI_ENUMERATED_TYPE,  
    TCI_FLOAT_TYPE,  
    TCI_HEXSTRING_TYPE,  
    TCI_INTEGER_TYPE,  
    TCI_OBJID_TYPE,  
    TCI_OCTETSTRING_TYPE,  
    TCI_RECORD_TYPE,  
    TCI_RECORD_OF_TYPE,  
    TCI_SET_TYPE,  
    TCI_SET_OF_TYPE,  
    TCI_UNION_TYPE,  
    TCI_UNIVERSAL_CHAR_TYPE,  
    TCI_UNIVERSAL_CHARSTRING_TYPE,  
    TCI_VERDICT_TYPE,
    TCI_DEFAULT_TYPE,
    TCI_PORT_TYPE,
    TCI_TIMER_TYPE,
    TCI_TEMPLATE_TYPE
  } TciTypeClassType;

/* 
 * TciSignatureIdType	
 * A value of type TciSignatureIdType is the name 
 * of a procedure signature as specified in the TTCN-3 ATS. 
 * This abstract type is used in procedure based TCI communication operations
*/

typedef QualifiedName TciSignatureIdType;

/* 
 * TciBehaviourIdType	
 * A value of type TciBehaviourIdType identifies a TTCN-3 behaviour functions
*/

typedef QualifiedName TciBehaviourIdType;

/* 
 * TciValueDifference
 * A value of TciValueDifference is a structure containing a value, 
 * a template, and a description for the reason of this difference.
*/

typedef struct _TciValueDifference 
  {
    TciValue val;
    TciValueTemplate tmpl;
    String desc;
  } TciValueDifference;

/* 
 * TciValueDifferenceList
 * A value of TciValueDifferenceList is a sequence of value differences.
*/

typedef struct _TciValueDifferenceList
  {
    long int length;
    IDL_ATTRIB(size_is(length))
    TciValueDifference *diffList;
  } *TciValueDifferenceList;

#ifdef __cplusplus
}
#endif

#endif
