/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: tci_tl_provided.h
 *
 * Description:
 *      This file declares TCI TL provided functions
 */
 
#ifndef __tci_tl_provided_h
#define __tci_tl_provided_h

#ifdef __cplusplus
extern "C" {
#endif

#include "tci_conditional.h"


                                              /* TCI-TL operations provided to TE */

/* tliTcExecute
 * 
 * Shall be called by TE to log the execute test case request.
*/
                                              
void T3TCI(tliTcExecute) (IDL_ATTRIB(in) String am,
                          IDL_ATTRIB(in) long int ts,
                          IDL_ATTRIB(in) String src,
                          IDL_ATTRIB(in) long int line,
                          IDL_ATTRIB(in) TriComponentId c,
                          IDL_ATTRIB(in) TciTestCaseIdType tcId,
                          IDL_ATTRIB(in) TciParameterListType pars,
                          IDL_ATTRIB(in) TriTimerDuration dur);

/* tliTcStart
 * 
 * Shall be called by TE to log the start of a testcase. This event occurs before the testcase is started.
*/
                          
void T3TCI(tliTcStart) (IDL_ATTRIB(in) String am,
                        IDL_ATTRIB(in) long int ts,
                        IDL_ATTRIB(in) String src,
                        IDL_ATTRIB(in) long int line,
                        IDL_ATTRIB(in) TriComponentId c,
                        IDL_ATTRIB(in) TciTestCaseIdType tcId,
                        IDL_ATTRIB(in) TciParameterListType pars,
                        IDL_ATTRIB(in) TriTimerDuration dur);

/* tliTcStop
 * 
 * Shall be called by TE to log the stop of a testcase.
*/
                        
void T3TCI(tliTcStop) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c);

/* tliTcStarted
 * 
 * Shall be called by TM to log the start of a testcase. This event occurs after the testcase was started.
*/
                       
void T3TCI(tliTcStarted) (IDL_ATTRIB(in) String am,
                          IDL_ATTRIB(in) long int ts,
                          IDL_ATTRIB(in) String src,
                          IDL_ATTRIB(in) long int line,
                          IDL_ATTRIB(in) TriComponentId c,
                          IDL_ATTRIB(in) TciTestCaseIdType tcId,
                          IDL_ATTRIB(in) TciParameterListType pars,
                          IDL_ATTRIB(in) TriTimerDuration dur);

/* tliTcTerminated
 * 
 * Shall be called by TM to log the termination of a testcase. This event occurs after the testcase
 * terminated.
*/
                          
void T3TCI(tliTcTerminated) (IDL_ATTRIB(in) String am,
                             IDL_ATTRIB(in) long int ts,
                             IDL_ATTRIB(in) String src,
                             IDL_ATTRIB(in) long int line,
                             IDL_ATTRIB(in) TriComponentId c,
                             IDL_ATTRIB(in) TciTestCaseIdType tcId,
                             IDL_ATTRIB(in) TciParameterListType pars,
                             IDL_ATTRIB(in) TciValue outcome);

/* tliCtrlStart
 * 
 * Shall be called by TE to log the start of the control part. This event occurs before the control is
 * started. If the control is not represented by a TRI component, 'c' is null.
*/
                             
void T3TCI(tliCtrlStart) (IDL_ATTRIB(in) String am,
                          IDL_ATTRIB(in) long int ts,
                          IDL_ATTRIB(in) String src,
                          IDL_ATTRIB(in) long int line,
                          IDL_ATTRIB(in) TriComponentId c);

/* tliCtrlStop
 * 
 * Shall be called by TE to log the stop of the control part. This event occurs before the control is
 * stopped. If the control is not represented by a TRI component, 'c' is null.
*/
                          
void T3TCI(tliCtrlStop) (IDL_ATTRIB(in) String am,
                         IDL_ATTRIB(in) long int ts,
                         IDL_ATTRIB(in) String src,
                         IDL_ATTRIB(in) long int line,
                         IDL_ATTRIB(in) TriComponentId c);

/* tliCtrlTerminated
 * 
 * Shall be called by TM to log the termination of the control part. This event occurs after the control
 * has terminated. If the control is not represented by a TRI component, 'c' is null.
*/
 
void T3TCI(tliCtrlTerminated) (IDL_ATTRIB(in) String am,
                               IDL_ATTRIB(in) long int ts,
                               IDL_ATTRIB(in) String src,
                               IDL_ATTRIB(in) long int line,
                               IDL_ATTRIB(in) TriComponentId c);

/* tliMSend_m
 * 
 * Shall be called by SA to log a unicast send operation. This event occurs after sending. This event is
 * used for logging the communication with the SUT.
*/
                               
void T3TCI(tliMSend_m) (IDL_ATTRIB(in) String am,
                        IDL_ATTRIB(in) long int ts,
                        IDL_ATTRIB(in) String src,
                        IDL_ATTRIB(in) long int line,
                        IDL_ATTRIB(in) TriComponentId c,
                        IDL_ATTRIB(in) TriPortId atPort,
                        IDL_ATTRIB(in) TriPortId toPort,
                        IDL_ATTRIB(in) TciValue msgValue,
                        IDL_ATTRIB(in) TriAddress address,
                        IDL_ATTRIB(in) TriStatus encoderFailure,
                        IDL_ATTRIB(in) TriMessage msg,
                        IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliMSend_m_BC
 * 
 * Shall be called by SA to log a broadcast send operation. This event occurs after sending. This event is
 * used for logging the communication with the SUT.
*/
                        
void T3TCI(tliMSend_m_BC) (IDL_ATTRIB(in) String am,
                           IDL_ATTRIB(in) long int ts,
                           IDL_ATTRIB(in) String src,
                           IDL_ATTRIB(in) long int line,
                           IDL_ATTRIB(in) TriComponentId c,
                           IDL_ATTRIB(in) TriPortId atPort,
                           IDL_ATTRIB(in) TriPortId toPort,
                           IDL_ATTRIB(in) TciValue msgValue,
                           IDL_ATTRIB(in) TriStatus encoderFailure,
                           IDL_ATTRIB(in) TriMessage msg,
                           IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliMSend_m_MC
 * 
 * Shall be called by SA to log a multicast send operation. This event occurs after sending. This event is
 * used for logging the communication with the SUT.
*/
                           
void T3TCI(tliMSend_m_MC) (IDL_ATTRIB(in) String am,
                           IDL_ATTRIB(in) long int ts,
                           IDL_ATTRIB(in) String src,
                           IDL_ATTRIB(in) long int line,
                           IDL_ATTRIB(in) TriComponentId c,
                           IDL_ATTRIB(in) TriPortId atPort,
                           IDL_ATTRIB(in) TriPortId toPort,
                           IDL_ATTRIB(in) TciValue msgValue,
                           IDL_ATTRIB(in) TriAddressList addresses,
                           IDL_ATTRIB(in) TriStatus encoderFailure,
                           IDL_ATTRIB(in) TriMessage msg,
                           IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliMSend_c
 * 
 * Shall be called by CH to log a unicast send operation. This event occurs after sending. This event is
 * used for logging the intercomponent communication.
*/
                           
void T3TCI(tliMSend_c) (IDL_ATTRIB(in) String am,
                        IDL_ATTRIB(in) long int ts,
                        IDL_ATTRIB(in) String src,
                        IDL_ATTRIB(in) long int line,
                        IDL_ATTRIB(in) TriComponentId c,
                        IDL_ATTRIB(in) TriPortId atPort,
                        IDL_ATTRIB(in) TriPortId toPort,
                        IDL_ATTRIB(in) TciValue msgValue,
                        IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliMSend_c_BC
 * 
 * Shall be called by CH to log a broadcast send operation. This event occurs after sending. This event is
 * used for logging the intercomponent communication.
*/
                        
void T3TCI(tliMSend_c_BC) (IDL_ATTRIB(in) String am,
                           IDL_ATTRIB(in) long int ts,
                           IDL_ATTRIB(in) String src,
                           IDL_ATTRIB(in) long int line,
                           IDL_ATTRIB(in) TriComponentId c,
                           IDL_ATTRIB(in) TriPortId atPort,
                           IDL_ATTRIB(in) TriPortIdList toPortList,
                           IDL_ATTRIB(in) TciValue msgValue,
                           IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliMSend_c_MC
 * 
 * Shall be called by CH to log a multicast send operation. This event occurs after sending. This event is
 * used for logging the intercomponent communication.
*/
                           
void T3TCI(tliMSend_c_MC) (IDL_ATTRIB(in) String am,
                           IDL_ATTRIB(in) long int ts,
                           IDL_ATTRIB(in) String src,
                           IDL_ATTRIB(in) long int line,
                           IDL_ATTRIB(in) TriComponentId c,
                           IDL_ATTRIB(in) TriPortId atPort,
                           IDL_ATTRIB(in) TriPortIdList toPortList,
                           IDL_ATTRIB(in) TciValue msgValue,
                           IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliMDetected_m
 * 
 * Shall be called by SA to log the enqueuing of a message. This event occurs after the message is
 * enqueued. This event is used for logging the communication with the SUT.
*/
                           
void T3TCI(tliMDetected_m) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TriPortId atPort,
                            IDL_ATTRIB(in) TriPortId fromPort,
                            IDL_ATTRIB(in) TriMessage msg,
                            IDL_ATTRIB(in) TriAddress address);

/* tliMDetected_c
 * 
 * Shall be called by CH to log the enqueuing of a message. This event occurs after the message is
 * enqueued. This event is used for logging the intercomponent communication.
*/
                            
void T3TCI(tliMDetected_c) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TriPortId atPort,
                            IDL_ATTRIB(in) TriPortId fromPort,
                            IDL_ATTRIB(in) TciValue msgValue);

/* tliMMismatch_m
 * 
 * Shall be called by TE to log the mismatch of a template. This event occurs after checking a
 * template match. This event is used for logging the communication with the SUT.
*/
                            
void T3TCI(tliMMismatch_m) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TriPortId port,
                            IDL_ATTRIB(in) TciValue msgValue,
                            IDL_ATTRIB(in) TciValueTemplate msgTmpl,
                            IDL_ATTRIB(in) TciValueDifferenceList diffs,
                            IDL_ATTRIB(in) TriAddress address,
                            IDL_ATTRIB(in) TciValueTemplate addressTmpl);

/* tliMMismatch_c
 * 
 * Shall be called by TE to log the mismatch of a template. This event occurs after checking a
 * template match. This event is used for logging the intercomponent communication.
*/

void T3TCI(tliMMismatch_c) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TriPortId port,
                            IDL_ATTRIB(in) TciValue msgValue,
                            IDL_ATTRIB(in) TciValueTemplate msgTmpl,
                            IDL_ATTRIB(in) TciValueDifferenceList diffs,
                            IDL_ATTRIB(in) TriComponentId from,
                            IDL_ATTRIB(in) TciNonValueTemplate fromTmpl);

/* tliMReceive_m
 * 
 * Shall be called by TE to log the receive of a message. This event occurs after checking a template
 * match. This event is used for logging the communication with SUT.
*/

void T3TCI(tliMReceive_m) (IDL_ATTRIB(in) String am,
                           IDL_ATTRIB(in) long int ts,
                           IDL_ATTRIB(in) String src,
                           IDL_ATTRIB(in) long int line,
                           IDL_ATTRIB(in) TriComponentId c,
                           IDL_ATTRIB(in) TriPortId port,
                           IDL_ATTRIB(in) TciValue msgValue,
                           IDL_ATTRIB(in) TciValueTemplate msgTmpl,
                           IDL_ATTRIB(in) TriAddress address,
                           IDL_ATTRIB(in) TciValueTemplate addressTmpl);

/* tliMReceive_c
 * 
 * Shall be called by TE to log the receive of a message. This event occurs after checking a template
 * match. This event is used for logging the intercomponent communication.
*/
                           
void T3TCI(tliMReceive_c) (IDL_ATTRIB(in) String am,
                           IDL_ATTRIB(in) long int ts,
                           IDL_ATTRIB(in) String src,
                           IDL_ATTRIB(in) long int line,
                           IDL_ATTRIB(in) TriComponentId c,
                           IDL_ATTRIB(in) TriPortId port,
                           IDL_ATTRIB(in) TciValue msgValue,
                           IDL_ATTRIB(in) TciValueTemplate msgTmpl,
                           IDL_ATTRIB(in) TriComponentId from,
                           IDL_ATTRIB(in) TciNonValueTemplate fromTmpl);

/* tliPrCall_m
 * 
 * Shall be called by SA to log a unicast call operation. This event occurs after call execution. This
 * event is used for logging the communication with the SUT.
*/
                           
void T3TCI(tliPrCall_m) (IDL_ATTRIB(in) String am,
                         IDL_ATTRIB(in) long int ts,
                         IDL_ATTRIB(in) String src,
                         IDL_ATTRIB(in) long int line,
                         IDL_ATTRIB(in) TriComponentId c,
                         IDL_ATTRIB(in) TriPortId atPort,
                         IDL_ATTRIB(in) TriPortId toPort,
                         IDL_ATTRIB(in) TriSignatureId signature,
                         IDL_ATTRIB(in) TciParameterListType parsValue,
                         IDL_ATTRIB(in) TriAddress address,
                         IDL_ATTRIB(in) TriStatus encoderFailure,
                         IDL_ATTRIB(in) TriParameterList pars,
                         IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrCall_m_BC
 * 
 * Shall be called by SA to log a broadcast call operation. This event occurs after call execution. This
 * event is used for logging the communication with the SUT.
*/
                         
void T3TCI(tliPrCall_m_BC) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TriPortId atPort,
                            IDL_ATTRIB(in) TriPortId toPort,
                            IDL_ATTRIB(in) TriSignatureId signature,
                            IDL_ATTRIB(in) TciParameterListType parsValue,
                            IDL_ATTRIB(in) TriStatus encoderFailure,
                            IDL_ATTRIB(in) TriParameterList pars,
                            IDL_ATTRIB(in) TriStatus transmissionFailure);
                            
/* tliPrCall_m_MC
 * 
 * Shall be called by SA to log a multicast call operation. This event occurs after call execution. This
 * event is used for logging the communication with the SUT.
*/

void T3TCI(tliPrCall_m_MC) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TriPortId atPort,
                            IDL_ATTRIB(in) TriPortId toPort,
                            IDL_ATTRIB(in) TriSignatureId signature,
                            IDL_ATTRIB(in) TciParameterListType parsValue,
                            IDL_ATTRIB(in) TriAddressList addresses,
                            IDL_ATTRIB(in) TriStatus encoderFailure,
                            IDL_ATTRIB(in) TriParameterList pars,
                            IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrCall_c
 * 
 * Shall be called by CH to log a unicast call operation. This event occurs after call execution. This
 * event is used for logging the intercomponent communication.
*/
                            
void T3TCI(tliPrCall_c) (IDL_ATTRIB(in) String am,
                         IDL_ATTRIB(in) long int ts,
                         IDL_ATTRIB(in) String src,
                         IDL_ATTRIB(in) long int line,
                         IDL_ATTRIB(in) TriComponentId c,
                         IDL_ATTRIB(in) TriPortId atPort,
                         IDL_ATTRIB(in) TriPortId toPort,
                         IDL_ATTRIB(in) TriSignatureId signature,
                         IDL_ATTRIB(in) TciParameterListType parsValue,
                         IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrCall_c_BC
 * 
 * Shall be called by CH to log a broadcast call operation. This event occurs after call execution. This
 * event is used for logging the intercomponent communication.
*/
                         
void T3TCI(tliPrCall_c_BC) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TriPortId atPort,
                            IDL_ATTRIB(in) TriPortIdList toPortList,
                            IDL_ATTRIB(in) TriSignatureId signature,
                            IDL_ATTRIB(in) TciParameterListType parsValue,
                            IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrCall_c_MC
 * 
 * Shall be called by CH to log a multicast call operation. This event occurs after call execution. This
 * event is used for logging the intercomponent communication.
*/
                            
void T3TCI(tliPrCall_c_MC) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TriPortId atPort,
                            IDL_ATTRIB(in) TriPortIdList toPortList,
                            IDL_ATTRIB(in) TriSignatureId signature,
                            IDL_ATTRIB(in) TciParameterListType parsValue,
                            IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrGetCallDetected_m
 * 
 * Shall be called by SA to log the getcall enqueue operation. This event occurs after call is enqueued.
 * This event is used for logging the communication with the SUT.
*/
                            
void T3TCI(tliPrGetCallDetected_m) (IDL_ATTRIB(in) String am,
                                    IDL_ATTRIB(in) long int ts,
                                    IDL_ATTRIB(in) String src,
                                    IDL_ATTRIB(in) long int line,
                                    IDL_ATTRIB(in) TriComponentId c,
                                    IDL_ATTRIB(in) TriPortId atPort,
                                    IDL_ATTRIB(in) TriPortId fromPort,
                                    IDL_ATTRIB(in) TriSignatureId signature,
                                    IDL_ATTRIB(in) TriParameterList pars,
                                    IDL_ATTRIB(in) TriAddress address);

/* tliPrGetCallDetected_c
 * 
 * Shall be called by CH to log the getcall enqueue operation. This event occurs after call is enqueued.
 * This event is used for logging the intercomponent communication.
*/
                                    
void T3TCI(tliPrGetCallDetected_c) (IDL_ATTRIB(in) String am,
                                    IDL_ATTRIB(in) long int ts,
                                    IDL_ATTRIB(in) String src,
                                    IDL_ATTRIB(in) long int line,
                                    IDL_ATTRIB(in) TriComponentId c,
                                    IDL_ATTRIB(in) TriPortId atPort,
                                    IDL_ATTRIB(in) TriPortId fromPort,
                                    IDL_ATTRIB(in) TriSignatureId signature,
                                    IDL_ATTRIB(in) TciParameterListType parsValue);

/* tliPrGetCallMismatch_m
 * 
 * Shall be called by TE to log the mismatch of a getcall. This event occurs after getcall is checked
 * against a template. This event is used for logging the communication with the SUT.
*/
                                    
void T3TCI(tliPrGetCallMismatch_m) (IDL_ATTRIB(in) String am,
                                    IDL_ATTRIB(in) long int ts,
                                    IDL_ATTRIB(in) String src,
                                    IDL_ATTRIB(in) long int line,
                                    IDL_ATTRIB(in) TriComponentId c,
                                    IDL_ATTRIB(in) TriPortId port,
                                    IDL_ATTRIB(in) TriSignatureId signature,
                                    IDL_ATTRIB(in) TciParameterListType parsValue,
                                    IDL_ATTRIB(in) TciValueTemplate parsTmpl,
                                    IDL_ATTRIB(in) TciValueDifferenceList diffs,
                                    IDL_ATTRIB(in) TriAddress address,
                                    IDL_ATTRIB(in) TciValueTemplate addressTmpl);

/* tliPrGetCallMismatch_c
 * 
 * Shall be called by TE to log the mismatch of a getcall. This event occurs after getcall is checked
 * against a template. This event is used for logging the intercomponent communication.
*/
                                    
void T3TCI(tliPrGetCallMismatch_c) (IDL_ATTRIB(in) String am,
                                    IDL_ATTRIB(in) long int ts,
                                    IDL_ATTRIB(in) String src,
                                    IDL_ATTRIB(in) long int line,
                                    IDL_ATTRIB(in) TriComponentId c,
                                    IDL_ATTRIB(in) TriPortId port,
                                    IDL_ATTRIB(in) TriSignatureId signature,
                                    IDL_ATTRIB(in) TciParameterListType parsValue,
                                    IDL_ATTRIB(in) TciValueTemplate parsTmpl,
                                    IDL_ATTRIB(in) TciValueDifferenceList diffs,
                                    IDL_ATTRIB(in) TriComponentId from,
                                    IDL_ATTRIB(in) TciNonValueTemplate fromTmpl);

/* tliPrGetCall_m
 * 
 * Shall be called by TE to log getting a call. This event occurs after getcall has matched against a
 * template. This event is used for logging the communication with the SUT.
*/
                                    
void T3TCI(tliPrGetCall_m) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TriPortId port,
                            IDL_ATTRIB(in) TriSignatureId signature,
                            IDL_ATTRIB(in) TciParameterListType parsValue,
                            IDL_ATTRIB(in) TciValueTemplate parsTmpl,
                            IDL_ATTRIB(in) TriAddress address,
                            IDL_ATTRIB(in) TciValueTemplate addressTmpl);

/* tliPrGetCall_c
 * 
 * Shall be called by TE to log getting a call. This event occurs after getcall has matched against a
 * template. This event is used for logging the intercomponent communication.
*/
                            
void T3TCI(tliPrGetCall_c) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TriPortId port,
                            IDL_ATTRIB(in) TriSignatureId signature,
                            IDL_ATTRIB(in) TciParameterListType parsValue,
                            IDL_ATTRIB(in) TciValueTemplate parsTmpl,
                            IDL_ATTRIB(in) TriComponentId from,
                            IDL_ATTRIB(in) TciNonValueTemplate fromTmpl);

/* tliPrReply_m
 * 
 * Shall be called by SA to log a unicast reply operation. This event occurs after reply execution. This
 * event is used for logging the communication with the SUT.
*/

void T3TCI(tliPrReply_m) (IDL_ATTRIB(in) String am,
                          IDL_ATTRIB(in) long int ts,
                          IDL_ATTRIB(in) String src,
                          IDL_ATTRIB(in) long int line,
                          IDL_ATTRIB(in) TriComponentId c,
                          IDL_ATTRIB(in) TriPortId atPort,
                          IDL_ATTRIB(in) TriPortId toPort,
                          IDL_ATTRIB(in) TriSignatureId signature,
                          IDL_ATTRIB(in) TciParameterListType parsValue,
                          IDL_ATTRIB(in) TciValue replValue,
                          IDL_ATTRIB(in) TriAddress address,
                          IDL_ATTRIB(in) TriStatus encoderFailure,
                          IDL_ATTRIB(in) TriParameterList pars,
                          IDL_ATTRIB(in) TriParameter repl,
                          IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrReply_m_BC
 * 
 * Shall be called by SA to log a broadcast reply operation. This event occurs after reply execution. This
 * event is used for logging the communication with the SUT.
*/
                          
void T3TCI(tliPrReply_m_BC) (IDL_ATTRIB(in) String am,
                             IDL_ATTRIB(in) long int ts,
                             IDL_ATTRIB(in) String src,
                             IDL_ATTRIB(in) long int line,
                             IDL_ATTRIB(in) TriComponentId c,
                             IDL_ATTRIB(in) TriPortId atPort,
                             IDL_ATTRIB(in) TriPortId toPort,
                             IDL_ATTRIB(in) TriSignatureId signature,
                             IDL_ATTRIB(in) TciParameterListType parsValue,
                             IDL_ATTRIB(in) TciValue replValue,
                             IDL_ATTRIB(in) TriStatus encoderFailure,
                             IDL_ATTRIB(in) TriParameterList pars,
                             IDL_ATTRIB(in) TriParameter repl,
                             IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrReply_m_MC
 * 
 * Shall be called by SA to log a multicast reply operation. This event occurs after reply execution. This
 * event is used for logging the communication with the SUT.
*/
                             
void T3TCI(tliPrReply_m_MC) (IDL_ATTRIB(in) String am,
                             IDL_ATTRIB(in) long int ts,
                             IDL_ATTRIB(in) String src,
                             IDL_ATTRIB(in) long int line,
                             IDL_ATTRIB(in) TriComponentId c,
                             IDL_ATTRIB(in) TriPortId atPort,
                             IDL_ATTRIB(in) TriPortId toPort,
                             IDL_ATTRIB(in) TriSignatureId signature,
                             IDL_ATTRIB(in) TciParameterListType parsValue,
                             IDL_ATTRIB(in) TciValue replValue,
                             IDL_ATTRIB(in) TriAddressList addresses,
                             IDL_ATTRIB(in) TriStatus encoderFailure,
                             IDL_ATTRIB(in) TriParameterList pars,
                             IDL_ATTRIB(in) TriParameter repl,
                             IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrReply_c
 * 
 * Shall be called by CH to log a unicast reply operation. This event occurs after reply execution. This
 * event is used for logging the intercomponent communication.
*/
 
void T3TCI(tliPrReply_c) (IDL_ATTRIB(in) String am,
                          IDL_ATTRIB(in) long int ts,
                          IDL_ATTRIB(in) String src,
                          IDL_ATTRIB(in) long int line,
                          IDL_ATTRIB(in) TriComponentId c,
                          IDL_ATTRIB(in) TriPortId atPort,
                          IDL_ATTRIB(in) TriPortId toPort,
                          IDL_ATTRIB(in) TriSignatureId signature,
                          IDL_ATTRIB(in) TciParameterListType parsValue,
                          IDL_ATTRIB(in) TciValue replValue,
                          IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrReply_c_BC
 * 
 * Shall be called by CH to log a broadcast reply operation. This event occurs after reply execution. This
 * event is used for logging the intercomponent communication.
*/
                          
void T3TCI(tliPrReply_c_BC) (IDL_ATTRIB(in) String am,
                             IDL_ATTRIB(in) long int ts,
                             IDL_ATTRIB(in) String src,
                             IDL_ATTRIB(in) long int line,
                             IDL_ATTRIB(in) TriComponentId c,
                             IDL_ATTRIB(in) TriPortId atPort,
                             IDL_ATTRIB(in) TriPortIdList toPortList,
                             IDL_ATTRIB(in) TriSignatureId signature,
                             IDL_ATTRIB(in) TciParameterListType parsValue,
                             IDL_ATTRIB(in) TciValue replValue,
                             IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrReply_c_MC
 * 
 * Shall be called by CH to log a multicast reply operation. This event occurs after reply execution. This
 * event is used for logging the intercomponent communication.
*/
                             
void T3TCI(tliPrReply_c_MC) (IDL_ATTRIB(in) String am,
                             IDL_ATTRIB(in) long int ts,
                             IDL_ATTRIB(in) String src,
                             IDL_ATTRIB(in) long int line,
                             IDL_ATTRIB(in) TriComponentId c,
                             IDL_ATTRIB(in) TriPortId atPort,
                             IDL_ATTRIB(in) TriPortIdList toPortList,
                             IDL_ATTRIB(in) TriSignatureId signature,
                             IDL_ATTRIB(in) TciParameterListType parsValue,
                             IDL_ATTRIB(in) TciValue replValue,
                             IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrGetReplyDetected_m
 * 
 * Shall be called by SA to log the getreply enqueue operation. This event occurs after getreply is
 * enqueued. This event is used for logging the communication with the SUT.
*/
                             
void T3TCI(tliPrGetReplyDetected_m) (IDL_ATTRIB(in) String am,
                                     IDL_ATTRIB(in) long int ts,
                                     IDL_ATTRIB(in) String src,
                                     IDL_ATTRIB(in) long int line,
                                     IDL_ATTRIB(in) TriComponentId c,
                                     IDL_ATTRIB(in) TriPortId atPort,
                                     IDL_ATTRIB(in) TriPortId fromPort,
                                     IDL_ATTRIB(in) TriSignatureId signature,
                                     IDL_ATTRIB(in) TriParameterList pars,
                                     IDL_ATTRIB(in) TriParameter repl,
                                     IDL_ATTRIB(in) TriAddress address);

/* tliPrGetReplyDetected_c
 * 
 * Shall be called by CH to log the getreply enqueue operation. This event occurs after getreply is
 * enqueued. This event is used for logging the intercomponent communication.
*/
                                     
void T3TCI(tliPrGetReplyDetected_c) (IDL_ATTRIB(in) String am,
                                     IDL_ATTRIB(in) long int ts,
                                     IDL_ATTRIB(in) String src,
                                     IDL_ATTRIB(in) long int line,
                                     IDL_ATTRIB(in) TriComponentId c,
                                     IDL_ATTRIB(in) TriPortId atPort,
                                     IDL_ATTRIB(in) TriPortId fromPort,
                                     IDL_ATTRIB(in) TriSignatureId signature,
                                     IDL_ATTRIB(in) TciParameterListType parsValue,
                                     IDL_ATTRIB(in) TciValue replValue);

/* tliPrGetReplyMismatch_m
 * 
 * Shall be called by TE to log the mismatch of a getreply operation. This event occurs after getreply is
 * checked against a template. This event is used for logging the communication with SUT.
*/
                                     
void T3TCI(tliPrGetReplyMismatch_m) (IDL_ATTRIB(in) String am,
                                     IDL_ATTRIB(in) long int ts,
                                     IDL_ATTRIB(in) String src,
                                     IDL_ATTRIB(in) long int line,
                                     IDL_ATTRIB(in) TriComponentId c,
                                     IDL_ATTRIB(in) TriPortId port,
                                     IDL_ATTRIB(in) TriSignatureId signature,
                                     IDL_ATTRIB(in) TciParameterListType parsValue,
                                     IDL_ATTRIB(in) TciValueTemplate parsTmpl,
                                     IDL_ATTRIB(in) TciValue replValue,
                                     IDL_ATTRIB(in) TciValueTemplate replyTmpl,
                                     IDL_ATTRIB(in) TciValueDifferenceList diffs,
                                     IDL_ATTRIB(in) TriAddress address,
                                     IDL_ATTRIB(in) TciValueTemplate addressTmpl);

/* tliPrGetReplyMismatch_c
 * 
 * Shall be called by TE to log the mismatch of a getreply operation. This event occurs after getreply is
 * checked against a template. This event is used for logging the intercomponent communication.
*/

void T3TCI(tliPrGetReplyMismatch_c) (IDL_ATTRIB(in) String am,
                                     IDL_ATTRIB(in) long int ts,
                                     IDL_ATTRIB(in) String src,
                                     IDL_ATTRIB(in) long int line,
                                     IDL_ATTRIB(in) TriComponentId c,
                                     IDL_ATTRIB(in) TriPortId port,
                                     IDL_ATTRIB(in) TriSignatureId signature,
                                     IDL_ATTRIB(in) TciParameterListType parsValue,
                                     IDL_ATTRIB(in) TciValueTemplate parsTmpl,
                                     IDL_ATTRIB(in) TciValue replValue,
                                     IDL_ATTRIB(in) TciValueTemplate replyTmpl,
                                     IDL_ATTRIB(in) TciValueDifferenceList diffs,
                                     IDL_ATTRIB(in) TriComponentId from,
                                     IDL_ATTRIB(in) TciNonValueTemplate fromTmpl);

/* tliPrGetReply_m
 * 
 * Shall be called by TE to log getting a reply. This event occurs after getreply is checked against a
 * template. This event is used for logging the communication with SUT.
*/
                                     
void T3TCI(tliPrGetReply_m) (IDL_ATTRIB(in) String am,
                             IDL_ATTRIB(in) long int ts,
                             IDL_ATTRIB(in) String src,
                             IDL_ATTRIB(in) long int line,
                             IDL_ATTRIB(in) TriComponentId c,
                             IDL_ATTRIB(in) TriPortId port,
                             IDL_ATTRIB(in) TriSignatureId signature,
                             IDL_ATTRIB(in) TciParameterListType parsValue,
                             IDL_ATTRIB(in) TciValueTemplate parsTmpl,
                             IDL_ATTRIB(in) TciValue replValue,
                             IDL_ATTRIB(in) TciValueTemplate replyTmpl,
                             IDL_ATTRIB(in) TriAddress address,
                             IDL_ATTRIB(in) TciValueTemplate addressTmpl);

/* tliPrGetReply_c
 * 
 * Shall be called by TE to log getting a reply. This event occurs after getreply is checked against a
 * template. This event is used for logging the intercomponent communication.
*/
                             
void T3TCI(tliPrGetReply_c) (IDL_ATTRIB(in) String am,
                             IDL_ATTRIB(in) long int ts,
                             IDL_ATTRIB(in) String src,
                             IDL_ATTRIB(in) long int line,
                             IDL_ATTRIB(in) TriComponentId c,
                             IDL_ATTRIB(in) TriPortId port,
                             IDL_ATTRIB(in) TriSignatureId signature,
                             IDL_ATTRIB(in) TciParameterListType parsValue,
                             IDL_ATTRIB(in) TciValueTemplate parsTmpl,
                             IDL_ATTRIB(in) TciValue replValue,
                             IDL_ATTRIB(in) TciValueTemplate replyTmpl,
                             IDL_ATTRIB(in) TriComponentId from,
                             IDL_ATTRIB(in) TciNonValueTemplate fromTmpl);

/* tliPrRaise_m
 * 
 * Shall be called by SA to log a unicast raise operation. This event occurs after reply execution. This
 * event is used for logging the communication with the SUT.
*/
                             
void T3TCI(tliPrRaise_m) (IDL_ATTRIB(in) String am,
                          IDL_ATTRIB(in) long int ts,
                          IDL_ATTRIB(in) String src,
                          IDL_ATTRIB(in) long int line,
                          IDL_ATTRIB(in) TriComponentId c,
                          IDL_ATTRIB(in) TriPortId atPort,
                          IDL_ATTRIB(in) TriPortId toPort,
                          IDL_ATTRIB(in) TriSignatureId signature,
                          IDL_ATTRIB(in) TciParameterListType parsValue,
                          IDL_ATTRIB(in) TciValue excValue,
                          IDL_ATTRIB(in) TriAddress address,
                          IDL_ATTRIB(in) TriStatus encoderFailure,
                          IDL_ATTRIB(in) TriException exc,
                          IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrRaise_m_BC
 * 
 * Shall be called by SA to log a broadcast raise operation. This event occurs after reply execution. This
 * event is used for logging the communication with the SUT.
*/
                          
void T3TCI(tliPrRaise_m_BC) (IDL_ATTRIB(in) String am,
                             IDL_ATTRIB(in) long int ts,
                             IDL_ATTRIB(in) String src,
                             IDL_ATTRIB(in) long int line,
                             IDL_ATTRIB(in) TriComponentId c,
                             IDL_ATTRIB(in) TriPortId atPort,
                             IDL_ATTRIB(in) TriPortId toPort,
                             IDL_ATTRIB(in) TriSignatureId signature,
                             IDL_ATTRIB(in) TciParameterListType parsValue,
                             IDL_ATTRIB(in) TciValue excValue,
                             IDL_ATTRIB(in) TriStatus encoderFailure,
                             IDL_ATTRIB(in) TriException exc,
                             IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrRaise_m_MC
 * 
 * Shall be called by SA to log a multicast raise operation. This event occurs after reply execution. This
 * event is used for logging the communication with the SUT.
*/
                             
void T3TCI(tliPrRaise_m_MC) (IDL_ATTRIB(in) String am,
                             IDL_ATTRIB(in) long int ts,
                             IDL_ATTRIB(in) String src,
                             IDL_ATTRIB(in) long int line,
                             IDL_ATTRIB(in) TriComponentId c,
                             IDL_ATTRIB(in) TriPortId atPort,
                             IDL_ATTRIB(in) TriPortId toPort,
                             IDL_ATTRIB(in) TriSignatureId signature,
                             IDL_ATTRIB(in) TciParameterListType parsValue,
                             IDL_ATTRIB(in) TciValue excValue,
                             IDL_ATTRIB(in) TriAddressList addresses,
                             IDL_ATTRIB(in) TriStatus encoderFailure,
                             IDL_ATTRIB(in) TriException exc,
                             IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrRaise_c
 * 
 * Shall be called by CH to log a unicast raise operation. This event occurs after reply execution. This
 * event is used for logging the intercomponent communication.
*/
                             
void T3TCI(tliPrRaise_c) (IDL_ATTRIB(in) String am,
                          IDL_ATTRIB(in) long int ts,
                          IDL_ATTRIB(in) String src,
                          IDL_ATTRIB(in) long int line,
                          IDL_ATTRIB(in) TriComponentId c,
                          IDL_ATTRIB(in) TriPortId atPort,
                          IDL_ATTRIB(in) TriPortId toPort,
                          IDL_ATTRIB(in) TriSignatureId signature,
                          IDL_ATTRIB(in) TciParameterListType parsValue,
                          IDL_ATTRIB(in) TciValue excValue,
                          IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrRaise_c_BC
 * 
 * Shall be called by CH to log a broadcast raise operation. This event occurs after reply execution. This
 * event is used for logging the intercomponent communication.
*/
                          
void T3TCI(tliPrRaise_c_BC) (IDL_ATTRIB(in) String am,
                             IDL_ATTRIB(in) long int ts,
                             IDL_ATTRIB(in) String src,
                             IDL_ATTRIB(in) long int line,
                             IDL_ATTRIB(in) TriComponentId c,
                             IDL_ATTRIB(in) TriPortId atPort,
                             IDL_ATTRIB(in) TriPortIdList toPortList,
                             IDL_ATTRIB(in) TriSignatureId signature,
                             IDL_ATTRIB(in) TciParameterListType parsValue,
                             IDL_ATTRIB(in) TciValue excValue,
                             IDL_ATTRIB(in) TriStatus transmissionFailure);
                             
/* tliPrRaise_c_MC
 * 
 * Shall be called by CH to log a multicast raise operation. This event occurs after reply execution. This
 * event is used for logging the intercomponent communication.
*/

void T3TCI(tliPrRaise_c_MC) (IDL_ATTRIB(in) String am,
                             IDL_ATTRIB(in) long int ts,
                             IDL_ATTRIB(in) String src,
                             IDL_ATTRIB(in) long int line,
                             IDL_ATTRIB(in) TriComponentId c,
                             IDL_ATTRIB(in) TriPortId atPort,
                             IDL_ATTRIB(in) TriPortIdList toPortList,
                             IDL_ATTRIB(in) TriSignatureId signature,
                             IDL_ATTRIB(in) TciParameterListType parsValue,
                             IDL_ATTRIB(in) TciValue excValue,
                             IDL_ATTRIB(in) TriStatus transmissionFailure);

/* tliPrCatchDetected_m
 * 
 * Shall be called by SA to log the catch enqueue operation. This event occurs after catch is
 * enqueued. This event is used for logging the communication with the SUT.
*/
                             
void T3TCI(tliPrCatchDetected_m) (IDL_ATTRIB(in) String am,
                                  IDL_ATTRIB(in) long int ts,
                                  IDL_ATTRIB(in) String src,
                                  IDL_ATTRIB(in) long int line,
                                  IDL_ATTRIB(in) TriComponentId c,
                                  IDL_ATTRIB(in) TriPortId atPort,
                                  IDL_ATTRIB(in) TriPortId fromPort,
                                  IDL_ATTRIB(in) TriSignatureId signature,
                                  IDL_ATTRIB(in) TriException exc,
                                  IDL_ATTRIB(in) TriAddress address);

/* tliPrCatchDetected_c
 * 
 * Shall be called by CH to log the catch enqueue operation. This event occurs after catch is enqueued.
 * This event is used for logging the intercomponent communication.
*/
                                  
void T3TCI(tliPrCatchDetected_c) (IDL_ATTRIB(in) String am,
                                  IDL_ATTRIB(in) long int ts,
                                  IDL_ATTRIB(in) String src,
                                  IDL_ATTRIB(in) long int line,
                                  IDL_ATTRIB(in) TriComponentId c,
                                  IDL_ATTRIB(in) TriPortId atPort,
                                  IDL_ATTRIB(in) TriPortId fromPort,
                                  IDL_ATTRIB(in) TriSignatureId signature,
                                  IDL_ATTRIB(in) TciValue excValue);

/* tliPrCatchMismatch_m
 * 
 * Shall be called by TE to log the mismatch of a catch operation. This event occurs after catch is
 * checked against a template. This event is used for logging the communication with SUT.
*/
                                  
void T3TCI(tliPrCatchMismatch_m) (IDL_ATTRIB(in) String am,
                                  IDL_ATTRIB(in) long int ts,
                                  IDL_ATTRIB(in) String src,
                                  IDL_ATTRIB(in) long int line,
                                  IDL_ATTRIB(in) TriComponentId c,
                                  IDL_ATTRIB(in) TriPortId port,
                                  IDL_ATTRIB(in) TriSignatureId signature,
                                  IDL_ATTRIB(in) TciValue excValue,
                                  IDL_ATTRIB(in) TciValueTemplate excTmpl,
                                  IDL_ATTRIB(in) TciValueDifferenceList diffs,
                                  IDL_ATTRIB(in) TriAddress address,
                                  IDL_ATTRIB(in) TciValueTemplate addressTmpl);

/* tliPrCatchMismatch_c
 * 
 * Shall be called by TE to log the mismatch of a catch operation. This event occurs after catch is
 * checked against a template. This event is used for logging the intercomponent communication.
*/
                                  
void T3TCI(tliPrCatchMismatch_c) (IDL_ATTRIB(in) String am,
                                  IDL_ATTRIB(in) long int ts,
                                  IDL_ATTRIB(in) String src,
                                  IDL_ATTRIB(in) long int line,
                                  IDL_ATTRIB(in) TriComponentId c,
                                  IDL_ATTRIB(in) TriPortId port,
                                  IDL_ATTRIB(in) TriSignatureId signature,
                                  IDL_ATTRIB(in) TciValue excValue,
                                  IDL_ATTRIB(in) TciValueTemplate excTmpl,
                                  IDL_ATTRIB(in) TciValueDifferenceList diffs,
                                  IDL_ATTRIB(in) TriComponentId from,
                                  IDL_ATTRIB(in) TciNonValueTemplate fromTmpl);

/* tliPrCatch_m
 * 
 * Shall be called by SA to log catching an exception. This event occurs after catch is checked against
 * a template. This event is used for logging the communication with SUT.
*/
                                  
void T3TCI(tliPrCatch_m) (IDL_ATTRIB(in) String am,
                          IDL_ATTRIB(in) long int ts,
                          IDL_ATTRIB(in) String src,
                          IDL_ATTRIB(in) long int line,
                          IDL_ATTRIB(in) TriComponentId c,
                          IDL_ATTRIB(in) TriPortId port,
                          IDL_ATTRIB(in) TriSignatureId signature,
                          IDL_ATTRIB(in) TciValue excValue,
                          IDL_ATTRIB(in) TciValueTemplate excTmpl,
                          IDL_ATTRIB(in) TriAddress address,
                          IDL_ATTRIB(in) TciValueTemplate addressTmpl);

/* tliPrCatch_c
 * 
 * Shall be called by CH to log catching an exception. This event occurs after catch is checked against
 * a template. This event is used for logging the intercomponent communication.
*/
                          
void T3TCI(tliPrCatch_c) (IDL_ATTRIB(in) String am,
                          IDL_ATTRIB(in) long int ts,
                          IDL_ATTRIB(in) String src,
                          IDL_ATTRIB(in) long int line,
                          IDL_ATTRIB(in) TriComponentId c,
                          IDL_ATTRIB(in) TriPortId port,
                          IDL_ATTRIB(in) TriSignatureId signature,
                          IDL_ATTRIB(in) TciValue excValue,
                          IDL_ATTRIB(in) TciValueTemplate excTmpl,
                          IDL_ATTRIB(in) TriComponentId from,   	
                          IDL_ATTRIB(in) TciNonValueTemplate fromTmpl);

/* tliPrCatchTimeoutDetected
 * 
 * Shall be called by PA to log the detection of a catch timeout. This event occurs after the timeout is
 * enqueued.
*/
                          
void T3TCI(tliPrCatchTimeoutDetected) (IDL_ATTRIB(in) String am,
                                       IDL_ATTRIB(in) long int ts,
                                       IDL_ATTRIB(in) String src,
                                       IDL_ATTRIB(in) long int line,
                                       IDL_ATTRIB(in) TriComponentId c,
                                       IDL_ATTRIB(in) TriPortId port,
                                       IDL_ATTRIB(in) TriSignatureId signature);

/* tliPrCatchTimeout
 * 
 * Shall be called by TE to log catching a timeout. This event occurs after the catch timeout has been
 * performed.
*/
                                       
void T3TCI(tliPrCatchTimeout) (IDL_ATTRIB(in) String am,
                               IDL_ATTRIB(in) long int ts,
                               IDL_ATTRIB(in) String src,
                               IDL_ATTRIB(in) long int line,
                               IDL_ATTRIB(in) TriComponentId c,
                               IDL_ATTRIB(in) TriPortId port,
                               IDL_ATTRIB(in) TriSignatureId signature);

/* tliCCreate
 * 
 * Shall be called by TE to log the create component operation. This event occurs after component
 * creation.
*/
                               
void T3TCI(tliCCreate) (IDL_ATTRIB(in) String am,
                        IDL_ATTRIB(in) long int ts,
                        IDL_ATTRIB(in) String src,
                        IDL_ATTRIB(in) long int line,
                        IDL_ATTRIB(in) TriComponentId c,
                        IDL_ATTRIB(in) TriComponentId comp,
                        IDL_ATTRIB(in) String name,
                        IDL_ATTRIB(in) unsigned char alive);

/* tliCStart
 * 
 * Shall be called by TE to log the start component operation. This event occurs after component start.
*/
                        
void T3TCI(tliCStart) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c,
                       IDL_ATTRIB(in) TriComponentId comp,
                       IDL_ATTRIB(in) TciBehaviourIdType name,
                       IDL_ATTRIB(in) TciParameterListType parsValue);

/* tliCRunning
 * 
 * Shall be called by TE to log the running component operation. This event occurs after component
 * running.
*/
                       
void T3TCI(tliCRunning) (IDL_ATTRIB(in) String am,
                         IDL_ATTRIB(in) long int ts,
                         IDL_ATTRIB(in) String src,
                         IDL_ATTRIB(in) long int line,
                         IDL_ATTRIB(in) TriComponentId c,
                         IDL_ATTRIB(in) TriComponentId comp,
                         IDL_ATTRIB(in) ComponentStatus status);

/* tliCAlive
 * 
 * Shall be called by TE to log the alive component operation. This event occurs after component
 * alive.
*/

                         
void T3TCI(tliCAlive) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c,
                       IDL_ATTRIB(in) TriComponentId comp,
                       IDL_ATTRIB(in) ComponentStatus status);

/* tliCStop
 * 
 * Shall be called by TE to log the stop component operation. This event occurs after component stop.
*/

                       
void T3TCI(tliCStop) (IDL_ATTRIB(in) String am,
                      IDL_ATTRIB(in) long int ts,
                      IDL_ATTRIB(in) String src,
                      IDL_ATTRIB(in) long int line,
                      IDL_ATTRIB(in) TriComponentId c,
                      IDL_ATTRIB(in) TriComponentId comp);

/* tliCKill
 * 
 * Shall be called by TE to log the kill component operation. This event occurs after component kill.
*/

                      
void T3TCI(tliCKill) (IDL_ATTRIB(in) String am,
                      IDL_ATTRIB(in) long int ts,
                      IDL_ATTRIB(in) String src,
                      IDL_ATTRIB(in) long int line,
                      IDL_ATTRIB(in) TriComponentId c,
                      IDL_ATTRIB(in) TriComponentId comp);

/* tliCDoneMismatch
 * 
 * Shall be called by TE to log the mismatch of a done component operation. This event occurs after
 * done is checked against a template.
*/
                      
void T3TCI(tliCDoneMismatch) (IDL_ATTRIB(in) String am,
                              IDL_ATTRIB(in) long int ts,
                              IDL_ATTRIB(in) String src,
                              IDL_ATTRIB(in) long int line,
                              IDL_ATTRIB(in) TriComponentId c,
                              IDL_ATTRIB(in) TriComponentId comp,
                              IDL_ATTRIB(in) TciNonValueTemplate compTmpl);

/* tliCDone
 * 
 * Shall be called by TE to log the done component operation. This event occurs after the done
 * operation.
*/
                              
void T3TCI(tliCDone) (IDL_ATTRIB(in) String am,
                      IDL_ATTRIB(in) long int ts,
                      IDL_ATTRIB(in) String src,
                      IDL_ATTRIB(in) long int line,
                      IDL_ATTRIB(in) TriComponentId c,
                      IDL_ATTRIB(in) TriComponentId comp,
                      IDL_ATTRIB(in) TciNonValueTemplate compTmpl);

/* tliCKilledMismatch
 * 
 * Shall be called by TE to log the mismatch of a killed component operation. This event occurs after
 * killed is checked against a template.
*/
                      
void T3TCI(tliCKilledMismatch) (IDL_ATTRIB(in) String am,
                                IDL_ATTRIB(in) long int ts,
                                IDL_ATTRIB(in) String src,
                                IDL_ATTRIB(in) long int line,
                                IDL_ATTRIB(in) TriComponentId c,
                                IDL_ATTRIB(in) TriComponentId comp,
                                IDL_ATTRIB(in) TciNonValueTemplate compTmpl);

/* tliCKilled
 * 
 * Shall be called by TE to log the killed component operation. This event occurs after the killed
 * operation.
*/
                                
void T3TCI(tliCKilled) (IDL_ATTRIB(in) String am,
                        IDL_ATTRIB(in) long int ts,
                        IDL_ATTRIB(in) String src,
                        IDL_ATTRIB(in) long int line,
                        IDL_ATTRIB(in) TriComponentId c,
                        IDL_ATTRIB(in) TriComponentId comp,
                        IDL_ATTRIB(in) TciNonValueTemplate compTmpl);

/* tliCTerminated
 * 
 * Shall be called by TE to log the termination of a component. This event occurs after the termination
 * of the component.
*/
                        
void T3TCI(tliCTerminated) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TciValue verdict);

/* tliPConnect
 * 
 * Shall be called by CH to log the connect operation. This event occurs after the connect operation.
*/
                            
void T3TCI(tliPConnect) (IDL_ATTRIB(in) String am,
                         IDL_ATTRIB(in) long int ts,
                         IDL_ATTRIB(in) String src,
                         IDL_ATTRIB(in) long int line,
                         IDL_ATTRIB(in) TriComponentId c,
                         IDL_ATTRIB(in) TriPortId port1,
                         IDL_ATTRIB(in) TriPortId port2);

/* tliPDisconnect
 * 
 * Shall be called by CH to log the disconnect operation. This event occurs after the disconnect 
 * operation.
*/
                         
void T3TCI(tliPDisconnect) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TriPortId port1,
                            IDL_ATTRIB(in) TriPortId port2);

/* tliPMap
 * 
 * Shall be called by SA to log the map operation. This event occurs after the map operation.
*/
                            
void T3TCI(tliPMap) (IDL_ATTRIB(in) String am,
                     IDL_ATTRIB(in) long int ts,
                     IDL_ATTRIB(in) String src,
                     IDL_ATTRIB(in) long int line,
                     IDL_ATTRIB(in) TriComponentId c,
                     IDL_ATTRIB(in) TriPortId port1,
                     IDL_ATTRIB(in) TriPortId port2);

/* tliPUnmap
 * 
 * Shall be called by SA to log the unmap operation. This event occurs after the unmap operation.
*/
                     
void T3TCI(tliPUnmap) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c,
                       IDL_ATTRIB(in) TriPortId port1,
                       IDL_ATTRIB(in) TriPortId port2);

/* tliPClear
 * 
 * Shall be called by TE to log the port clear operation. This event occurs after the port clear
 * operation.
*/
                       
void T3TCI(tliPClear) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c,
                       IDL_ATTRIB(in) TriPortId port);

/* tliPStart
 * 
 * Shall be called by TE to log the port start operation. This event occurs after the port start operation.
*/
                       
void T3TCI(tliPStart) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c,
                       IDL_ATTRIB(in) TriPortId port);

/* tliPStop
 * 
 * Shall be called by TE to log the port stop operation. This event occurs after the port stop operation.
*/
                       
void T3TCI(tliPStop) (IDL_ATTRIB(in) String am,
                      IDL_ATTRIB(in) long int ts,
                      IDL_ATTRIB(in) String src,
                      IDL_ATTRIB(in) long int line,
                      IDL_ATTRIB(in) TriComponentId c,
                      IDL_ATTRIB(in) TriPortId port);

/* tliPHalt
 * 
 * Shall be called by TE to log the port halt operation. This event occurs after the port halt operation.
*/
                      
void T3TCI(tliPHalt) (IDL_ATTRIB(in) String am,
                      IDL_ATTRIB(in) long int ts,
                      IDL_ATTRIB(in) String src,
                      IDL_ATTRIB(in) long int line,
                      IDL_ATTRIB(in) TriComponentId c,
                      IDL_ATTRIB(in) TriPortId port);

/* tliEncode
 * 
 * Shall be called by CD to log the encode operation.
*/
                      
void T3TCI(tliEncode) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c,
                       IDL_ATTRIB(in) TciValue val,
                       IDL_ATTRIB(in) TriStatus encoderFailure,
                       IDL_ATTRIB(in) TriMessage msg,
                       IDL_ATTRIB(in) String codec);

/* tliDecode
 * 
 * Shall be called by CD to log the decode operation.
*/
                       
void T3TCI(tliDecode) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c,
                       IDL_ATTRIB(in) TriMessage msg,
                       IDL_ATTRIB(in) TriStatus decoderFailure,
                       IDL_ATTRIB(in) TciValue val,
                       IDL_ATTRIB(in) String codec);

/* tliTTimeoutDetected
 * 
 * Shall be called by PA to log the detection of a timeout. This event occurs after timeout is
 * enqueued.
*/
                       
void T3TCI(tliTTimeoutDetected) (IDL_ATTRIB(in) String am,
                                 IDL_ATTRIB(in) long int ts,
                                 IDL_ATTRIB(in) String src,
                                 IDL_ATTRIB(in) long int line,
                                 IDL_ATTRIB(in) TriComponentId c,
                                 IDL_ATTRIB(in) TriTimerId timer);

/* tliTTimeoutMismatch
 * 
 * Shall be called by TE to log a timeout mismatch. This event occurs after a timeout match failed.
*/
                                 
void T3TCI(tliTTimeoutMismatch) (IDL_ATTRIB(in) String am,
                                 IDL_ATTRIB(in) long int ts,
                                 IDL_ATTRIB(in) String src,
                                 IDL_ATTRIB(in) long int line,
                                 IDL_ATTRIB(in) TriComponentId c,
                                 IDL_ATTRIB(in) TriTimerId timer,
                                 IDL_ATTRIB(in) TciNonValueTemplate timerTmpl);

/* tliTTimeout
 * 
 * Shall be called by TE to log a timeout match. This event occurs after a timeout matched.
*/
                                 
void T3TCI(tliTTimeout) (IDL_ATTRIB(in) String am,
                         IDL_ATTRIB(in) long int ts,
                         IDL_ATTRIB(in) String src,
                         IDL_ATTRIB(in) long int line,
                         IDL_ATTRIB(in) TriComponentId c,
                         IDL_ATTRIB(in) TriTimerId timer,
                         IDL_ATTRIB(in) TciNonValueTemplate timerTmpl);

/* tliTStart
 * 
 * Shall be called by PA to log the start of a timer. This event occurs after the start timer
 * operation.
*/
                         
void T3TCI(tliTStart) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c,
                       IDL_ATTRIB(in) TriTimerId timer,
                       IDL_ATTRIB(in) TriTimerDuration dur);

/* tliTStop
 * 
 * Shall be called by PA to log the stop of a timer. This event occurs after the stop timer operation.
*/
                       
void T3TCI(tliTStop) (IDL_ATTRIB(in) String am,
                      IDL_ATTRIB(in) long int ts,
                      IDL_ATTRIB(in) String src,
                      IDL_ATTRIB(in) long int line,
                      IDL_ATTRIB(in) TriComponentId c,
                      IDL_ATTRIB(in) TriTimerId timer,
                      IDL_ATTRIB(in) TriTimerDuration dur);

/* tliTRead
 * 
 * Shall be called by PA to log the reading of a timer. This event occurs after the read timer
 * operation.
*/
                      
void T3TCI(tliTRead) (IDL_ATTRIB(in) String am,
                      IDL_ATTRIB(in) long int ts,
                      IDL_ATTRIB(in) String src,
                      IDL_ATTRIB(in) long int line,
                      IDL_ATTRIB(in) TriComponentId c,
                      IDL_ATTRIB(in) TriTimerId timer,
                      IDL_ATTRIB(in) TriTimerDuration elapsed);

/* tliTRunning
 *
 * Shall be called by PA to log the running timer operation. This event occurs after the running timer
 * operation.
*/
                      
void T3TCI(tliTRunning) (IDL_ATTRIB(in) String am,
                         IDL_ATTRIB(in) long int ts,
                         IDL_ATTRIB(in) String src,
                         IDL_ATTRIB(in) long int line,
                         IDL_ATTRIB(in) TriComponentId c,
                         IDL_ATTRIB(in) TriTimerId timer,
                         IDL_ATTRIB(in) TimerStatus status);

/* tliSEnter
 *
 * Shall be called by TE to log the entering of a scope. This event occurs after the scoped has been
 * entered.
*/
                         
void T3TCI(tliSEnter) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c,
                       IDL_ATTRIB(in) QualifiedName name,
                       IDL_ATTRIB(in) TciParameterListType parsValue,
                       IDL_ATTRIB(in) String kind);

/* tliSLeave
 *
 * Shall be called by TE to log the leaving of a scope. This event occurs after the scoped has been
 * leaved.
*/
                       
void T3TCI(tliSLeave) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c,
                       IDL_ATTRIB(in) QualifiedName name,
                       IDL_ATTRIB(in) TciParameterListType parsValue,
                       IDL_ATTRIB(in) TciValue returnValue,
                       IDL_ATTRIB(in) String kind);

/* tliVar
 *
 * Shall be called by TE to log the modification of the value of a variable. This event occurs after the
 * values has been changed.
*/
                       
void T3TCI(tliVar) (IDL_ATTRIB(in) String am,
                    IDL_ATTRIB(in) long int ts,
                    IDL_ATTRIB(in) String src,
                    IDL_ATTRIB(in) long int line,
                    IDL_ATTRIB(in) TriComponentId c,
                    IDL_ATTRIB(in) QualifiedName name,
                    IDL_ATTRIB(in) TciValue varValue);

/* tliModulePar
 *
 * Shall be called by TE to log the value of a module parameter. This event occurs after the
 * access to the value of a module parameter.
*/
                    
void T3TCI(tliModulePar) (IDL_ATTRIB(in) String am,
                          IDL_ATTRIB(in) long int ts,
                          IDL_ATTRIB(in) String src,
                          IDL_ATTRIB(in) long int line,
                          IDL_ATTRIB(in) TriComponentId c,
                          IDL_ATTRIB(in) QualifiedName name,
                          IDL_ATTRIB(in) TciValue parValue);

/* tliGetVerdict
 *
 * Shall be called by TE to log the getverdict operation. This event occurs after the getverdict
 * operation.
*/
                          
void T3TCI(tliGetVerdict) (IDL_ATTRIB(in) String am,
                           IDL_ATTRIB(in) long int ts,
                           IDL_ATTRIB(in) String src,
                           IDL_ATTRIB(in) long int line,
                           IDL_ATTRIB(in) TriComponentId c,
                           IDL_ATTRIB(in) TciValue verdict);

/* tliSetVerdict
 *
 * Shall be called by TE to log the setverdict operation. This event occurs after the setverdict
 * operation.
*/
                           
void T3TCI(tliSetVerdict) (IDL_ATTRIB(in) String am,
                           IDL_ATTRIB(in) long int ts,
                           IDL_ATTRIB(in) String src,
                           IDL_ATTRIB(in) long int line,
                           IDL_ATTRIB(in) TriComponentId c,
                           IDL_ATTRIB(in) TciValue verdict);

/* tliLog
 *
 * Shall be called by TM to log the TTCN-3 statement log. This event occurs after the TTCN-3 log
 * operation.
*/

void T3TCI(tliLog) (IDL_ATTRIB(in) String am,
                    IDL_ATTRIB(in) long int ts,
                    IDL_ATTRIB(in) String src,
                    IDL_ATTRIB(in) long int line,
                    IDL_ATTRIB(in) TriComponentId c,
                    IDL_ATTRIB(in) String log);

/* tliAEnter
 *
 * Shall be called by TE to log entering an alt. This event occurs after an alt has been entered.
*/
                    
void T3TCI(tliAEnter) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c);

/* tliALeave
 *
 * Shall be called by TE to log leaving an alt. This event occurs after the alt has been leaved.
*/
                      
void T3TCI(tliALeave) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c);

/* tliADefaults
 *
 * Shall be called by TE to log entering the default section. This event occurs after the default
 * section has been entered.
*/
                       
void T3TCI(tliADefaults) (IDL_ATTRIB(in) String am,
                          IDL_ATTRIB(in) long int ts,
                          IDL_ATTRIB(in) String src,
                          IDL_ATTRIB(in) long int line,
                          IDL_ATTRIB(in) TriComponentId c);

/* tliAActivate
 *
 * Shall be called by TE to log the activation of a default. This event occurs after the default activation.
*/
                          
void T3TCI(tliAActivate) (IDL_ATTRIB(in) String am,
                          IDL_ATTRIB(in) long int ts,
                          IDL_ATTRIB(in) String src,
                          IDL_ATTRIB(in) long int line,
                          IDL_ATTRIB(in) TriComponentId c,
                          IDL_ATTRIB(in) QualifiedName name,
                          IDL_ATTRIB(in) TciParameterListType pars,
                          IDL_ATTRIB(in) TciValue ref);

/* tliADeactivate
 *
 * Shall be called by TE to log the deactivation of a default. This event occurs after the default
 * deactivation.
*/
                          
void T3TCI(tliADeactivate) (IDL_ATTRIB(in) String am,
                            IDL_ATTRIB(in) long int ts,
                            IDL_ATTRIB(in) String src,
                            IDL_ATTRIB(in) long int line,
                            IDL_ATTRIB(in) TriComponentId c,
                            IDL_ATTRIB(in) TciValue ref);

/* tliANomatch
 *
 * Shall be called by TE to log the nomatch of an alt. This event occurs after the alt has not matched.
*/
                            
void T3TCI(tliANomatch) (IDL_ATTRIB(in) String am,
                         IDL_ATTRIB(in) long int ts,
                         IDL_ATTRIB(in) String src,
                         IDL_ATTRIB(in) long int line,
                         IDL_ATTRIB(in) TriComponentId c);
                         
/* tliARepeat
 *
 * Shall be called by TE to log repeating an alt. This event occurs when the alt is been repeated.
*/
                         
void T3TCI(tliARepeat) (IDL_ATTRIB(in) String am,
                        IDL_ATTRIB(in) long int ts,
                        IDL_ATTRIB(in) String src,
                        IDL_ATTRIB(in) long int line,
                        IDL_ATTRIB(in) TriComponentId c);

/* tliAWait
 *
 * Shall be called by TE to log that the component awaits events for a new snapshot.
*/
                        
void T3TCI(tliAWait) (IDL_ATTRIB(in) String am,
                      IDL_ATTRIB(in) long int ts,
                      IDL_ATTRIB(in) String src,
                      IDL_ATTRIB(in) long int line,
                      IDL_ATTRIB(in) TriComponentId c);

/* tliAction
 *
 * Shall be called by TE to log that the component executed an SUT action.
*/
                        
void T3TCI(tliAction) (IDL_ATTRIB(in) String am,
                       IDL_ATTRIB(in) long int ts,
                       IDL_ATTRIB(in) String src,
                       IDL_ATTRIB(in) long int line,
                       IDL_ATTRIB(in) TriComponentId c,
                       IDL_ATTRIB(in) String action);

/* tliMatch
 *
 * Shall be called by TE to log that the component successfully executed a match operation.
*/
                        
void T3TCI(tliMatch) (IDL_ATTRIB(in) String am,
                      IDL_ATTRIB(in) long int ts,
                      IDL_ATTRIB(in) String src,
                      IDL_ATTRIB(in) long int line,
                      IDL_ATTRIB(in) TriComponentId c,
                      IDL_ATTRIB(in) TciValue expr,
                      IDL_ATTRIB(in) TciValueTemplate tmpl);

/* tliMatchMismatch
 *
 * Shall be called by TE to log that the component unsuccessfully executed a match operation - 
 * a mismatch occurred.
*/
                        
void T3TCI(tliMatchMismatch) (IDL_ATTRIB(in) String am,
                              IDL_ATTRIB(in) long int ts,
                              IDL_ATTRIB(in) String src,
                              IDL_ATTRIB(in) long int line,
                              IDL_ATTRIB(in) TriComponentId c,
                              IDL_ATTRIB(in) TciValue expr,
                              IDL_ATTRIB(in) TciValueTemplate tmpl,
                              IDL_ATTRIB(in) TciValueDifferenceList diffs);

/* tliInfo
 *
 * Can be called by TE to log additional information during test execution. 
 * This generation of this event is tool dependent as well as the usage of the parameters level and info.
*/
                        
void T3TCI(tliInfo) (IDL_ATTRIB(in) String am,
                     IDL_ATTRIB(in) long int ts,
                     IDL_ATTRIB(in) String src,
                     IDL_ATTRIB(in) long int line,
                     IDL_ATTRIB(in) TriComponentId c,
                     IDL_ATTRIB(in) long int level,
                     IDL_ATTRIB(in) String info);

#ifdef __cplusplus
}
#endif

#endif
