/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: tci_tm_provided.h
 *
 * Description:
 *      This file declares TCI TM provided functions
 */
 
#ifndef __tci_tm_provided_h
#define __tci_tm_provided_h

#ifdef __cplusplus
extern "C" {
#endif

#include "tci_conditional.h"


                                              /* TCI-TM operations provided to TE */

/* void tciTestCaseStarted (in TciTestCaseIdType testCaseId, in TciParameterListType parameterList, in Tfloat timer)	
 * tciTestCaseStarted indicates to the TM that a test case with testCaseId has been started. 
 * It will not be distinguished whether the test case has been started explicitly 
 * using the required operation tciStartTestCase or implicitly while executing the control part.
 *
 * Constraint: Shall only be called after either the control part of the module or a test case has been started 
 * using the required operations tciStartControl or tciStartTestCase.
*/
void T3TCI(tciTestCaseStarted) (IDL_ATTRIB(in) TciTestCaseIdType testCaseId, 
								IDL_ATTRIB(in) TciParameterListType parameterList, 
								IDL_ATTRIB(in) double timer);

/* void tciTestCaseTerminated (in VerdictValue verdict, in TciParameterListType parameterlist)	
 * This operation will be called by the TE to indicate the test management 
 * that the test case that has been currently executed on the MTC has terminated 
 * and that the final verdict was verdict. 
 * On the invocation of a tciTestCaseTerminated operation all out and inout test case parameters contain Values. 
 * All in test case parameters contain the distinct value of null 
 * because they are only of relevance to the test case start but not in the reply to the call.
 *
 * Constraint: Shall only be called after either the control part of the module or a test cases 
 * has been started using the required operations tciStartControl or tciStartTestCase.
*/
void T3TCI(tciTestCaseTerminated) (IDL_ATTRIB(in) TciValue verdict, 
								   IDL_ATTRIB(in) TciParameterListType parameterlist);

/* void tciControlTerminated()	
 * This operation will be called by the TE to indicate the test management that the control part 
 * of the selected module has just terminated execution.
 *
 * Constraint: Shall only be called when the module execution has been started using the tciStartControl operation.
*/
void T3TCI(tciControlTerminated) ();	

/* Value tciGetModulePar (in TciModuleParameterIdType parameterId)	
 * The management provides to the TE a Value for the indicated parameterId. 
 * Every call of tciGetModulePar() will return the same value throughout the execution 
 * of an explicitly started test case or throughout the execution of a control part 
 * If the management cannot provide a TTCN-3 value, the distinct null value shall be returned.
 *
 * Constraint: This operation shall be called whenever the TE needs to access the value of a module parameter. 
 * Every accessed module parameter will be resolved only once between a tciStartTestCase and tciTestCaseTerminated 
 * pair if a test case has been started explicitly or between a tciStartControl and tciControlTerminated pair 
 * if the control part of a module has been started.
*/
TciValue T3TCI(tciGetModulePar) (IDL_ATTRIB(in) TciModuleParameterIdType parameterId);

/* void tciError(in String message)	
 * The TE indicates the occurrence of an unrecoverable error situation. 
 * message contains a reason phrase that might be communicated to the test system user. 
 * It is up to the test management to terminate execution of test cases or control parts if running. 
 * The test management has to take explicit measures to terminate test execution immediately.
 *
 * Constraint: Can be called at any time by the TE to indicate an unrecoverable error situation. 
 * This error situation could either be indicated by the CH or the CD or could occur within the TE.
*/
void T3TCI(tciError) (IDL_ATTRIB(in) String message);	


#ifdef __cplusplus
}
#endif

#endif
