/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: tci_tm_required.h
 *
 * Description:
 *      This file declares TCI TM required functions
 */
 
#ifndef __tci_tm_required_h
#define __tci_tm_required_h

#ifdef __cplusplus
extern "C" {
#endif

#include "tci_conditional.h"

                                              /* TCI-TM operations required from TE */


/* void tciRootModule (in TciModuleIdType moduleId)	
 * tciRootModule selects the indicated module for execution through a subsequent call 
 * using tciStartTestCase or tciStartControl. A tciError will be issued by the TE if no such module exists.
 *
 * Constraint: Shall be used only if neither the control part nor a test case is currently being executed.
*/
void T3TCI(tciRootModule) (IDL_ATTRIB(in) String moduleId);

/* TciModuleIdListtype getImportedModules();
 * The TE provides to the management a list of imported modules of the root module. 
 * The modules are ordered as they appear in the TTCN-3 module.
 * If no imported module exist, an empty module list is returned. 
 * If the TE cannot provide a list, the distinct null value shall be returned. 
 * 
 * Constraint: Shall be used only if a root module has been set before.
*/
TciModuleIdListType T3TCI(tciGetImportedModules) ();


/* TciModuleParameterListType tciGetModuleParameters (in TciModuleIdType moduleName)	
 * The TE provides to the management a list of module parameters of the identified module. 
 * The parameters are ordered as they appear in the TTCN-3 module.
 * If no module parameters exist, an empty module parameter list is returned. 
 * If the TE cannot provide a list, the distinct null value shall be returned. 
 *
 * Constraint: Shall be used only if a root module has been set before.
*/
TciModuleParameterListType T3TCI(tciGetModuleParameters) (IDL_ATTRIB(in) TciModuleIdType moduleName);

/* TciTestCaseIdListType tciGetTestCases()	
 * The TE provides to the management a list of test cases 
 * that are either defined in or imported into the root module. 
 * If no test cases exist, an empty test case list is returned. 
 * If the TE cannot provide a list, the distinct null value shall be returned
 *
 * Constraint: Shall be used only if a root module has been set before.
*/
TciTestCaseIdListType T3TCI(tciGetTestCases) ();

/* TciParameterTypeListType tciGetTestCaseParameters(in TciTestCaseIdType testCaseId)	
 * The TE provides to the management a list of parameter types of the given test case. 
 * The parameter types are ordered as they appear in the TTCN-3 signature of the test case. 
 * If no test case parameters exist, an empty parameter type list is returned. 
 * If the TE cannot provide a list, the distinct null value shall be returned.
 *
 * Constraint: Shall be used only if a root module has been set before.
*/
TciParameterTypeListType T3TCI(tciGetTestCaseParameters) (IDL_ATTRIB(in) TciTestCaseIdType testCaseId);

/* TriPortIdListType tciGetTestCaseTSI(in TciTestCaseIdType testCaseId)	
 * The TE provides to the management a list of system ports of the given test case
 * that have been declared in the definition of the system component for the test case, i.e. the TSI ports. 
 * If a system component has not been explicitly defined for the test case, 
 * then the list contains all communication ports of the MTC test component. 
 * The ports are ordered as they appear in the respective TTCN-3 component type declaration.
 * If no system ports exist, an empty port list is returned. 
 * If the TE cannot provide a list, the distinct null value shall be returned.
 *
 * Constraint: Shall be used only if a root module has been set before.
*/
TriPortIdList T3TCI(tciGetTestCaseTSI) (IDL_ATTRIB(in) TciTestCaseIdType testCaseId);

/* void tciStartTestCase  (in TciTestCaseIdType testCaseId, in TciParameterListType parameterlist)	
 * tciStartTestCase starts a testcase in the currently selected module with the given parameters. 
 * A tciError will be issued by the TE if no such test case exists.
 * All in and inout test case parameters in parameterList contain Value. 
 * All out test case parameters in parameterList shall contain the distinct value of null 
 * since they are only of relevance when the test case terminates.
 *
 * Constraint: Shall be called only if a module has been selected before. 
 * Only testCaseIds for test cases that are declared in the currently selected TTCN-3 module shall be passed. 
 * Test cases that are imported in a referenced module can not be started. 
 * To start imported test cases the referenced (imported) module must be selected first using the tciRootModule operation
*/
void T3TCI(tciStartTestCase) (IDL_ATTRIB(in) TciTestCaseIdType testCaseId, 
							  IDL_ATTRIB(in) TciParameterListType parameterList);

/* void tciStopTestCase()	
 * tciStopTestCase stops the testcase currently being executed. 
 * If the TE is not executing a test case, the operation will be ignored. 
 * If the control part is being executed, tciStopTestCase will stop execution of the currently executed test case, 
 * i.e. the execution of the test case that has recently been indicated 
 * using the provided operation tciTestCaseStarted. 
 * A possible executing control part will continue execution as if the test case has stopped normally 
 * and returned with verdict ERROR.
 *
 * Constraint: Shall be called only if a module has been selected before.
*/
void T3TCI(tciStopTestCase) ();

/* TriComponentId tciStartControl()	
 * Starts the control part of the selected module. 
 * The control part will start TTCN-3 test cases as described in TTCN-3. 
 * While executing the control part the TE will call the provided operation tciTestCaseStarted and tciTestCaseTerminated 
 * for every test case that has been started and that has terminated. 
 * After termination of the control part the TE will call the provided operation tciControlPartTerminated
 *
 * Constraint: Shall be called only if a module has been selected before.
*/
TriComponentId T3TCI(tciStartControl) ();

/* void tciStopControl()	
 * tciStopControl stops execution of the control part. 
 * If no control part is currently being executed the operation will be ignored. 
 * If a test case has been started directly this will stop execution of the current test case as if tciStopTestCase 
 * has been called.
 *
 * Constraint: Shall only be called if a module has been selected before.
*/
void T3TCI(tciStopControl) ();	

/***************************************************************
*            IBM Rational proprietary TCI functions
***************************************************************/

/* 
 * TciModuleIdList tciGetModules()	
 * tciGetModules retrieves list of all modules defined in testsuite
 *
 * Constraint: None
*/
TciModuleIdListType T3TCI(tciGetModules) ();

/* 
 * TciTestCaseParameterIdListType tciGetTestCaseParametersNames()	
 * TciTestCaseParameterIdListType retrieves a list of 
 * formal testcase parameter names as defined in TTCN-3 ATS
 *
 * Constraint: None
*/
TciTestCaseParameterIdListType T3TCI(tciGetTestCaseParametersNames) (IDL_ATTRIB(in) TciTestCaseIdType testCaseId);

/* TciType tciGetModuleParameterType (in TciModuleParameterIdType modParId)	
 * The TE provides to the management type of the specified module parameter. 
 * This may be required if module parameter doesn't have default value
 * If the TE cannot provide type, the distinct null value shall be returned. 
 *
 * Constraint: Shall be used only if a root module has been set before.
 * Note: 
*/
TciType T3TCI(tciGetModuleParameterType) (IDL_ATTRIB(in) TciModuleParameterIdType modParId);



#ifdef __cplusplus
}
#endif

#endif
