/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: tci_tridata.h
 *
 * Description:
 *      This file declares TRI data structures
 */
 
#ifndef __tci_tridata_h
#define __tci_tridata_h

#ifdef __cplusplus
extern "C" {
#endif

#include "tci_conditional.h"

/*  data is a non-null-terminated string. 
 *  bits is the number of bits used in data. bits value -1 is used to denote omitted value.
 *	The aux field is for future extensibility of TRI functionality.
 */
typedef struct _BinaryString 
  {
    IDL_ATTRIB(size_is(bits)) /* actually size = (bits%8 == 0 ? bits/8 : bits/8 + 1) */
    unsigned char *data;
    long int bits;
    P_VOID aux;
  } BinaryString;


/* 	The moduleName and objectName fields are the TTCN-3 identifiers literally.
 *  The aux field is for future extensibility of TRI functionality.
 */
typedef struct _QualifiedName 
  {
    String moduleName;
    String objectName;
    P_VOID aux;
  } QualifiedName;


typedef BinaryString TriActionTemplate;

typedef BinaryString TriAddress;

typedef struct _TriAddressList
  {
    IDL_ATTRIB(size_is(length))
    TriAddress** addrList;
    long int length;
  } TriAddressList;

typedef BinaryString TriException;
typedef QualifiedName TriFunctionId;
typedef BinaryString TriMessage;
typedef QualifiedName TriSignatureId;
typedef QualifiedName TriTestCaseId;
typedef double TriTimerDuration;
typedef BinaryString TriTimerId; /* Note: Pending ETSI statement on timer
                                     and snapshot semantics may influence
                                     future representation! */

  
typedef long int TriStatus;
#define TRI_Error -1
#define TRI_OK     0 /* All negative values are reserved for future extension of TRI functionality.*/


/*compInst is for component instance.*/
typedef struct _TriComponentId 
  {
    BinaryString  compInst;
    String        compName;
    QualifiedName compType;
  } TriComponentId;

typedef struct _TriComponentIdList
  {
    IDL_ATTRIB(size_is(length))
    TriComponentId** compIdList;
    long int length;
  } TriComponentIdList;  

typedef enum 
  {
    TRI_IN,
    TRI_INOUT,
    TRI_OUT
  } TriParameterPassingMode;

typedef struct _TriParameter
  {
    BinaryString par;
    TriParameterPassingMode mode;
  } TriParameter;

/*  No special values mark the end of parList[]. The length field shall be used
 *  to traverse this array properly.
 */
typedef struct _TriParameterList 
  {
    IDL_ATTRIB(size_is(length))
    TriParameter **parList;
    long int length;
  } TriParameterList;


/*  compInst is for component instance. For a singular (non-array) declaration,
 *  the portIndex value should be -1. The aux field is for future extensibility
 *  of TRI functionality.
 */
typedef struct _TriPortId 
  {
    TriComponentId compInst;
    String portName;
    long int portIndex;
    QualifiedName  portType;
    P_VOID aux;
  } TriPortId;


/*  No special values mark the end of portIdList[]. The length field shall be
 *  used to traverse this array properly.
 */
typedef struct _TriPortIdList 
  {
    IDL_ATTRIB(size_is(length))
    TriPortId **portIdList;
    long int length;
  } TriPortIdList;

#ifdef __cplusplus
}
#endif

#endif

