/*************************************************************
Generated for IBM Rational Systems Tester 3.3.0.2.17499 at Tue Apr 27 05:07:51 PM MEST 2010
Licensed Materials - Property of IBM 
 Copyright IBM Corporation 2002,2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*---------------------------------------------------------------------------
 * File Name: tci_values.h
 *
 * Description:
 *      This file declares TCI functions used to process values
 */
 
#ifndef __tci_values_h
#define __tci_values_h

#ifdef __cplusplus
extern "C" {
#endif

#include "tci_conditional.h"

/***************************************************************
*   Generic TCI Value operations
*   Four operations defined in standard
***************************************************************/
/* 
 * Type getType()	
 * Returns the type of the specified value
*/
TciType T3TCI(tciGetType) (IDL_ATTRIB(in) TciValue inst);

/*
 * TBoolean notPresent()	
 * Returns true if the specified value is omit, false otherwise
*/
unsigned char T3TCI(tciNotPresent) (IDL_ATTRIB(in) TciValue inst);

/* 
 * TString getValueEncoding()	
 * Returns the value encoding attribute as defined in TTCN-3, if any. 
 * If no encoding attribute is defined the distinct value null is returned
*/
String T3TCI(tciGetValueEncoding) (IDL_ATTRIB(in) TciValue inst);

/* 
 * TString getValueEncodingVariant()	
 * Returns the value encoding variant attribute as defined in TTCN-3, if any. 
 * If no encoding variant attribute is defined the distinct value null is returned
*/
String T3TCI(tciGetValueEncodingVariant) (IDL_ATTRIB(in) TciValue inst);

/***************************************************************
*            The abstract data type IntegerValue
***************************************************************/
/* 
 * TInteger getInt()	
 * Returns the integer value of this TTCN-3 integer
 * IDL getInt() is implemented by the following four functions
*/

/* TString getIntAbs(in TciValue value)	
 * Returns the (10-base) integer absolute value as an ASCII string.
*/
String T3TCI(tciGetIntAbs) (IDL_ATTRIB(in) TciValue inst);

/* unsigned long int getIntNumberOfDigits(in TciValue value)
 * Returns the number of digits in an integer value.
*/
unsigned long int T3TCI(tciGetIntNumberOfDigits) (IDL_ATTRIB(in) TciValue inst);

/* TBoolean getIntSign(in TciValue value)
 * Returns true if the number is positive, false otherwise
*/
unsigned char T3TCI(tciGetIntSign) (IDL_ATTRIB(in) TciValue inst);

/* char getIntDigit(in Tcivalue value, in unsigned long int position)
 * Returns the value of the digit at position 'position', where position 0 is the least significant digit.
*/
unsigned char T3TCI(tciGetIntDigit) (IDL_ATTRIB(in) TciValue inst, 
									 IDL_ATTRIB(in) unsigned long int position);

/* void setInt(in TInteger value)	
 * Sets this IntegerValue to value
 * IDL setInt() is implemented by the following four functions
*/

/* void setIntAbs(inout TciValue inst, in char* value)
 * Sets the (10-base) absolute value of the integer via an ASCII string. 
 * The first digit must not be 0 unless the value is 0.
*/
void T3TCI(tciSetIntAbs) (IDL_ATTRIB(in) TciValue inst, 
						  IDL_ATTRIB(in) String value);

/* void setIntNumberOfDigits(inout TciValue inst, in unsigned long int dig_num);
 * Sets the number of digits in an integer value.
*/
void T3TCI(tciSetIntNumberOfDigits) (IDL_ATTRIB(in) TciValue inst, 
									 IDL_ATTRIB(in) unsigned long int dig_num);

/* void setIntSign(inout TciValue inst, in unsigned char sign);
 * Sets the sign to + (true) or - (false).
*/  
void T3TCI(tciSetIntSign) (IDL_ATTRIB(in) TciValue inst, 
						   IDL_ATTRIB(in) unsigned char sign);

/* void setIntDigit(inout TciValue inst, in unsigned long int position, in char digit);
 * Sets the value of the digit at position 'position', 
 * where position 0 is the least significant digit.
*/
void T3TCI(tciSetIntDigit) (IDL_ATTRIB(in) TciValue inst, 
							IDL_ATTRIB(in) unsigned long int position, 
							IDL_ATTRIB(in) unsigned char digit);

/***************************************************************
*            The abstract data type FloatValue
***************************************************************/
/* 
 * TFloat getFloat()
 * Returns the float value of this TTCN-3 float
*/
double T3TCI(tciGetFloatValue) (IDL_ATTRIB(in) TciValue inst);

/* void setFloat(in TFloat value)
 * Sets this FloatValue to value
*/
void T3TCI(tciSetFloatValue) (IDL_ATTRIB(in) TciValue inst, 
							  IDL_ATTRIB(in) double value);

/***************************************************************
*            The abstract data type BooleanValue
***************************************************************/
/* 
 * TBoolean getBoolean()
 * Returns the boolean value of the TTCN-3 boolean
*/
unsigned char T3TCI(tciGetBooleanValue) (IDL_ATTRIB(in) TciValue inst);

/* void setBoolean(in TBoolean value)
 * Sets this boolean value to value
*/
void T3TCI(tciSetBooleanValue) (IDL_ATTRIB(in) TciValue inst, 
								IDL_ATTRIB(in) unsigned char value);

/***************************************************************
*            The abstract data type ObjidValue
***************************************************************/
/* 
 * TObjid getObjid()
 * Returns the object id value of the TTCN-3 objid
*/
TciObjidValue T3TCI(tciGetTciObjidValue) (IDL_ATTRIB(in) TciValue inst);

/* void setObjid(in TObjid value)
 * Sets this ObjidValue to value
*/
void T3TCI(tciSetObjidValue) (IDL_ATTRIB(in) TciValue inst, 
							  IDL_ATTRIB(in) TciObjidValue value);

/***************************************************************
*            The abstract data type CharValue
***************************************************************/
/* 
 * TChar getChar()
 * Returns the char value of the TTCN-3 char
*/
unsigned char T3TCI(tciGetCharValue) (IDL_ATTRIB(in) TciValue inst);

/* void setChar(in TChar value)
 * Sets this CharValue to value
*/
void T3TCI(tciSetCharValue) (IDL_ATTRIB(in) TciValue inst, 
							 IDL_ATTRIB(in) unsigned char value);

/***************************************************************
*            The abstract data type UniversalCharValue
***************************************************************/
/* 
 * TUniversalChar getUniversalChar()
 * Returns the universal char value of the TTCN-3 universal char
*/
TciUCReturnValue T3TCI(tciGetUniversalCharValue) (IDL_ATTRIB(in) TciValue inst);

/* void setUniversalChar(in TUniversalChar value)
 * 	Sets this universal char value to value
*/
void T3TCI(tciSetUniversalCharValue) (IDL_ATTRIB(in) TciValue inst, 
									  IDL_ATTRIB(in) TciUCValue value);

/***************************************************************
*            The abstract data type CharstringValue
***************************************************************/
/* 
 * TString getString()
 * Returns the string value of the TTCN-3 charstring. 
 * The textual representation of the empty TTCN-3 charstring is '', 
 * while its length is zero
*/
TciCharStringValue T3TCI(tciGetCStringValue) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setString(in TString value)
 * Sets this CharstringValue to value
*/
void T3TCI(tciSetCStringValue) (IDL_ATTRIB(in) TciValue inst, 
								IDL_ATTRIB(in) TciCharStringValue value);

/* 
 * TChar getChar(in TInteger position)
 * Returns the char value of the TTCN-3 charstring at position. 
 * Position 0 denotes the first char of the TTCN-3 charstring. 
 * Valid values for position are from 0 to length - 1
*/
unsigned char T3TCI(tciGetCStringCharValue) (IDL_ATTRIB(in) TciValue inst, 
											 IDL_ATTRIB(in) unsigned long int position);

/* 
 * void setChar(in TInteger position, in TChar value)
 * Set the character at position to value. 
 * Valid values for position are from 0 to length - 1
*/
void T3TCI(tciSetCStringCharValue) (IDL_ATTRIB(in) TciValue inst, 
									IDL_ATTRIB(in) unsigned long int position, 
									IDL_ATTRIB(in) unsigned char value);

/* 
 * TInteger getLength()
 * Returns the length of this CharstringValue in chars, 
 * zero if the value of this CharstringValue is omit
*/
unsigned long int T3TCI(tciGetCStringLength) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setLength(in TInteger len)
 * setLength first resets this CharstringValue to its initial value 
 * and afterwards sets the length of this CharstringValue in chars to len
*/
void T3TCI(tciSetCStringLength) (IDL_ATTRIB(in) TciValue inst, 
								 IDL_ATTRIB(in) unsigned long int len);

/***************************************************************
*            The abstract data type UniversalCharstringValue
***************************************************************/
/* 
 * TString getString()
 * Returns the textual representation of this UniversalCharstringValue, 
 * as defined in TTCN-3
*/
TciUCStringValue T3TCI(tciGetUCStringValue) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setString(in TString value)
 * Sets the value of this UniversalCharstringValue according 
 * to the textual representation as defined by value
*/
void T3TCI(tciSetUCStringValue) (IDL_ATTRIB(in) TciValue inst, 
								 IDL_ATTRIB(in) TciUCStringValue value);

/* 
 * TUniversalChar getChar(in TInteger position)
 * Returns the universal char value of the TTCN-3 universal charstring at position. 
 * Position 0 denotes the first TUniversalChar of the TTCN-3 universal charstring. 
 * Valid values for position are from 0 to length - 1
*/
TciUCReturnValue T3TCI(tciGetUCStringCharValue) (IDL_ATTRIB(in) TciValue inst, 
												  IDL_ATTRIB(in) unsigned long int position);

/* 
 * void setChar(in TInteger position, in TUniversalChar value)
 * Sets the universal char at position to value. 
 * Valid values for position are from 0 to length - 1
*/
void T3TCI(tciSetUCStringCharValue) (IDL_ATTRIB(in) TciValue inst, 
									 IDL_ATTRIB(in) unsigned long int position, 
									 IDL_ATTRIB(in) TciUCValue value);

/* 
 * TInteger getLength()
 * Returns the length of this universal charstring value in universal chars, 
 * zero if the value of this universal charstring value is omit
*/
unsigned long int T3TCI(tciGetUCStringLength) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setLength(in TInteger len)
 * setLength first resets this UniversalCharstringValue to its initial value 
 * and afterwards sets the length of this UniversalCharstringValue in universal chars to len
*/
void T3TCI(tciSetUCStringLength) (IDL_ATTRIB(in) TciValue inst, 
								  IDL_ATTRIB(in) unsigned long int len);

/***************************************************************
*            The abstract data type BitstringValue
***************************************************************/
/* 
 * TString getString()
 * Returns the textual representation of this BitstringValue, 
 * as defined in TTCN-3. E.g. the textual representation of 0101 is "0101"B. 
 * The textual representation of the empty TTCN-3 bitstring is ""B, 
 * while its length is zero
*/
String T3TCI(tciGetBStringValue) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setString(in TString value)
 * Sets the value of this BitstringValue according to the textual representation 
 * as defined by value. E.g. the value of this BitstringValue is 0101 
 * if the textual representation in value is "0101"B
*/
void T3TCI(tciSetBStringValue) (IDL_ATTRIB(in) TciValue inst, 
								IDL_ATTRIB(in) String value);

/* 
 * TChar getBit(in TInteger position)
 * Returns the value (0 | 1) at position of this TTCN-3 bitstring as a character. 
 * Position 0 denotes the first bit of the TTCN-3 bitstring. 
 * Valid values for position are from 0 to length - 1
*/
long int T3TCI(tciGetBStringBitValue) (IDL_ATTRIB(in) TciValue inst, 
								  IDL_ATTRIB(in) unsigned long int position);

/* 
 * void setBit(in TInteger position, in TInteger value)
 * Sets the bit at position to the value (0 | 1). 
 * Position 0 denotes the first bit in this BitstringValue. 
 * Valid values for position are from 0 to length - 1
*/
void T3TCI(tciSetBStringBitValue) (IDL_ATTRIB(in) TciValue inst, 
								   IDL_ATTRIB(in) unsigned long int position, 
								   IDL_ATTRIB(in) long int value);

/* 
 * TInteger getLength()
 * Returns the length of this BitstringValue in bits, 
 * zero if the value of this BitstringValue is omit
*/
unsigned long int T3TCI(tciGetBStringLength) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setLength(in TInteger len)
 * setLength first resets this BitstringValue to its initial value 
 * and afterwards sets the length of this BitstringValue in bits to len
*/
void T3TCI(tciSetBStringLength) (IDL_ATTRIB(in) TciValue inst, 
								 IDL_ATTRIB(in) unsigned long int len);

/***************************************************************
*            The abstract data type OctetstringValue
***************************************************************/
/* 
 * TString getString()
 * Returns the textual representation of this OctetstringValue, 
 * as defined in TTCN-3. E.g. the textual representation of 0xCAFFEE is "CAFFEE"O. 
 * The textual representation of the empty TTCN-3 octetstring is ""O, 
 * while its length is zero
*/
String T3TCI(tciGetOStringValue) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setString(in TString value)
 * Sets the value of this OctetstringValue according to the textual representation 
 * as defined by value. E.g. The value of this OctetstringValue is 0xCAFFEE 
 * if the textual representation in value is "CAFFEE"O
*/
void T3TCI(tciSetOStringValue) (IDL_ATTRIB(in) TciValue inst, 
								IDL_ATTRIB(in) String value);

/* 
 * TChar getOctet(in TInteger position)
 * Returns the value (0..255) at position of this TTCN-3 octetstring. 
 * Position 0 denotes the first octet of the TTCN-3 octetstring. 
 * Valid values for position are from 0 to length - 1
*/
long int T3TCI(tciGetOStringOctetValue) (IDL_ATTRIB(in) TciValue inst, 
									IDL_ATTRIB(in) unsigned long int position);

/* 
 * void setOctet(in TInteger position, in TInteger value)
 * Sets the octet at position to value 0..255). 
 * Position 0 denotes the first octet in the octetstring. 
 * Valid values for position are from 0 to length - 1
*/
void T3TCI(tciSetOStringOctetValue) (IDL_ATTRIB(in) TciValue inst, 
									 IDL_ATTRIB(in) unsigned long int position, 
									 IDL_ATTRIB(in) long int value);

/* 
 * TInteger getLength()
 * Returns the length of this OctetstringValue in octets, 
 * zero if the value of this OctetstringValue is omit
*/
unsigned long int T3TCI(tciGetOStringLength) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setLength(in TInteger len)
 * setLength first resets this OctetstringValue to its initial value 
 * and afterwards sets the length of this OctetstringValue in octets to len
*/
void T3TCI(tciSetOStringLength) (IDL_ATTRIB(in) TciValue inst, 
								 IDL_ATTRIB(in) unsigned long int len);

/***************************************************************
*            The abstract data type HexstringValue
***************************************************************/
/* 
 * TString getString()
 * Returns the textual representation of this HexstringValue, 
 * as defined in TTCN-3. E.g. the textual representation of 0xAFFEE is "AFFEE"H. 
 * The textual representation of the empty TTCN-3 hexstring is ""H, 
 * while its length is zero
*/
String T3TCI(tciGetHStringValue) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setString(in TString value)
 * Sets the value of this HexstringValue according to the textual representation 
 * as defined by value. E.g. The value of this HexstringValue is 0xAFFEE 
 * if the textual representation in value is "AFFEE"H
*/
void T3TCI(tciSetHStringValue) (IDL_ATTRIB(in) TciValue inst, 
								IDL_ATTRIB(in) String value);

/* 
 * TChar getHex(in TInteger position)
 * Returns the value (0..15) at position of this TTCN-3 hexstring. 
 * Position 0 denotes the first hex digits of the TTCN-3 hexstring. 
 * Valid values for position are from 0 to length - 1
*/
long int T3TCI(tciGetHStringHexValue) (IDL_ATTRIB(in) TciValue inst, 
									   IDL_ATTRIB(in) unsigned long int position);

/* 
 * void setHex(in TInteger position, in TInteger value)
 * Sets the hex digit at position to value (0..15). 
 * Position 0 denotes the first octet in the hexstring. 
 * Valid values for position are from 0 to length - 1
*/
void T3TCI(tciSetHStringHexValue) (IDL_ATTRIB(in) TciValue inst, 
								   IDL_ATTRIB(in) unsigned long int position, 
								   IDL_ATTRIB(in) long int value);

/* 
 * TInteger getLength()
 * Returns the length of this HexstringValue in octets, 
 * zero if the value of this HexstringValue is omit
*/
unsigned long int T3TCI(tciGetHStringLength) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setLength(in TInteger len)
 * setLength first resets this HexstringValue to its initial value 
 * and afterwards sets the length of this HexstringValue in hex digits to len
*/
void T3TCI(tciSetHStringLength) (IDL_ATTRIB(in) TciValue inst, 
								 IDL_ATTRIB(in) unsigned long int len);

/***************************************************************
*            The abstract data type RecordValue (SetValue)
***************************************************************/
/* 
 * Value getField(in TString fieldName)
 * Returns the value of the field named fieldName. 
 * The return value is the common abstract base type Value, 
 * as a record field can have any type defined in TTCN-3. 
 * If the field can not be obtained from the record the distinct value null is returned
*/
TciValue T3TCI(tciGetRecFieldValue) (IDL_ATTRIB(in) TciValue inst, 
									 IDL_ATTRIB(in) String fieldName);

/* 
 * void setField(in TString fieldName, in Value value)
 * Sets the field named fieldName of the record to value. 
 * No assumption shall be made on how a field is stored in a record. 
 * An internal implementation might choose to store a reference to this value 
 * or to copy the value. It is safe to assume that the value is copied. 
 * Therefore it should be relied on that subsequent modifications of value 
 * will not be considered in the record
*/
void T3TCI(tciSetRecFieldValue) (IDL_ATTRIB(in) TciValue inst, 
								 IDL_ATTRIB(in) String fieldName, 
								 IDL_ATTRIB(in) TciValue value);

/* 
 * TStringSeq getFieldNames()
 * Returns a sequence of string of field names, 
 * the distinct value null, if the record has no fields
*/


IDL_ATTRIB(local)
String* T3TCI(tciGetRecFieldNames) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setFieldOmitted(in TciValue inst, TString fieldName)
 * Mark the referenced optional field of the record as being omitted.
*/

void T3TCI(tciSetFieldOmitted) (IDL_ATTRIB(in) TciValue inst, 
                                IDL_ATTRIB(in) String fieldName);

/***************************************************************
*            The abstract data type RecordOfValue (SetOfValue)
***************************************************************/
/* 
 * Value getField(in TInteger position)
 * Returns the value of the record of at position 
 * if position is between zero and length -1, the distinct value null otherwise. 
 * The return value is the common abstract base type Value, 
 * as a record of can have fields of any type defined in TTCN-3
*/
TciValue T3TCI(tciGetRecOfFieldValue) (IDL_ATTRIB(in) TciValue inst, 
									   IDL_ATTRIB(in) unsigned long int position);

/* 
 * void setField(in TInteger position, in Value value)
 * Sets the field at position to value. If position is greater than (length -1) 
 * the record of is extended to have the length (position + 1). 
 * The record of elements between the original position at length and position - 1 
 * is set to omit. No assumption shall be made on how a field is stored in a record of. 
 * An internal implementation might choose to store a reference to this value 
 * or to copy the value. It is safe to assume that the value is copied. 
 * Therefore, it should be relied on that subsequent modifications of value 
 * will not be considered in the record of
*/
void T3TCI(tciSetRecOfFieldValue) (IDL_ATTRIB(in) TciValue inst, 
								   IDL_ATTRIB(in) unsigned long int position, 
								   IDL_ATTRIB(in) TciValue value);

/* 
 * void appendField(in Value value)
 * Appends the value at the end of the record of, i.e. at position length. 
 * No assumption shall be made on how a field is stored in a record of. 
 * An internal implementation might choose to store a reference to this value 
 * or to copy the value. It is safe to assume that the value is copied. 
 * Therefore, it should be relied on that subsequent modifications of value 
 * will not be considered in the record of
*/
void T3TCI(tciAppendRecOfFieldValue) (IDL_ATTRIB(in) TciValue inst, 
									  IDL_ATTRIB(in) TciValue value);

/*
 * Type getElementType()
 * Returns the Type of the elements of this record of
*/
TciType T3TCI(tciGetRecOfElementType) (IDL_ATTRIB(in) TciValue inst);

/* 
 * TInteger getLength()
 * Returns the actual length of the record of value, 
 * zero if the record of value is omit
*/
unsigned long int T3TCI(tciGetRecOfLength) (IDL_ATTRIB(in) TciValue inst);

/*
 * void setLength(in TInteger len)
 * Sets the length of the record of to len. 
 * If len is greater than the original length, newly created elements have the value omit. 
 * If len is less than the original length record of is truncated to the new length
*/
void T3TCI(tciSetRecOfLength) (IDL_ATTRIB(in) TciValue inst, 
							   IDL_ATTRIB(in) unsigned long int len);

/***************************************************************
*            The abstract data type UnionValue
***************************************************************/
/* 
 * Value getVariant(in TString variantName)
 * Returns the value of the TTCN-3 union variantName.
 * If variantName is not equal the result of getPresentVariantName, 
 * new variant is set and freshly created value is returned.
*/
TciValue T3TCI(tciGetUnionVariant) (IDL_ATTRIB(in) TciValue inst, 
									IDL_ATTRIB(in) String variantName);

/* 
 * void setVariant(in TString variantName, in Value value)
 * Sets variantName of the union to value. 
 * If variantName is not defined for this union this operation is ignored. 
 * If another variant was selected the new variant is selected instead
*/
void T3TCI(tciSetUnionVariant) (IDL_ATTRIB(in) TciValue inst, 
								IDL_ATTRIB(in) String variantName, 
								IDL_ATTRIB(in) TciValue value);

/* 
 * TString getPresentVariantName()
 * Returns a String representing the currently selected variant name 
 * in the given TTCN-3 union. 
 * The distinct value null is returned if no variant is selected
*/
String T3TCI(tciGetUnionPresentVariantName) (IDL_ATTRIB(in) TciValue inst);

/* 
 * TStringSeq getVariantNames()
 * Returns a sequence of string of variant names, 
 * the distinct value null, if the union has no fields. 
 * If the UnionValue represents the TTCN-3 anytype, 
 * i.e. the type class of the type obtained by getType() is ANYTYPE, 
 * all predefined and user-defined TTCN-3 types is returned
*/


IDL_ATTRIB(local)
String* T3TCI(tciGetUnionVariantNames) (IDL_ATTRIB(in) TciValue inst);

/***************************************************************
*            The abstract data type EnumeratedValue
***************************************************************/
/* 
 * TString getEnum()
 * Returns the string identifier of this EnumeratedValue. 
 * This identifier equals the identifier in the TTCN-3 specification
*/
String T3TCI(tciGetEnumValue) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setEnum(in TString enumValue)
 * Sets the enum to enumValue. 
 * If enumValue is not an allowed value for this enumeration the operation is ignored
*/
void T3TCI(tciSetEnumValue) (IDL_ATTRIB(in) TciValue inst, 
							 IDL_ATTRIB(in) String enumValue);

/***************************************************************
*            The abstract data type VerdictValue
***************************************************************/
/* 
 * TInteger getVerdict()
 * Returns the integer value for this VerdictValue. 
 * The integer is one of the following constants: ERROR, FAIL, INCONC, NONE, PASS.
*/
TciVerdictValue T3TCI(tciGetVerdictValue) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setVerdict(in TInteger verdict)
 * Sets this VerdictValue to verdict. Note that a VerdictValue can be set 
 * to any of the above mentioned verdicts at any time. 
 * The VerdictValue does not perform any verdict calculations as defined in TTCN-3. 
 * For example, it is legal to set the VerdictValue first to ERROR and then to PASS. 
*/
void T3TCI(tciSetVerdictValue) (IDL_ATTRIB(in) TciValue inst, 
								IDL_ATTRIB(in) TciVerdictValue verdict);

/***************************************************************
*            The abstract data type AddressValue
***************************************************************/
/* 
 * TAddress getAddress()
 * Returns the address value, which will no longer be of type class ADDRESS 
 * but rather of the actual type used for address
*/
TciValue T3TCI(tciGetAddressValue) (IDL_ATTRIB(in) TciValue inst);

/* 
 * void setAddress(in TciValue value)
 * Sets this address value to value
*/
void T3TCI(tciSetAddressValue) (IDL_ATTRIB(in) TciValue inst, 
								IDL_ATTRIB(in) TciValue value);

								
/***************************************************************
*            IBM Rational proprietary TCI functions
***************************************************************/

/*
 * String tciGetCharstringValue(TciValue inst)
 * Returns zero terminated character string 
*/

String T3TCI(tciGetCharstringValue)(IDL_ATTRIB(in) TciValue inst);
  
/*
 * void tciSetCharstringValue (Tcivalue inst, String value)
 * Sets character string value with zero terminated character string 
*/

void T3TCI(tciSetCharstringValue)(IDL_ATTRIB(in) TciValue inst, IDL_ATTRIB(in) String value);


#ifdef __cplusplus
}
#endif
								
#endif
