/*---------------------------------------------------------------------------
 * File Name: example_communication.h
 *
 * 2010 IBM Corporation
 * 
 * Description:
 * 	   This is an example implementation of the communication part of the
 * Platform Layer.
 */


#ifndef __example_communication_h
#define __example_communication_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts.h"

#include "example_general.h"
#include "example_eventqueue.h"
#include "example_concurrency.h"

/* T3RTS_TRI_SECTION_START */
#ifdef T3PL_TRI
#include "t3tri.h"
#endif
/* T3RTS_TRI_SECTION_END */


typedef struct ex_port_repr_internal_t {
/* T3RTS_TRI_SECTION_START */
#ifdef T3PL_TRI
  TriPortId             triPortId;
#else
/* T3RTS_TRI_SECTION_END */
  char dummy;
/* T3RTS_TRI_SECTION_START */
#endif
/* T3RTS_TRI_SECTION_END */
} ex_port_repr_struct_t;



void
ex_communication_testcase_terminated(t3rt_context_t ctx);


void
ex_component_queue_put_call(ex_component_queue_t  comp_queue,
                            t3rt_binary_string_t  port_addr,
                            t3rt_type_t           signature_type,
                            t3rt_binary_string_t *parameters,
                            t3rt_binary_string_t  sender,
                            t3rt_context_t        ctx);

void 
ex_component_queue_put_reply(ex_component_queue_t  comp_queue,
                             t3rt_binary_string_t  port_addr,
                             t3rt_type_t           signature_type,
                             t3rt_binary_string_t *reply_data,
                             t3rt_binary_string_t  return_data,
                             t3rt_binary_string_t  sender,
                             t3rt_context_t        ctx);

void 
ex_component_queue_put_exception(ex_component_queue_t comp_queue,
                                 t3rt_binary_string_t port_addr,
                                 t3rt_type_t          signature_type,
                                 t3rt_binary_string_t exception_data,
                                 t3rt_binary_string_t sender,
                                 t3rt_context_t       ctx);

void 
ex_component_queue_put_message(ex_component_queue_t comp_queue,
                               t3rt_binary_string_t port_address,
                               t3rt_binary_string_t data,
                               t3rt_binary_string_t sender,
                               t3rt_context_t       ctx);

void 
ex_component_queue_put_timeout(ex_component_queue_t  comp_queue,
                               t3rt_timer_handle_t   timer_handle,
                               t3rt_context_t        ctx);


ex_port_t 
ex_find_reflected_port(ex_component_object_id_t pid, 
                       t3rt_context_t ctx);


#ifdef __cplusplus
}
#endif

#endif


/* End of File */

