/*---------------------------------------------------------------------------
 * File Name: example_time.h
 *
 * 2010 IBM Corporation
 *
 * Description:
 * 	   This is an example implementation of the time part of the
 * Platform Layer.
 */


#ifndef __example_time_h
#define __example_time_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3rts.h"


/* T3RTS_TRI_SECTION_START */

#ifdef T3PL_TRI

/* TRI Section */
#include "example_general.h"
#include "example_components.h" /* For 'ex_component_object_id_t' */
#include "t3tri.h"
#include "example_triutil.h"


#define EX_TRI_START_TIMER_FAILED   "triStartTimer failed!"
#define EX_TRI_STOP_TIMER_FAILED    "triStopTimer failed!"
#define EX_TRI_READ_TIMER_FAILED    "triReadTimer failed!"
#define EX_TRI_TIMER_RUNNING_FAILED "triTimerRunning failed!"

ex_component_object_id_t
ex_decode_timer_handle(const TriTimerId *timerId);


#endif /* T3PL_TRI */
/* T3RTS_TRI_SECTION_END */

double
ex_get_current_time (void);

double
ex_get_current_relative_time (void);


typedef struct ex_timer_repr_internal_t {
    t3rt_timer_state_t  state;
/* T3RTS_TRI_SECTION_START */
#ifdef T3PL_TRI
    double              duration;
    double              elapsed_time;
    BinaryString        tri_TimerId;
    /* The 'start_time' is not necessary but useful if the
       timer representation (timer_repr) is resued in PA impl: */
    double              start_time;
#else
/* T3RTS_TRI_SECTION_END */
    double              start_time;
    double              stop_time;
/* T3RTS_TRI_SECTION_START */
#endif
/* T3RTS_TRI_SECTION_END */
} ex_timer_repr_struct_t;

#ifdef __cplusplus
}
#endif

#endif

/* End of File */

