/*---------------------------------------------------------------------------
 * File Name: example_triutil.h
 *
 * 2010 IBM Corporation
 * 
 * Description:
 *     TRI utility functions
 */


#ifndef __example_triutil_h
#define __example_triutil_h

#ifdef __cplusplus
extern "C" {
#endif

#include "t3tri.h"
#include "t3rts.h"


t3rt_boolean_t
t3tri_componentId_is_equal(const TriComponentId *comp1,
                           const TriComponentId *comp2);

t3rt_boolean_t
t3tri_BinaryString_is_equal(const BinaryString *str1,
                            const BinaryString *str2);

/*
 * This function is only supposed to be called from within
 * the triPAReset, triSAReset or triExecuteTestcase functions.
 */
t3rt_context_t
t3tri_get_context();

void
clear_BinaryString(BinaryString *str,
                   t3rt_alloc_strategy_t strategy,
                   t3rt_context_t context);


/*
 * TRI constructors.
 */

QualifiedName *
tri__create_QualifiedName(const char* moduleName, const char* objectName,
                          void* aux, t3rt_alloc_strategy_t strategy,
                          QualifiedName *name, t3rt_context_t ctx);


void
tri__create_TriParameterList(long param_count,
                             t3rt_alloc_strategy_t strategy,
                             TriParameterList *parlist,
                             t3rt_context_t ctx);

void
tri__create_TriParameter(t3rt_binary_string_t enc_par,
                         t3rt_field_properties_t props,
                         t3rt_alloc_strategy_t strategy,
                         TriParameter *par,
                         t3rt_context_t ctx);



/*
 * TRI to T3 RTS conversions.
 */

BinaryString *
tri__t3_to_tri_BinaryString(t3rt_binary_string_t t3string,
                            t3rt_alloc_strategy_t strategy,
                            BinaryString *bstring,
                            t3rt_context_t ctx);


/*
 * T3 RTS to TRI conversions
 */

t3rt_binary_string_t
tri__tri_to_t3_binary_string(const BinaryString *tri_str,
                             t3rt_alloc_strategy_t strategy,
                             t3rt_context_t ctx);

#ifdef __cplusplus
}
#endif
                             
#endif

/* End of File */

