## DOORS - Tau Integration Customization Script
## IBM Corporation - 2010
## Use this script to customize the behaviour of the Generic Data Server
## NEVER MODIFY THE PROTOTYPE OF FUNCTIONS !
## NEVER REMOVE A FUNCTION
## CAUTION : AN ERROR IN THIS SCRIPT MAY CAUSE IBM RATIONAL SYSTEMS TESTER NOT TO WORK !

package require commands

Declare addcommand -variable cmdStartDOORS -name "Start DOORS" -statusmessage "Launch DOORS application" -tooltip "Start DOORS" -accelerator "Ctrl+Shift+D" -imagefile "Doors.bmp" -OnActivateCommand OnStartDOORS -OnEnableCommand OnEnableStartDOORS
Declare addcommand -variable cmdImportDOORS -name "Import from DOORS" -statusmessage "Import a DOORS formal module" -tooltip "Import a DOORS formal module" -accelerator "Ctrl+Shift+I" -imagefile "ImportDoors.bmp" -OnActivateCommand OnImportDOORS -OnEnableCommand OnEnableImportDOORS
Declare addcommand -variable cmdLocateInDOORS -name "Locate in DOORS" -statusmessage "Locate an element in DOORS" -tooltip "Locate an element in DOORS" -accelerator "Ctrl+Shift+L" -imagefile "LocateDoors.bmp" -OnActivateCommand OnLocateInDOORS -OnEnableCommand OnEnableLocateInDOORS
Declare addcommand -variable cmdExportDOORS -name "Export to DOORS" -statusmessage "Export a hierarchy to DOORS" -tooltip "Export a hierarchy to DOORS" -accelerator "Ctrl+Shift+X" -imagefile "ExportDoors.bmp" -OnActivateCommand OnExportDOORS -OnEnableCommand OnEnableExportDOORS

set TCheck 0
proc OnCheckDummy {command} {
    global TCheck
    return $TCheck
}

############################################################################
## DOORS Toolbar command handlers
set EnabledDOORS 1
proc OnEnableStartDOORS {command} {
    return 1
}

proc OnStartDOORS {command} {
    catch {Synchronizer start DOORS}
}

proc OnEnableImportDOORS {command} {
    global project
    foreach item $project {
        return 1
    }
    return 0
}

proc OnImportDOORS {command} {
    catch {Synchronizer import DOORS "" ""}
}

proc OnEnableLocateInDOORS {command} {
    global selection
    set result 0
    catch {Synchronizer canlocate DOORS $selection} result
    return $result
}

proc OnLocateInDOORS {command} {
    global selection
    catch {Synchronizer locate DOORS $selection}
}

proc OnEnableExportDOORS {command} {
    global selection
    set URL [GetModelUrl $selection]
    set result 0
    catch {Synchronizer canexport DOORS $URL} result
    return $result
}

proc OnExportDOORS {command} {
    global selection
    set URL [GetModelUrl $selection]
    catch {Synchronizer export DOORS $URL}
}

############################################################################

# Global Variables
global nDataModelImage
set nDataModelImage -1

global nHeadingImage
set nHeadingImage -1

global nReqImage
set nReqImage -1

global bInitImageDone
set bInitImageDone 0

proc InitImages {} {
    global bInitImageDone
    set bInitImageDone 1

    # Set the image for the datamodel in the file view
    global nDataModelImage
    set nDataModelImage [RegisterImage "BmpDoors.bmp"]

    # Set the image for heading object in the requirements tab
    global nHeadingImage
    set nHeadingImage [RegisterImage "Heading.bmp"]

    global nReqImage
    set nReqImage [RegisterImage "Requirement.bmp"]
}

proc OnActivateImageSyncOn {cmdName} {
    global selection U2
    foreach elem $selection {
	if {[u2::GetTaggedValue $elem "diagramImageExport (. .)"] == 0} {
	    set st [u2::FindByGuid [lindex $U2 0] "@TTDExport@diagramImageExport"]
	    set stIns [u2::CreateInstance $st]
	    u2::SetEntity $elem StereotypeInstance $stIns
	}
    }
}

proc OnActivateImageSyncOff {cmdName} {
    global selection
    foreach elem $selection {
	set tv [u2::GetTaggedValue $elem "diagramImageExport (. .)"]
	if {$tv != 0} {
	    catch { u2::Delete $tv }
	}
    }
}

proc OnEnableImageSyncOn {cmdName} {
    global selection
    if {[llength $selection] == 0} {
	return 0
    }

    if [ catch {
	foreach elem $selection {
	    if {![u2::IsKindOf $elem Diagram]} {
		return 0
	    }
	}
    }] {
	return 0
    }

    if {[llength $selection] != 1} {
        return 1
    }

    set elem [lindex $selection 0]
    if {[u2::GetTaggedValue $elem "diagramImageExport (. .)"] == 0} {
	return 1
    }

    return 0
}

proc OnEnableImageSyncOff {cmdName} {
    global selection
    if {[llength $selection] == 0} {
	return 0
    }

    if [ catch {
	foreach elem $selection {
	    if {![u2::IsKindOf $elem Diagram]} {
		return 0
	    }
	}
    }] {
	return 0
    }

    if {[llength $selection] != 1} {
        return 1
    }

    set elem [lindex $selection 0]
    if {[u2::GetTaggedValue $elem "diagramImageExport (. .)"] == 0} {
	return 0
    }

    return 1
}


proc OnActivateSyncOff {cmdName} {
    global selection U2
    foreach elem $selection {
	if {[u2::GetTaggedValue $elem "isExportDisabled (. .)"] == 0} {
	    set st [u2::FindByGuid [lindex $U2 0] "@TTDExport@isExportDisabled"]
	    set stIns [u2::CreateInstance $st]
	    u2::SetEntity $elem StereotypeInstance $stIns
	}
    }
}

proc OnActivateSyncOn {cmdName} {
    global selection
    foreach elem $selection {
	set tv [u2::GetTaggedValue $elem "isExportDisabled (. .)"]
	if {$tv != 0} {
	    catch { u2::Delete $tv }
	}
    }
}

proc OnEnableSyncOff {cmdName} {
    global selection
    if {[llength $selection] == 0} {
	return 0
    }

    if [ catch {
	foreach elem $selection {
	    if {![u2::IsKindOf $elem ModelElement]} {
		return 0
	    }
	}
    }] {
	return 0
    }

    if {[llength $selection] != 1} {
        return 1
    }

    set elem [lindex $selection 0]
    if {[u2::GetTaggedValue $elem "isExportDisabled (. .)"] == 0} {
	return 1
    }

    return 0
}

proc OnEnableSyncOn {cmdName} {
    global selection
    if {[llength $selection] == 0} {
	return 0
    }

    if [ catch {
	foreach elem $selection {
	    if {![u2::IsKindOf $elem ModelElement]} {
		return 0
	    }
	}
    }] {
	return 0
    }

    if {[llength $selection] != 1} {
        return 1
    }

    set elem [lindex $selection 0]
    if {[u2::GetTaggedValue $elem "isExportDisabled (. .)"] == 0} {
	return 0
    }

    return 1
}


# Initialize menus etc
proc Init {} {
    AddCommand cmdStartDOORS
    AddCommand cmdImportDOORS
    AddCommand cmdLocateInDOORS
    AddCommand cmdExportDOORS
    AddToolbar -variable "DOORS" -commands {cmdStartDOORS cmdImportDOORS cmdLocateInDOORS cmdExportDOORS}

    AddCommand -variable cmdImageSyncOnDOORS -name "Show diagram image in DOORS" -statusmessage "Show this diagram as an image in DOORS" -tooltip "Show diagram in DOORS" -imagefile "" -OnActivateCommand OnActivateImageSyncOn -OnEnableCommand OnEnableImageSyncOn
    AddCommand -variable cmdImageSyncOffDOORS -name "Do not show diagram image in DOORS" -statusmessage "Do not show this diagram as an image in DOORS" -tooltip "Do not show diagram in DOORS" -imagefile "" -OnActivateCommand OnActivateImageSyncOff -OnEnableCommand OnEnableImageSyncOff

    AddCommand -variable cmdSyncOnDOORS -name "Enable synchronization with DOORS" -statusmessage "Enables synchronization for this element with DOORS" -tooltip "Enable synchronization" -imagefile "" -OnActivateCommand OnActivateSyncOn -OnEnableCommand OnEnableSyncOn
    AddCommand -variable cmdSyncOffDOORS -name "Disable synchronization with DOORS" -statusmessage "Disables synchronization for this element with DOORS" -tooltip "Disable synchronization" -imagefile "" -OnActivateCommand OnActivateSyncOff -OnEnableCommand OnEnableSyncOff

    AddContextMenu -variable ctxMenu1 -commands { cmdImageSyncOnDOORS } -onenablemenu { OnEnableImageSyncOn }
    AddContextMenu -variable ctxMenu1 -commands { cmdImageSyncOffDOORS } -onenablemenu { OnEnableImageSyncOff }

    AddContextMenu -variable ctxMenu2 -commands { cmdSyncOnDOORS } -onenablemenu { OnEnableSyncOn }
    AddContextMenu -variable ctxMenu2 -commands { cmdSyncOffDOORS } -onenablemenu { OnEnableSyncOff }
}

# Returns the image for the datamodel in the file view
proc GetDataModelImage {} {
    global bInitImageDone
    if { $bInitImageDone == 0 } { InitImages }
    global nDataModelImage
    return $nDataModelImage
}

# Return 0 if you do not wish that your data server returns a doc template
proc NeedDocTemplate {} {
    return 1
}

proc GetFilterName {} {
	return "DOORS Integration Modules (*.dim)"
}

proc GetFilterExt {} {
	return ".dim"
}


# Return 0 if you do not wish that your extension returns a link server
proc NeedLinkServer {} {
    return 1
}

# Return 0 if you do not wish that your data server returns a browser
proc NeedBrowser {} {
    return 1
}

# Lists the instance types acceptable in the browser
proc CanInsertInBrowser {strInstanceType} {
    if {![string compare $strInstanceType "Requirement"]} {
        return 1
    }
    return 0
}

# Returns the icon to display in the browser tab
proc GetBrowserIcon {} {
    return "doors.ico"
}

proc GetDocumentIcon {} {
    return "doors.ico"
}

# DOORS View parameters

proc GetViewImage {} {
    return "ViewImage.bmp"
}

proc GetViewModifiedImage {} {
    return "ModViewImage.bmp"
}

proc GetViewColumns {} {
    return "Object Identifier:150;Object Heading/Text:500"
}

proc GetColumnOfAttribute {strAttribute} {
    if {![string compare $strAttribute "Object Heading"]} {
        return "Object Heading/Text"
    }

    if {![string compare $strAttribute "Object Text"]} {
        return "Object Heading/Text"
    }

    return ""
}

proc GetViewIdentification {} {
    return "DOORS View"
}

proc RepeatViewImage {} {
    return 1
}

proc GetViewLinkIndicatorColumn {} {
    return "Object Heading/Text"
}

proc GetViewImageColumn {} {
    return ""
}

proc GetSharedCommandServerIdent {} {
    return "DOORS Generic Command Server"
}

proc GetCouplingKind {} {
    return "DOORS"
}

proc GetCouplingName {} {
    return "DOORS"
}

proc GetLinkName {} {
    return "Traceability link"
}


proc IsHeading {strUid} {
	set heading [GetAttribute $strUid "Object Heading"]

    # differentiate heading and requirement
    if {[string compare $heading ""]} {
        return 1
    } else {
        return 0
    }
}

proc GetImage {strUid} {
    global bInitImageDone
    if { $bInitImageDone == 0 } { InitImages }

    global nHeadingImage
    global nReqImage

    set heading [GetAttribute $strUid "Object Heading"]

    # differentiate heading and requirement
    if {[string compare $heading ""]} {
        return $nHeadingImage
    } else {
        return $nReqImage
    }
}

proc GetInLinksIcon {} {
    return "InLink.ico"
}

proc GetOutLinksIcon {} {
    return "OutLink.ico"
}

proc GetInOutLinksIcon {} {
    return "InOutLink.ico"
}

proc GetAlternativeUrl {} {

}

proc GetObjectAttributes {} {
    return "Object Heading;Object Text;Absolute Number;Last Modified on;Object Short Text;Created By;Created On;Created Thru;Last Modified By"
}

Init
