#!/bin/sh
#
#   Telelogic AB
#
#   Copyright (c) 2005 by Telelogic AB.
#
# ##############################################################################
#   Telelogic AB	Please don't hesitate to contact Telelogic Customer
#                       Support if you have any questions or encountered any
#   Kungsgatan 6      	difficulties with this script.
#   203 12 Malmo        
# 
# ##############################################################################
#
#
# This installation procedure provide support to install the integration between Telelogic TAU G2 
# and Telelogic SYNERGY/CM on Unix.
# -----------------------------------------------------------------------------
#
#
#set -x
PATH=.:/bin:/usr/bin:/usr/ucb
export PATH

# Default-values
ECHO='echo'

case `uname -mr` in
  5*sun4*  	      )	hosttype=sunos5
	                HOSTTYPE=SUNOS5
			username=`/usr/ucb/whoami`
			flexdir=flex/sunos5flex
			ECHO='echo'
			hosttype2=sun4os5
			BINDIR=bin/sunos5 ;;
  2*i686  	      )	hosttype=linux
	                HOSTTYPE=LINUX
			username=`/usr/bin/whoami`
			flexdir=flex/linuxflex
			ECHO='echo -e'
			hosttype2=i86linux
			BINDIR=bin/linux ;;

esac

# ------------ Macro definitions of procedures -----------------
# Check entered answers default answer No
check_answer()
{
  case $answ in
    y*	) answ=1;;
    Y*	) answ=1;;
    n*	) answ=0;;
    N*	) answ=0;;
    x	) exit 0;;
    X	) exit 0;;
    ""	) answ=0;;
  esac
}
# Check entered answers default answer Yes
check_answer2()
{
  case $answ in
    y*	) answ=1;;
    Y*	) answ=1;;
    n*	) answ=0;;
    N*	) answ=0;;
    x	) exit 0;;
    X	) exit 0;;
    ""	) answ=1;;
  esac
}

read_answer() 
{
  answ=0
  read answ
  check_answer
}

read_answer_def_yes()
{
  answ=0
  read answ
  check_answer2
}

check_textansw()
{
  case $1 in
    x | X ) exit 0 ;;
    "" ) instdir=$CCM_HOME ;;
  esac
}


# Check the selected installation directory
check_installation_dir()
{
    # Check if specified path is a directory and that we have write privilege
    if [ ! -d "$instdir" ]; then
	$ECHO ""
	$ECHO ">>      Directory $instdir doesn't exist."
	$ECHO ">>      Exiting Installation without completion...."
	exit 0
    fi
}


# Ask for installation directory
ask_where_to_install()
{

  $ECHO ""
  $ECHO "        Installation Procedure TAU G2 Integration with SYNERGY/CM."
  $ECHO ""
  $ECHO "        Specify the existing directory path for your Telelogic SYNERGY/CM installation"
  $ECHO ">>      Enter path-name ($CCM_HOME): \c"
  read instdir
  check_textansw $instdir
  export instdir
}



update_regfile()
{
  touch tausyn.reg
  sed "s@\[SYNCM_DIR\]@$instdir@g" tausyn_template.reg >tausyn.reg
}


install_untar()
{
    TARCOM="$instdir/bin/util/ccm_tar xf"
    tardir=$PWD
    cd $instdir/etc
    su ccm_root -c "$TARCOM $tardir/tausyn.tar" 
    su ccm_root -c "chmod 755 -R com" 
}

check_user ()
{
    if [ ! $USER = "root" ]; then
	$ECHO ""
	$ECHO ">>      This script must be run as user root. Currently user $USER"
	$ECHO ">>      Exiting Installation without completion...."
	exit 0
    fi
	
}

# -------------------------  START of install procedure -----------------------

check_user

cd `dirname $0`

ask_where_to_install

check_installation_dir

update_regfile

install_untar


exit 0
